SystemOrganization addCategory: #'EyeSee-Core'!

!String methodsFor: '*eyesee-core' stamp: 'AndreHora 6/3/2011 12:52'!
displayStringOn: t1 at: t2 

	t1 displayString: self string at: t2.! !

Morph subclass: #ESCanvas
	instanceVariableNames: 'currentPosition lastClickPosition lastClickTimestamp announcer lastEnteredObject diagram'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EyeSee-Core'!

!ESCanvas class methodsFor: 'instance-creation' stamp: 'TudorGirba 4/17/2011 23:41'!
onDiagram: aDiagram
	^ self new 
		diagram: aDiagram;
		announcer: aDiagram announcer! !

!ESCanvas methodsFor: 'announce' stamp: 'AndreHora 4/13/2011 10:27'!
announce: anAnnouncement

	anAnnouncement element isNil ifFalse: [
		anAnnouncement element announcer announce: anAnnouncement ].
	
	self announcer announce: anAnnouncement.! !

!ESCanvas methodsFor: 'announce' stamp: 'TudorGirba 4/17/2011 23:42'!
announcer

	^ announcer ifNil: [announcer := ESAnnouncer new]! !

!ESCanvas methodsFor: 'announce' stamp: 'AndreHora 4/13/2011 13:03'!
announcer: aAnnouncer

	announcer := aAnnouncer! !

!ESCanvas methodsFor: 'accessing' stamp: 'AndreHora 3/19/2011 19:20'!
diagram
	^ diagram! !

!ESCanvas methodsFor: 'accessing' stamp: 'AndreHora 3/19/2011 19:20'!
diagram: aDiagram
	diagram := aDiagram! !

!ESCanvas methodsFor: 'error management' stamp: 'AndreHora 6/19/2011 17:12'!
disableErrorFlag
	Smalltalk removeKey: #EyeSeeError ifAbsent: []! !

!ESCanvas methodsFor: 'drawing' stamp: 'AndreHora 6/19/2011 17:12'!
drawOn: aCanvas 

	diagram displayOn: aCanvas
	
	! !

!ESCanvas methodsFor: 'export' stamp: 'AndreHora 12/9/2011 20:33'!
exportAsGIF

	^ self exportWith: GIFReadWriter extension: '.gif'! !

!ESCanvas methodsFor: 'export' stamp: 'AndreHora 12/9/2011 20:34'!
exportAsPNG

	^ self exportWith: PNGReadWriter extension: '.png'! !

!ESCanvas methodsFor: 'export' stamp: 'AndreHora 12/9/2011 20:51'!
exportWith: imageWriterClass extension: fileExtension

	| fName directoryName |
	
	fName := UIManager default 
		request:'Please enter the name' translated initialAnswer: self externalName, fileExtension.
	fName isEmptyOrNil ifTrue: [^ self].
	directoryName := UIManager default chooseDirectory: 'Choose a directory to store the image'.
	directoryName ifNil: [^ self ].
	"PNGReadWriter"
	imageWriterClass 
		putForm: self imageForm 
		onFileNamed: (directoryName pathName, FileDirectory pathNameDelimiter asString, fName).! !

!ESCanvas methodsFor: 'morph' stamp: 'AndreHora 12/9/2011 20:36'!
externalName

	^ 'EyeSee-', Date today yyyymmdd, '-', Time now hhmm24! !

!ESCanvas methodsFor: 'event handling' stamp: 'AndreHora 4/18/2011 21:58'!
handleMouseOver: anEvent
	
	self mouseOver: anEvent! !

!ESCanvas methodsFor: 'event handling' stamp: 'AndreHora 4/12/2011 17:27'!
handlesMouseDown: anEvent

	^ true! !

!ESCanvas methodsFor: 'event handling' stamp: 'AndreHora 4/12/2011 17:27'!
handlesMouseOver: anEvent

	^ true! !

!ESCanvas methodsFor: 'initialization' stamp: 'AndreHora 4/1/2011 16:28'!
initialize

	super initialize.
	currentPosition := 0@0.! !

!ESCanvas methodsFor: 'event handling' stamp: 'AndreHora 10/6/2011 11:03'!
mouseDown: anEvent 
	
	self announcer diagramRenderer ifNotNil: [
		| element |

		element := self diagram atPoint: anEvent position.
		lastEnteredObject := nil.
		element ifNil: [ ^ self ].
	
		self announce: (ESMouseDown 
			event: anEvent
			on: element).
	
		anEvent wasHandled: true.
	]! !

!ESCanvas methodsFor: 'event handling' stamp: 'AndreHora 4/18/2011 16:37'!
mouseOver: anEvent 

	self announcer diagramRenderer ifNotNil: [
		| elementUnderTheMouse |
	
		anEvent wasHandled ifTrue: [ ^ self ].
	
		currentPosition := anEvent position - self bounds origin.
		elementUnderTheMouse := self diagram atPoint: currentPosition.
	
		(elementUnderTheMouse ~~ lastEnteredObject)
			ifTrue: [ 
				lastEnteredObject 
					ifNotNil: [ self announce: (ESMouseLeave event: anEvent on: lastEnteredObject) ].
		  		elementUnderTheMouse 
					ifNotNil: [ self announce: (ESMouseEnter event: anEvent on: elementUnderTheMouse) ].
		  		lastEnteredObject := elementUnderTheMouse ].
	
		anEvent wasHandled: true.
	]! !

!ESCanvas methodsFor: 'event handling' stamp: 'AndreHora 6/19/2011 17:20'!
mouseUp: anEvent
	
	self announcer diagramRenderer ifNotNil: [
		| element |
		
		"If the lastEnteredGraphElement is not selected, then we select it since a mouse button is pressed"

		(lastEnteredObject notNil and: [ (lastEnteredObject isNotSelected)]) 
			ifTrue: [
	  			self announce: ( ESElementSelection 
					event: anEvent 
					on: lastEnteredObject).
	  			anEvent wasHandled: true.
	  			^ self  ].
		
		element := self diagram atPoint: anEvent position.
		element ifNil: [ ^ self ].
	
		self announce: (ESMouseUp
			event: anEvent
			on: element).
		anEvent wasHandled: true.
	]! !

!ESCanvas methodsFor: 'printing' stamp: 'TudorGirba 4/12/2011 10:35'!
printOn: stream
	stream nextPutAll: self class name.  
	stream nextPutAll: '<'.
	stream nextPutAll: self bounds printString.
	stream nextPutAll: '>'.! !

!ESCanvas methodsFor: 'error management' stamp: 'AndreHora 4/13/2011 21:51'!
raiseError: error
	| v |
	v := Smalltalk at: #EyeSeeError ifAbsentPut: [ true ].
	v ifFalse: [ ^ self ].
	self inform: error printString.
	Smalltalk at: #EyeSeeError put: false! !

!ESCanvas methodsFor: 'event handling' stamp: 'AndreHora 4/27/2011 14:54'!
selected: anElement 

	self diagram deselectAll.
	anElement ifNotNil: [anElement select ].
	self changed! !

!ESCanvas methodsFor: 'announce' stamp: 'AndreHora 4/13/2011 17:27'!
signalWindowSwitch
	"This method is called when the window in which I am embedded is moved to the back or to the front"
	
	"nil is provided since no mouse event is accessible (hooks need to be inserted into the Morphic framework, which is not trivial). However, the morphic mouse event is irrelevent here"
	lastEnteredObject 
		ifNotNil: [ self announce: (ESMouseLeave event: nil on: lastEnteredObject) ].
	lastEnteredObject := nil.! !

!ESCanvas methodsFor: 'action' stamp: 'AndreHora 3/15/2011 15:44'!
stopAllProcesses
	self root allNodesDo: [ :n | n interaction stopProcesses ].
	(Process allInstances select: [:p | p name = 'mondrian process' ])
		do: #terminate.! !

!ESCanvas methodsFor: 'action' stamp: 'AndreHora 4/13/2011 21:45'!
updateBounds

	"Scroll pane comes with its own bag of mysteries and tricks. "
	| scrollPane scrollPaneExtent |
	(owner isNil or: [ owner owner isNil]) 
		ifTrue: [ self extent: diagram bounds extent. ^ self ].
	

	scrollPane := owner owner.
	scrollPaneExtent := scrollPane bounds extent.

	scrollPane resizeScrollBars; resizeScroller; hideOrShowScrollBars.	
	scrollPane  vSetScrollDelta ; hSetScrollDelta.
	 self extent: diagram bounds extent.  
	

! !

ESCanvas subclass: #ESPopupViewCanvas
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EyeSee-Core'!

!PathShape methodsFor: '*eyesee-core' stamp: 'AndreHora 10/6/2011 23:41'!
displayFilledOn: t1 

	t1 displayPolygon: vertices! !

!PathShape methodsFor: '*eyesee-core' stamp: 'AndreHora 4/5/2011 13:59'!
displayStrokedOn: t1 

	t1 displayPolyline: vertices at: 0 @ 0.! !

!PathShape methodsFor: '*eyesee-core' stamp: 'AndreHora 6/5/2012 10:17'!
scaleBy: scale 
	"Answer a Rectangle translated by factor, a Point or a scalar."

	^ self class vertices: (self vertices collect: [ :each | each * scale])! !

!PathShape methodsFor: '*eyesee-core' stamp: 'AndreHora 6/5/2012 10:16'!
translateBy: factor 
	"Answer a PathShape translated by factor, a Point or a scalar."

	^ self class vertices: (self vertices collect: [ :each | each + factor])! !

!Dictionary class methodsFor: '*eyesee-core' stamp: ' 11/3/11 16:41'!
keys: keys values: aCollection
	
	| dict |
	dict := Dictionary new.	"if assertion fails, then there aren't enough values available to encode
	every value"
	[keys size <= aCollection size] assert.
	keys
		doWithIndex:
			[:each :i | 
			i <= aCollection size
				ifTrue:
					[dict
						at: each
						put: (aCollection at: i)]].
	^dict! !

!Color methodsFor: '*eyesee-core' stamp: 'AndreHora 3/18/2012 21:27'!
strongerAlpha

	^ self alpha: self alpha + 0.5! !

!LineSegment methodsFor: '*eyesee-core' stamp: 'AndreHora 4/5/2011 13:59'!
displayStrokedOn: t1 

	t1 displayLineFrom: start to: end.! !

Point subclass: #ESMatrixPoint
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EyeSee-Core'!

!ESMatrixPoint class methodsFor: 'instance creation' stamp: ' 11/3/11 16:41'!
i: anInteger j: anInteger2
	
	^self x: anInteger2 y: anInteger! !

!ESMatrixPoint methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
i
	
	^y! !

!ESMatrixPoint methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
i: anInteger
	
	y := anInteger! !

!ESMatrixPoint methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
j
	
	^x! !

!ESMatrixPoint methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
j: anInteger
	
	x := anInteger! !

!Point methodsFor: '*eyesee-core' stamp: ' 11/3/11 16:41'!
rotateBy: angle
	
	^(self x * angle cos - (self y * angle sin))
		@ (self x * angle sin + (self y * angle cos))! !

!Point methodsFor: '*eyesee-core' stamp: 'AndreHora 3/13/2011 14:16'!
scaledBy: t1

	^ self * t1! !

!Point methodsFor: '*eyesee-core' stamp: 'AndreHora 4/1/2012 20:06'!
translatedby: amount 

	^ self + amount! !

!Collection methodsFor: '*eyesee-core' stamp: 'AndreHora 12/4/2011 18:49'!
getMaxStringForFont: aFont
	
	| maxValue maxString currValue |
	"TODO: check the font style"
	self isEmpty ifTrue: [^ 0].
	maxValue := 0.
	maxString := self any.
	self
		do:
			[:each | 
			(currValue := each asStringMorph width) > maxValue
				ifTrue:
					[maxString := each.
					maxValue := currValue]].
	^ maxString! !

!Collection methodsFor: '*eyesee-core' stamp: 'AndreHora 12/4/2011 18:54'!
getMaxStringHeight
	
	self isEmpty ifTrue: [^0].
	^ (self collect: [:each | each asStringMorph height]) max! !

!Collection methodsFor: '*eyesee-core' stamp: 'AndreHora 12/4/2011 18:37'!
getMaxStringLength
	
	self isEmpty ifTrue: [^0].
	^ (self collect: [:each | each asStringMorph width]) max! !

!Collection methodsFor: '*eyesee-core' stamp: 'AndreHora 12/4/2011 18:40'!
getMaxStringLengthForFont: aFont
	
	"TODO: check the font style"
	^ self getMaxStringLength! !

!Collection methodsFor: '*eyesee-core' stamp: 'AndreHora 3/25/2011 15:21'!
lowerQuartile
	
	| size collection |
	size := self size.
	collection := self asSortedCollection: [ :a :b | a value < b value].
	^collection at: ((size + 1) * (1 / 4)) rounded! !

!Collection methodsFor: '*eyesee-core' stamp: 'AndreHora 3/25/2011 17:06'!
maxValue

	"andre added value"
	
	| maxValue |
	maxValue := 0.
	self do: [:each | each value > maxValue value ifTrue: [maxValue := each]].
	^maxValue! !

!Collection methodsFor: '*eyesee-core' stamp: 'AndreHora 4/5/2011 11:34'!
maximumValue: aBlock
	"Evaluate aBlock for element of the receiver, and return the largest result."

	^self inject: Float infinity negated into: [ :max :each | max max: (aBlock value: each) value ]! !

!Collection methodsFor: '*eyesee-core' stamp: 'AndreHora 3/25/2011 15:23'!
median2
	
	| size collection |
	size := self size.
	collection := self asSortedCollection: [ :a :b | a value < b value].
	size odd
		ifTrue: [^collection at: (size / 2) rounded]
		ifFalse:
			[| x1 x2 |
			x1 := collection at: size / 2.
			x2 := collection at: size / 2 + 1.
			^(x1 + x2) / 2]! !

!Collection methodsFor: '*eyesee-core' stamp: ' 11/3/11 16:41'!
mergeToPoints: aCollection
	
	| newList i |
	newList := OrderedCollection new.
	i := 1.
	self
		do:
			[:each | 
			newList add: each @ (aCollection at: i).
			i := i + 1].
	^newList! !

!Collection methodsFor: '*eyesee-core' stamp: 'AndreHora 4/11/2011 22:16'!
minValue

	"andre added value"
	
	| minValue |
	self notEmpty
		ifTrue:
			[minValue := self anyOne.
			self do: [:each | each value < minValue value ifTrue: [minValue := each]].
			^minValue]
		ifFalse: [^nil]! !

!Collection methodsFor: '*eyesee-core' stamp: 'AndreHora 4/5/2011 11:31'!
minValue: aBlock
	"Evaluate aBlock for element of the receiver, and return the least result."

	^self inject: Float infinity into: [ :min :each | min min: (aBlock value: each) value ]! !

!Collection methodsFor: '*eyesee-core' stamp: 'AndreHora 12/9/2011 21:13'!
openBarPlot
	
	"((1 to: 10) collect: #atRandom) openBarPlot"
	
	| diag |
	diag := ESDiagramRenderer new.
	(diag verticalBarDiagram)
		y: #value;
		defaultColor: Color black;
		axisColor: Color black;
		regularAxis;
		models: self.
	^ diag open! !

!Collection methodsFor: '*eyesee-core' stamp: 'AndreHora 12/9/2011 21:13'!
openPlot
	"This method assumes that only numerical values are contained in the collection.
	It plots all the values. The upper and lower bounds are automatically determined"
	
	"((1 to: 10) collect: #atRandom) openPlot"

	| diag |
	diag := ESDiagramRenderer new.
	(diag lineDiagram)
		y: #value;
		defaultColor: Color black;
		hideDots;
		axisColor: Color black;
		regularAxis;
		models: self.
	^ diag open! !

!Collection methodsFor: '*eyesee-core' stamp: 'AndreHora 12/9/2011 21:50'!
openPlotWith: aCollection
	"Draw two curves, the receiver and the one provided as argument. The receiving collection is drawn in red, the argument in black"

	"((1 to: 10) collect: #atRandom) openPlotWith: ((100 to: 200) collect: #atRandom)"
	
	| diag diag0 diag3 |
	diag := (ESDiagramRenderer new lineDiagram)
		y: #value;
		defaultColor: Color red;
		hideDots;
		axisColor: Color red;
		regularAxis;
		models: self;
		yourself.
	diag0 := (ESDiagramRenderer new lineDiagram)
		y: #value;
		defaultColor: Color black;
		hideDots;
		axisColor: Color black;
		rightYAxis;
		regularAxis;
		models: aCollection;
		yourself.
	diag3 := ESDiagramRenderer new.
	(diag3 compositeDiagram)
		add: diag;
		add: diag0;
		width: 300;
		height: 250.
	^ diag3 open! !

!Collection methodsFor: '*eyesee-core' stamp: 'AlexandreBergel 12/8/2011 12:52'!
openScatterPlot
	"This method assumes that only instance of Point are contained in the collection.
	It plots all the points using a scatterplot. The upper and lower bounds are automatically determined"
	
	" {1@3 . 5@6 . 3@6} openScatterPlot"

	| diag |
	diag := ESDiagramRenderer new.
	(diag scatterplot)
		y: [:each | each value y];
		x: [:each | each value x];
		axisColor: "#black" Color black;
		baseAxisLine;
		crosses;
		axisPadding;
		strokedShapes;
		valueAxis;
		models: self.	"lineColor: #black;"	"fillColor: #white;"
	^ diag open! !

!Collection methodsFor: '*eyesee-core' stamp: ' 11/3/11 16:41'!
removeDuplicates
	
	| newCollection |
	newCollection := OrderedCollection new.
	self
		do:
			[:each | (newCollection includes: each) ifFalse: [newCollection add: each]].
	^newCollection! !

!Collection methodsFor: '*eyesee-core' stamp: ' 11/3/11 16:41'!
sumUp: aCollection
	"sums the values of 2 collections of equal length asuming that alle elements understand + and retruns the collection with the sums"
	
	| temp |
	temp := OrderedCollection new.
	[self size = aCollection size] assert.
	1
		to: self size
		do: [:index | temp add: (self at: index) + (aCollection at: index)].
	^temp! !

!Collection methodsFor: '*eyesee-core' stamp: 'AndreHora 3/25/2011 15:22'!
upperQuartile
	
	| size collection |
	size := self size.
	collection := self asSortedCollection: [ :a :b | a value < b value].
	^collection at: ((size + 1) * (3 / 4)) rounded! !

!Rectangle methodsFor: '*eyesee-core' stamp: 'AndreHora 4/5/2011 14:00'!
displayFilledOn: t1 

	t1 displayRectangle: self.! !

!Rectangle methodsFor: '*eyesee-core' stamp: 'AndreHora 4/5/2011 14:00'!
displayStrokedOn: t1 

	t1 displayRectangularBorder: self.! !

!Rectangle methodsFor: '*eyesee-core' stamp: 'AndreHora 4/5/2011 14:00'!
expandRectangle: t1 

	^t1 species origin: t1 origin - origin corner: t1 corner + corner! !

!Rectangle methodsFor: '*eyesee-core' stamp: 'AndreHora 4/5/2011 14:01'!
moveBy: t1 

	origin := origin + t1.
	corner := corner + t1.! !

!Integer methodsFor: '*eyesee-core' stamp: ' 11/3/11 16:41'!
matrixPointWith: anInteger
	
	^MatrixPoint i: self j: anInteger! !

!Integer methodsFor: '*eyesee-core' stamp: ' 11/3/11 16:41'!
toLast10
	
	^(self / 10 asFloat) floor * 10! !

!Integer methodsFor: '*eyesee-core' stamp: ' 11/3/11 16:41'!
toNext10
	
	^(self / 10 asFloat) ceiling * 10! !

!Number methodsFor: '*eyesee-core' stamp: 'AlexandreBergel 12/9/2011 10:57'!
asTruncatedFloat
	"Return a float with only two decimal
	(1/3) asTruncatedFloat =>  0.33 
	"

	^ (((self * 100) truncated) / 100 ) asFloat! !

!Circle methodsFor: '*eyesee-core' stamp: 'AndreHora 4/5/2011 13:56'!
displayFilledOn: t1 

	| t2 t3 t4 t5 |
	t4 := radius rounded.
	t2 := center x rounded.
	t3 := center y rounded.
	t5 := t4 + t4.
	t1
		displayWedgeBBoxOrigin: t2 - t4 @ (t3 - t4)
		extent: t5 @ t5
		startAngle: 0.0
		sweepAngle: 360.0.! !

!Circle methodsFor: '*eyesee-core' stamp: 'AndreHora 4/5/2011 13:56'!
displayStrokedOn: t1 

	| t2 t3 t4 t5 |
	t4 := radius rounded.
	t2 := center x rounded.
	t3 := center y rounded.
	t5 := t4 + t4.
	t1
		displayArcBBoxOrigin: t2 - t4 @ (t3 - t4)
		extent: t5 @ t5
		startAngle: 0.0
		sweepAngle: 360.0.! !

Object subclass: #ESAbstractAxisPositionStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EyeSee-Core'!

!ESAbstractAxisPositionStrategy methodsFor: 'changing' stamp: ' 11/3/11 16:41'!
setBorders: aDiagram
	
	self subclassResponsibility! !

!ESAbstractAxisPositionStrategy methodsFor: 'changing' stamp: ' 11/3/11 16:41'!
setLabelDistanceFromAxisCalculation: aDiagram
	
	self subclassResponsibility! !

!ESAbstractAxisPositionStrategy methodsFor: 'changing' stamp: ' 11/3/11 16:41'!
setLabelPointCalculation: aDiagram
	
	self subclassResponsibility! !

ESAbstractAxisPositionStrategy subclass: #ESXAxisStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EyeSee-Core'!

ESXAxisStrategy subclass: #ESBottomAxisStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EyeSee-Core'!

!ESBottomAxisStrategy methodsFor: 'displaying' stamp: 'AndreHora 12/5/2011 12:26'!
getDeviationDescriptionLabel: aDiagram
	
	| offset |

	offset := (aDiagram deviationValue - aDiagram xAxis minValue)
		* aDiagram xAxis scaleFactor.
	^(ESTextLabel new)
		text: aDiagram deviationDescription;
		origin: offset @ (aDiagram contentHeight + 10)! !

!ESBottomAxisStrategy methodsFor: 'changing' stamp: ' 11/3/11 16:41'!
setBorders: aDiagram
	
	aDiagram xAxis rotatedLabels
		ifTrue:
			[aDiagram
				lowerBorder:
					(aDiagram lowerBorder
						max:
							aDiagram xAxis labelDistanceFromAxis + aDiagram xAxis getMaxLenghtOfLabel)]
		ifFalse:
			[aDiagram lowerBorder: (aDiagram lowerBorder max: aDiagram xAxis height)].
	aDiagram xDeviationValue
		ifNotNil:
			[aDiagram
				upperBorder:
					(aDiagram upperBorder
						max: aDiagram defaultFontSize + aDiagram yAxis labelDistanceFromAxis)]! !

!ESBottomAxisStrategy methodsFor: 'changing' stamp: 'AndreHora 3/28/2011 15:35'!
setLabelDistanceFromAxisCalculation: aDiagram
	
	aDiagram xAxis
		labelDistanceBlock:
			[:each | 
			aDiagram xAxis rotatedLabels
				ifTrue:
					[(aDiagram xAxis labelDistanceFromAxis + aDiagram contentTranslation y abs) negated "added the negated invoc"]
				ifFalse:
					[(aDiagram axisFontSize + aDiagram xAxis labelDistanceFromAxis
						+ aDiagram contentTranslation y abs) negated "added the negated invoc"]]! !

!ESBottomAxisStrategy methodsFor: 'changing' stamp: 'AndreHora 3/28/2011 14:59'!
setLabelPointCalculation: aDiagram
	
	aDiagram xAxis
		labelPointCalculationBlock:
			[:aPoint :labelString | 
			| length shorterLength |
			length := 0 asPoint dist: aPoint.
			aDiagram xAxis rotatedLabels
				ifTrue:
					[shorterLength := length - aDiagram axisFontSize.
					aPoint scaledBy: shorterLength / length]
				ifFalse: [aPoint scaledBy: (length - labelString "asString" "size" width "andre") / length]]! !

ESXAxisStrategy subclass: #ESTopAxisStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EyeSee-Core'!

!ESTopAxisStrategy methodsFor: 'displaying' stamp: 'AndreHora 12/5/2011 12:26'!
getDeviationDescriptionLabel: aDiagram
	
	| offset |

	offset := (aDiagram deviationValue - aDiagram xAxis minValue)
		* aDiagram xAxis scaleFactor.
	^(ESTextLabel new)
		text: aDiagram deviationDescription;
		origin: offset @ 10 negated! !

!ESTopAxisStrategy methodsFor: 'changing' stamp: ' 11/3/11 16:41'!
setBorders: aDiagram
	
	aDiagram xAxis rotatedLabels
		ifTrue:
			[aDiagram
				upperBorder:
					(aDiagram upperBorder
						max:
							aDiagram xAxis labelDistanceFromAxis + aDiagram xAxis getMaxLenghtOfLabel)]
		ifFalse:
			[aDiagram xAxis values
				ifNotNil:
					[aDiagram
						upperBorder:
							(aDiagram upperBorder
								max: aDiagram xAxis labelDistanceFromAxis + aDiagram axisFontSize)]].
	aDiagram xDeviationValue
		ifNotNil:
			[aDiagram
				lowerBorder:
					(aDiagram lowerBorder
						max: aDiagram defaultFontSize + aDiagram yAxis labelDistanceFromAxis)]! !

!ESTopAxisStrategy methodsFor: 'changing' stamp: ' 11/3/11 16:41'!
setLabelDistanceFromAxisCalculation: aDiagram
	
	| labelDistance |
	aDiagram xAxis
		labelDistanceBlock:
			[:each | 
			labelDistance := aDiagram labelDistance isNil
				ifTrue: [aDiagram xAxis labelDistanceFromAxis]
				ifFalse: [aDiagram labelDistance].
			aDiagram xAxis rotatedLabels
				ifTrue: [labelDistance := labelDistance + each height].
			labelDistance]! !

!ESTopAxisStrategy methodsFor: 'changing' stamp: 'AndreHora 3/29/2011 17:00'!
setLabelPointCalculation: aDiagram
	
	aDiagram xAxis
		labelPointCalculationBlock:
			[:aPoint :aLabelString | 
			| length shorterLength |
			length := 0 asPoint dist: aPoint.
			aDiagram xAxis rotatedLabels
				ifTrue:
					[shorterLength := length - aDiagram axisFontSize.
					aPoint scaledBy: shorterLength / length]
				ifFalse:
					[aPoint
						scaledBy:
							(length
								- 0)
									"((TextMeasurer
										defaultWidthOfString: aLabelString text
										font: aDiagram getDefaultFont) / 2)) / length" "andre TODO"]]! !

!ESXAxisStrategy methodsFor: 'displaying' stamp: ' 11/3/11 16:41'!
getDeviationLine: aDiagram
	
	| offset |
	offset := (aDiagram deviationValue - aDiagram xAxis minValue)
		* aDiagram xAxis scaleFactor.
	^LineSegment
		from: offset @ 0
		to: offset @ aDiagram contentHeight! !

!ESXAxisStrategy methodsFor: 'changing' stamp: ' 11/3/11 16:41'!
setBorders: aDiagram
	
	self subclassResponsibility! !

!ESXAxisStrategy methodsFor: 'changing' stamp: ' 11/3/11 16:41'!
setLabelDistanceFromAxisCalculation: aDiagram
	
	self subclassResponsibility! !

!ESXAxisStrategy methodsFor: 'changing' stamp: ' 11/3/11 16:41'!
setLabelPointCalculation: aDiagram
	
	self subclassResponsibility! !

!ESXAxisStrategy methodsFor: 'changing' stamp: 'AndreHora 4/11/2011 22:32'!
setRotatedLabels: aDiagram
	"TODO"
	"| noOfValues |
	aDiagram xAxis values
		ifNotNil:
			[noOfValues := aDiagram xAxis values size.
			(aDiagram xAxis values collect: aDiagram xAxis labelRepresentation)
				do:
					[:each | 
					(TextMeasurer
						defaultWidthOfString: each asString
						font: aDiagram getDefaultFont) > (aDiagram contentWidth / noOfValues)
						ifTrue:
							[aDiagram xAxis rotatedLabels: true.
							aDiagram rotatedLabels: true]]]"! !

ESAbstractAxisPositionStrategy subclass: #ESYAxisStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EyeSee-Core'!

ESYAxisStrategy subclass: #ESLeftAxisStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EyeSee-Core'!

!ESLeftAxisStrategy methodsFor: 'displaying' stamp: 'AndreHora 12/5/2011 12:17'!
getDeviationDescriptionLabel: aDiagram
	
	| offset |

	offset := (aDiagram deviationValue - aDiagram yAxis minValue)
		* aDiagram yAxis scaleFactor.
	^(ESTextLabel new)
		text: aDiagram deviationDescription;
		origin:
				(aDiagram contentWidth + (aDiagram yAxis labelDistanceFromAxis / 2))
						@ (offset - (aDiagram defaultFontSize / 2))

"	| offset |
	offset := (aDiagram deviationValue - aDiagram yAxis minValue)
		* aDiagram yAxis scaleFactor.
	^(ESTextLabel new)
		text: aDiagram deviationDescription asString;
		origin:
			(aDiagram contentWidth + (aDiagram yAxis labelDistanceFromAxis / 2) negated )
						@ (offset - (aDiagram defaultFontSize / 2))"! !

!ESLeftAxisStrategy methodsFor: 'changing' stamp: 'AndreHora 12/5/2011 15:24'!
setBorders: aDiagram

	aDiagram
		leftBorder:
			(aDiagram leftBorder
				max:
					aDiagram yAxis labelDistanceFromAxis + aDiagram yAxis getMaxLenghtOfLabel).

	aDiagram yDeviationValue
		ifNotNil:
			[aDiagram
				rightBorder:
					(aDiagram rightBorder
						max:
							(aDiagram yDeviationDescription asStringMorph width)
								+ aDiagram yAxis labelDistanceFromAxis)]! !

!ESLeftAxisStrategy methodsFor: 'changing' stamp: 'AndreHora 6/17/2011 15:49'!
setLabelDistanceFromAxisCalculation: aDiagram
	
	aDiagram yAxis
		labelDistanceBlock:
			[:each | (aDiagram yAxis labelDistanceFromAxis + each width) "negated" ]! !

!ESLeftAxisStrategy methodsFor: 'changing' stamp: 'AndreHora 7/5/2011 17:06'!
setLabelPointCalculation: aDiagram
	
	aDiagram yAxis
		labelPointCalculationBlock:
			[:aPoint :aLabelString | 
			| length shorterLength |
			length := 0 asPoint dist: aPoint.
			shorterLength := length - (aDiagram scale y * aDiagram axisFontSize).
			aPoint scaledBy: shorterLength / length]! !

ESYAxisStrategy subclass: #ESRightAxisStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EyeSee-Core'!

!ESRightAxisStrategy methodsFor: 'displaying' stamp: 'AndreHora 12/5/2011 12:26'!
getDeviationDescriptionLabel: aDiagram
	"TODO"
"	| offset |
	offset := (aDiagram deviationValue - aDiagram yAxis minValue)
		* aDiagram yAxis scaleFactor.
	^(ESTextLabel new)
		text: aDiagram deviationDescription asString;
		origin:
				((TextMeasurer
						defaultWidthOfString: aDiagram deviationDescription
						font: aDiagram getDefaultFont)
						+ (aDiagram yAxis labelDistanceFromAxis / 2)) negated
						@ (offset - (aDiagram defaultFontSize / 2))"

	| offset |

	offset := (aDiagram deviationValue - aDiagram yAxis minValue)
		* aDiagram yAxis scaleFactor.
	^(ESTextLabel new)
		text: aDiagram deviationDescription asString;
		origin:
			(aDiagram contentWidth + (aDiagram yAxis labelDistanceFromAxis / 2) negated )
						@ (offset - (aDiagram defaultFontSize / 2))! !

!ESRightAxisStrategy methodsFor: 'changing' stamp: 'AndreHora 12/5/2011 15:24'!
setBorders: aDiagram

	aDiagram
		rightBorder:
			(aDiagram rightBorder
				max:
					aDiagram yAxis labelDistanceFromAxis + aDiagram yAxis getMaxLenghtOfLabel).
	aDiagram yDeviationValue
		ifNotNil:
			[aDiagram
				leftBorder:
					(aDiagram leftBorder
						max:
							(aDiagram yDeviationDescription asStringMorph width)
								+ aDiagram yAxis labelDistanceFromAxis)]! !

!ESRightAxisStrategy methodsFor: 'changing' stamp: 'AndreHora 6/17/2011 15:51'!
setLabelDistanceFromAxisCalculation: aDiagram
	
	aDiagram yAxis
		labelDistanceBlock:
			[:each | aDiagram yAxis labelDistanceFromAxis ]! !

!ESRightAxisStrategy methodsFor: 'changing' stamp: 'AndreHora 7/5/2011 17:06'!
setLabelPointCalculation: aDiagram
	
	aDiagram yAxis
		labelPointCalculationBlock:
			[:aPoint :aLabelString | 
			| length shorterLength |
			length := 0 asPoint dist: aPoint.
			shorterLength := length + (aDiagram scale y * aDiagram axisFontSize) + 15.
			aPoint scaledBy: shorterLength / length]! !

!ESYAxisStrategy methodsFor: 'displaying' stamp: ' 11/3/11 16:41'!
getDeviationLine: aDiagram
	
	| offset |
	(aDiagram values isEmpty not and: [aDiagram values minValue >= 0])
		ifTrue:
			[offset := (aDiagram deviationValue - aDiagram yAxis minValue)
				* aDiagram yAxis scaleFactor]
		ifFalse: [offset := aDiagram deviationValue * aDiagram yAxis scaleFactor].
	^LineSegment
		from: 0 @ offset
		to: aDiagram contentWidth @ offset! !

!ESYAxisStrategy methodsFor: 'changing' stamp: ' 11/3/11 16:41'!
setBorders: aDiagram
	" *** This method was defined by EyeSee.AbstractAxisPositionStrategy as a subclass responsibility.
	Replace its body with a proper implementation. *** "
	
	self error: 'Subclass responsibility stub not reimplemented'! !

!ESYAxisStrategy methodsFor: 'changing' stamp: ' 11/3/11 16:41'!
setLabelDistanceFromAxisCalculation: aDiagram
	" *** This method was defined by EyeSee.AbstractAxisPositionStrategy as a subclass responsibility.
	Replace its body with a proper implementation. *** "
	
	self error: 'Subclass responsibility stub not reimplemented'! !

!ESYAxisStrategy methodsFor: 'changing' stamp: ' 11/3/11 16:41'!
setLabelPointCalculation: aDiagram
	" *** This method was defined by EyeSee.AbstractAxisPositionStrategy as a subclass responsibility.
	Replace its body with a proper implementation. *** "
	
	self error: 'Subclass responsibility stub not reimplemented'! !

Object subclass: #ESAbstractDiagram
	instanceVariableNames: 'layerHolder elements scale contentTranslation contentScale diagramTranslation height width xPadding yPadding models axisColor defaultColor labels rotatedLabels leftBorder upperBorder rightBorder lowerBorder defaultFontSize color colorDict availableColors displayLegend legendHeight legendWidth diagramTitle titleFontHeight horizontalLegend gcWrapper legendOrigin titleAlignment axisFontSize legend labelDistance decorators decorationPadding announcer borderWidth fillColor legendTextBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EyeSee-Core'!

!ESAbstractDiagram commentStamp: '<historical>' prior: 0!
AbstractDiagramType has not been commented.  The comment should state the purpose of the class and also explain any unobvious aspects of the implementation.

Subclasses must implement the following messages:
	changing
		scaleAxes
		setAxesValues
	creating
		createElements

Instance Variables:
	elements	<FigureGroup | SequenceableCollection>	collection of the graphical elements
	graphicsContext	<DiagramGraphicsContextWrapper>	
	height	<ArithmeticValue | CPointer | Matrix | Set | Vector>	
	models	<AbstractGroup | AbstractHistory | (Collection of: (MessageForwarder | Object | ProtoObject)) | Extent | Matrix | RBProgramNode>	collection of models
	scale	<MessageForwarder | Object | ProtoObject> 	a Point. gives information, how the coord system of this diagram type is oriented (e.g. BarDiagrams have their origin in the left 																	lower	corner, so the scale is 1@-1). used by the graphicsContextWrapper
	translation	<MessageForwarder | Object | ProtoObject>	aPoint gives information, how the coord system of this diagram type is oriented (e.g. BarDiagrams have their origin in the left 																	lower	corner, so the translation is something like 0@self height). used by the graphicsContextWrapper
	width	<Number | Vector>	
	xBorder	<Number | SequenceableCollection>	value of border (border is the space where the labels and titles are
	xPadding	<Number | SequenceableCollection>	
	yBorder	<MessageForwarder | Object | ProtoObject>	
	yPadding	<MessageForwarder | Object | ProtoObject>	

!

ESAbstractDiagram subclass: #ESAbstract2DDiagram
	instanceVariableNames: 'hasOrientationLeftRight hasOrientationBottomTop xAxis yAxis xAxisStrategy movedXAxis movedYAxis yAxisStrategy xAxisLabel yAxisLabel xAxisTranslation yAxisTranslation xAxisScale yAxisScale preferredAxisMaxX preferredAxisMaxY preferredAxisMinX preferredAxisMinY xDeviationValue yDeviationValue xDeviationDescription yDeviationDescription xAxisDecorators yAxisDecorators showBorder borderColor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EyeSee-Core'!

!ESAbstract2DDiagram methodsFor: 'scripting' stamp: ' 11/3/11 16:41'!
addXDecorator: aDecorator
	"self xAxis: (aDecorator anAxis: self xAxis)"
	
	self xAxisDecorators add: aDecorator! !

!ESAbstract2DDiagram methodsFor: 'scripting' stamp: ' 11/3/11 16:41'!
addYDecorator: aDecorator
	"self yAxis: (aDecorator anAxis: self yAxis)"
	
	self yAxisDecorators add: aDecorator! !

!ESAbstract2DDiagram methodsFor: 'accessing' stamp: 'TudorGirba 10/1/2012 08:17'!
atPoint: aPoint
	
	| found |
	(found := super atPoint: aPoint) ifNotNil: [^ found].
	(found := self
		findObjectIn: self xAxis values
		forPoint: aPoint
		inLayer: 'xAxis') ifNotNil: [^ found].
	(found := self
		findObjectIn: self yAxis values
		forPoint: aPoint
		inLayer: 'yAxis') ifNotNil: [^ found].
	^ nil! !

!ESAbstract2DDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
axisMaxX
	
	self deprecated: 'use #preferredAxisMaxX instead'.
	^preferredAxisMaxX! !

!ESAbstract2DDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
axisMaxX: aNumber
	
	self deprecated: 'use #preferredAxisMaxX: instead'.
	preferredAxisMaxX := aNumber! !

!ESAbstract2DDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
axisMaxY
	
	self deprecated: 'use #preferredAxisMaxY: instead'.
	^preferredAxisMaxY! !

!ESAbstract2DDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
axisMaxY: aNumber
	
	self deprecated: 'use #preferredAxisMaxY: instead'.
	preferredAxisMaxY := aNumber! !

!ESAbstract2DDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
axisMinX
	
	self deprecated: 'use #preferredAxisMinX: instead'.
	^preferredAxisMinX! !

!ESAbstract2DDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
axisMinX: aNumber
	
	self deprecated: 'use #preferredAxisMinX instead'.
	preferredAxisMinX := aNumber! !

!ESAbstract2DDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
axisMinY
	
	self deprecated: 'use #preferredAxisMinY instead'.
	^preferredAxisMinY! !

!ESAbstract2DDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
axisMinY: aNumber
	
	self deprecated: 'use #preferredAxisMinY: instead'.
	preferredAxisMinY := aNumber! !

!ESAbstract2DDiagram methodsFor: 'scripting' stamp: 'AndreHora 4/11/2011 22:50'!
axisPadding
	
	self
		yAxisTranslation: (self yAxisTranslation translatedby: 20 negated @ 0).
	self xAxisTranslation: (self xAxisTranslation translatedby: 0 @ 20)! !

!ESAbstract2DDiagram methodsFor: 'scripting' stamp: 'AndreHora 4/11/2011 22:50'!
axisPadding: aNumber
	
	self
		yAxisTranslation:
			(self yAxisTranslation translatedby: aNumber negated @ 0).
	self xAxisTranslation: (self xAxisTranslation translatedby: 0 @ aNumber)! !

!ESAbstract2DDiagram methodsFor: 'accessing' stamp: 'AndreHora 10/13/2011 16:21'!
borderColor

	^ borderColor! !

!ESAbstract2DDiagram methodsFor: 'accessing' stamp: 'AndreHora 10/13/2011 16:21'!
borderColor: aColor

	borderColor := aColor! !

!ESAbstract2DDiagram methodsFor: 'displaying' stamp: 'AndreHora 6/1/2012 15:04'!
bottomDecorationLayer: aGraphicsContext
	
	| gc |
	gc := (self gcWrapper copy)
		context: aGraphicsContext;
		scale: 1 asPoint;
		translation:
				self totalLeftBorder
						@ (self totalUpperBorder + self contentHeight + self xAxis height) +
							decorationPadding;
		yourself.
	gc font: self getDefaultFont.
	^gc! !

!ESAbstract2DDiagram methodsFor: 'private' stamp: 'AndreHora 6/1/2012 15:21'!
createAxis
	
	self xAxis: ESAxis new.
	self yAxis: ESAxis new.
	self setAxesStrategies.
	self xAxis textStyle: self getAxisTextStyle.
	self yAxis textStyle: self getAxisTextStyle.
	self setDecorators.
	self setYAxisValues.
	self setXAxisValues.
	self setLeftRightBorder.
	self scaleXAxis.
	self setUpperLowerBorder.
	self scaleYAxis.
	self setAxesColor! !

!ESAbstract2DDiagram methodsFor: 'creating' stamp: ' 11/3/11 16:41'!
createElements
	
	self subclassResponsibility! !

!ESAbstract2DDiagram methodsFor: 'displaying' stamp: 'AndreHora 3/16/2011 14:25'!
displayOn: aGraphicsContext
	
	super displayOn: aGraphicsContext.
	self layerHolder setActiveLayer: 'diagram'.
	self layerHolder activeLayer paint: Color white.
	self displayTitle: self layerHolder activeLayer.
	self colorDict isEmpty
		ifFalse: [self drawLegend: self layerHolder activeLayer].
	showBorder
		ifTrue:
			[self layerHolder activeLayer paint: Color darkGray.
			(Rectangle
				origin: 0 asPoint
				extent: (self width - 1) @ (self height - 1))
				displayStrokedOn: self layerHolder activeLayer]! !

!ESAbstract2DDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
getMaxX
	
	^self xAxis maxValue! !

!ESAbstract2DDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
getMaxY
	
	^self yAxis maxValue! !

!ESAbstract2DDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
getMinX
	
	^self xAxis minValue! !

!ESAbstract2DDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
getMinY
	
	^self yAxis minValue! !

!ESAbstract2DDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
hasMovedXAxis
	
	^movedXAxis! !

!ESAbstract2DDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
hasMovedXAxis: anObject
	
	movedXAxis := anObject! !

!ESAbstract2DDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
hasMovedYAxis
	
	^movedYAxis! !

!ESAbstract2DDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
hasMovedYAxis: anObject
	
	movedYAxis := anObject! !

!ESAbstract2DDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
hasOrientationBottomTop
	
	^hasOrientationBottomTop! !

!ESAbstract2DDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
hasOrientationBottomTop: anObject
	
	hasOrientationBottomTop := anObject! !

!ESAbstract2DDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
hasOrientationLeftRight
	
	^hasOrientationLeftRight! !

!ESAbstract2DDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
hasOrientationLeftRight: anObject
	
	hasOrientationLeftRight := anObject! !

!ESAbstract2DDiagram methodsFor: 'private' stamp: ' 11/3/11 16:41'!
hasValues
	
	self subclassResponsibility! !

!ESAbstract2DDiagram methodsFor: 'initialize-release' stamp: 'usmanbhatti 6/5/2012 17:27'!
initialize
	"Initialize a newly created instance. This method must answer the receiver."
	
	super initialize.
	self colorDict: Dictionary new.
	self xAxisScale: 1 @ 1.
	self yAxisScale: 1 @ 1.
	self xAxisTranslation: 0 @ 0.
	self yAxisTranslation: 0 @ 0.
	self axisColor: Color black.
	self defaultColor: Color gray.
	self displayLegend: true.
	self legendHeight: 30.
	self hasMovedYAxis: false.
	self hasMovedXAxis: false.
	self xAxisDecorators: OrderedCollection new.
	self yAxisDecorators: OrderedCollection new.
	self legendTextBlock: #yourself.
	showBorder := false.! !

!ESAbstract2DDiagram methodsFor: 'displaying' stamp: ' 11/3/11 16:41'!
leftDecorationLayer: aGraphicsContext
	
	| gc |
	gc := (self gcWrapper copy)
		context: aGraphicsContext;
		scale: 1 asPoint;
		translation:
				self diagramTranslation + (self totalLeftBorder @ self totalUpperBorder) +
							decorationPadding;
		yourself.
	gc font: self getDefaultFont.
	^gc! !

!ESAbstract2DDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
preferredAxisMaxX
	
	^preferredAxisMaxX! !

!ESAbstract2DDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
preferredAxisMaxX: anObject
	
	preferredAxisMaxX := anObject! !

!ESAbstract2DDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
preferredAxisMaxY
	
	^preferredAxisMaxY! !

!ESAbstract2DDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
preferredAxisMaxY: anObject
	
	preferredAxisMaxY := anObject! !

!ESAbstract2DDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
preferredAxisMinX
	
	^preferredAxisMinX! !

!ESAbstract2DDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
preferredAxisMinX: anObject
	
	preferredAxisMinX := anObject! !

!ESAbstract2DDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
preferredAxisMinY
	
	^preferredAxisMinY! !

!ESAbstract2DDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
preferredAxisMinY: anObject
	
	preferredAxisMinY := anObject! !

!ESAbstract2DDiagram methodsFor: 'advanced scripting' stamp: ' 11/3/11 16:41'!
regularAxis
	
	self subclassResponsibility! !

!ESAbstract2DDiagram methodsFor: 'displaying' stamp: ' 11/3/11 16:41'!
rightDecorationLayer: aGraphicsContext
	
	| gc |
	gc := (self gcWrapper copy)
		context: aGraphicsContext;
		scale: 1 asPoint;
		translation:
				self diagramTranslation + (self contentWidth @ self totalUpperBorder) +
							decorationPadding;
		yourself.
	gc font: self getDefaultFont.
	^gc! !

!ESAbstract2DDiagram methodsFor: 'scripting' stamp: 'AndreHora 6/17/2011 15:31'!
rightYAxis
	
	self hasMovedYAxis: true.
	"self yAxisScale: (self yAxisScale scaledBy: -1 @ 1)."
"	self yAxisTranslation: (self yAxisTranslation 
				translatedBy: self contentWidth @ 0)"! !

!ESAbstract2DDiagram methodsFor: 'private' stamp: ' 11/3/11 16:41'!
scaleXAxis
	
	self
		xAxis:
			(self xAxis
				from: 0 @ 0
				to: self contentWidth @ 0).
	self xAxis gridLineLenght: self contentWidth! !

!ESAbstract2DDiagram methodsFor: 'private' stamp: ' 11/3/11 16:41'!
scaleYAxis
	
	self
		yAxis:
			(self yAxis
				from: 0 @ 0
				to: 0 @ self contentHeight).
	self yAxis gridLineLenght: self contentWidth! !

!ESAbstract2DDiagram methodsFor: 'private' stamp: ' 11/3/11 16:41'!
setAxesColor
	
	self axisColor notNil
		ifTrue:
			[self xAxis color: self axisColor.
			self yAxis color: self axisColor]! !

!ESAbstract2DDiagram methodsFor: 'private' stamp: 'AndreHora 6/1/2012 15:18'!
setAxesStrategies
	
	self hasOrientationBottomTop
		ifTrue:
			[self hasMovedXAxis
				ifTrue: [self xAxisStrategy: ESTopAxisStrategy new]
				ifFalse: [self xAxisStrategy: ESBottomAxisStrategy new]]
		ifFalse:
			[self hasMovedXAxis
				ifTrue: [self xAxisStrategy: ESBottomAxisStrategy new]
				ifFalse: [self xAxisStrategy: ESTopAxisStrategy new]].
	self hasOrientationLeftRight
		ifTrue:
			[self hasMovedYAxis
				ifTrue: [self yAxisStrategy: ESRightAxisStrategy new]
				ifFalse: [self yAxisStrategy: ESLeftAxisStrategy new]]
		ifFalse:
			[self hasMovedYAxis
				ifTrue: [self yAxisStrategy: ESLeftAxisStrategy new]
				ifFalse: [self yAxisStrategy: ESRightAxisStrategy new]]! !

!ESAbstract2DDiagram methodsFor: 'private' stamp: ' 11/3/11 16:41'!
setDecorators
	
	self xAxisDecorators
		do: [:each | self xAxis: (each copy anAxis: self xAxis)].
	self yAxisDecorators
		do: [:each | self yAxis: (each copy anAxis: self yAxis)]! !

!ESAbstract2DDiagram methodsFor: 'private' stamp: 'AndreHora 6/5/2012 10:50'!
setLeftRightBorder
	
	super setLeftRightBorder.
	self yAxisStrategy setBorders: self.
	(self displayLegend and: [horizontalLegend not])
		ifTrue: [self rightBorder: self legendWidth].

	self flag: 'self xAxisLabel asStringMorph width should take the font into account'.
	self xAxisLabel
		ifNotNil:
			[self
				rightBorder:
					(self rightBorder
						max:
							(self xAxisLabel asStringMorph width))]! !

!ESAbstract2DDiagram methodsFor: 'private' stamp: 'AndreHora 6/6/2012 15:45'!
setScaleAndTranslation
	
	self hasOrientationLeftRight not
		ifTrue:
			[self scale: (self scale scaledBy: -1 @ 1).
			self
				diagramTranslation:
					(self diagramTranslation translatedby: self contentWidth @ 0)].
	self hasOrientationBottomTop
		ifTrue:
			[self scale: (self scale scaledBy: 1 @ -1).
			self
				diagramTranslation:
					(self diagramTranslation translatedby: 0 @ self contentHeight)].
	self hasMovedYAxis
		ifTrue:
			[self yAxisScale: (self yAxisScale scaledBy: -1 @ 1).
			self
				yAxisTranslation:
					(self yAxisTranslation translatedby: self contentWidth @ 0)].
	self hasMovedXAxis
		ifTrue:
			[self xAxisScale: (self xAxisScale scaledBy: 1 @ -1).
			self
				xAxisTranslation:
					(self xAxisTranslation translatedby: 0 @ self contentHeight)]! !

!ESAbstract2DDiagram methodsFor: 'private' stamp: ' 11/3/11 16:41'!
setUpperLowerBorder
	
	self xAxisStrategy setBorders: self.
	super setUpperLowerBorder.
	self yAxisLabel
		ifNotNil:
			[self upperBorder: (self upperBorder max: self defaultFontSize * 2)]! !

!ESAbstract2DDiagram methodsFor: 'private' stamp: 'AndreHora 4/6/2011 10:53'!
setXAxisValues
	
	self rotatedLabels isNil
		ifTrue: [self xAxisStrategy setRotatedLabels: self].
	self xAxisStrategy setLabelDistanceFromAxisCalculation: self.
	self xAxisStrategy setLabelPointCalculation: self.
	self xAxisLabel
		ifNotNil:
			[self xAxis label: self xAxisLabel.
			self xAxis: (ESTitleDecorator new anAxis: self xAxis)].
	self xAxis textStyle: self getDefaultTextStyle	"self xAxis fontSize: self getDefaultFont fontDescription pixelSize"! !

!ESAbstract2DDiagram methodsFor: 'private' stamp: 'AndreHora 4/5/2011 23:58'!
setYAxisValues
	
	self yAxisStrategy setLabelDistanceFromAxisCalculation: self.
	self yAxisStrategy setLabelPointCalculation: self.
	self yAxisLabel
		ifNotNil:
			[self yAxis label: self yAxisLabel.
			self yAxis: (ESTitleDecorator new anAxis: self yAxis)].
	self yAxis textStyle: self getDefaultTextStyle	"self yAxis fontSize: self getDefaultFont fontDescription pixelSize."! !

!ESAbstract2DDiagram methodsFor: 'displaying' stamp: ' 11/3/11 16:41'!
setupLayers: aGraphicsContext
	
	super setupLayers: aGraphicsContext.
	self layerHolder
		addLayer: (self xAxisLayer: aGraphicsContext)
		name: 'xAxis'.
	self layerHolder
		addLayer: (self yAxisLayer: aGraphicsContext)
		name: 'yAxis'! !

!ESAbstract2DDiagram methodsFor: 'scripting' stamp: ' 11/3/11 16:41'!
showBorder
	
	showBorder := true! !

!ESAbstract2DDiagram methodsFor: 'displaying' stamp: 'AndreHora 6/1/2012 15:03'!
topDecorationLayer: aGraphicsContext
	
	| gc |
	
	gc := (self gcWrapper copy)
		context: aGraphicsContext;
		scale: 1 asPoint;
		translation:
				self diagramTranslation
						+
							((self totalLeftBorder + decorationPadding)
								@
									(self totalUpperBorder - self xAxis height - self topDecoration height -
											decorationPadding));
		yourself.
	gc font: self getDefaultFont.
	^gc! !

!ESAbstract2DDiagram methodsFor: 'advanced scripting' stamp: ' 11/3/11 16:41'!
valueAxis
	
	self subclassResponsibility! !

!ESAbstract2DDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
xAxis
	
	^xAxis! !

!ESAbstract2DDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
xAxis: anObject
	
	xAxis := anObject! !

!ESAbstract2DDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
xAxisDecorators
	
	^xAxisDecorators! !

!ESAbstract2DDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
xAxisDecorators: anObject
	
	xAxisDecorators := anObject! !

!ESAbstract2DDiagram methodsFor: 'scripting' stamp: ' 11/3/11 16:41'!
xAxisLabel
	
	^xAxisLabel! !

!ESAbstract2DDiagram methodsFor: 'scripting' stamp: ' 11/3/11 16:41'!
xAxisLabel: anObject
	
	xAxisLabel := anObject! !

!ESAbstract2DDiagram methodsFor: 'displaying' stamp: 'AndreHora 3/15/2011 16:52'!
xAxisLayer: aGraphicsContext
	
	| gc |
	gc := (self gcWrapper copy)
		context: aGraphicsContext;
		scale: self scale * self xAxisScale;
		translation:
				self diagramTranslation + (0 @ self contentTranslation y)
						+ self xAxisTranslation + self padding + self leftTopBorder;
		yourself.
	"gc font: self getDefaultFont."
	^gc! !

!ESAbstract2DDiagram methodsFor: 'evaluating' stamp: ' 11/3/11 16:41'!
xAxisOnBottom
	
	^self xAxisScale y ~= self scale y! !

!ESAbstract2DDiagram methodsFor: 'evaluating' stamp: ' 11/3/11 16:41'!
xAxisOnTop
	
	^self xAxisScale y = self scale y! !

!ESAbstract2DDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
xAxisScale
	
	^xAxisScale! !

!ESAbstract2DDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
xAxisScale: anObject
	
	xAxisScale := anObject! !

!ESAbstract2DDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
xAxisStrategy
	
	^xAxisStrategy! !

!ESAbstract2DDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
xAxisStrategy: anObject
	
	xAxisStrategy := anObject! !

!ESAbstract2DDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
xAxisTranslation
	
	^xAxisTranslation! !

!ESAbstract2DDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
xAxisTranslation: anObject
	
	xAxisTranslation := anObject! !

!ESAbstract2DDiagram methodsFor: 'accessing' stamp: 'AndreHora 4/11/2011 22:30'!
xDeviationDescription
	
	xDeviationDescription isNil
		ifTrue: [^xDeviationValue asString]
		ifFalse: [^xDeviationDescription]! !

!ESAbstract2DDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
xDeviationDescription: anObject
	
	xDeviationDescription := anObject! !

!ESAbstract2DDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
xDeviationValue
	
	^xDeviationValue! !

!ESAbstract2DDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
xDeviationValue: anObject
	
	xDeviationValue := anObject! !

!ESAbstract2DDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
yAxis
	
	^yAxis! !

!ESAbstract2DDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
yAxis: anObject
	
	yAxis := anObject! !

!ESAbstract2DDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
yAxisDecorators
	
	^yAxisDecorators! !

!ESAbstract2DDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
yAxisDecorators: anObject
	
	yAxisDecorators := anObject! !

!ESAbstract2DDiagram methodsFor: 'scripting' stamp: ' 11/3/11 16:41'!
yAxisLabel
	
	^yAxisLabel! !

!ESAbstract2DDiagram methodsFor: 'scripting' stamp: ' 11/3/11 16:41'!
yAxisLabel: anObject
	
	yAxisLabel := anObject! !

!ESAbstract2DDiagram methodsFor: 'displaying' stamp: 'AndreHora 3/15/2011 16:52'!
yAxisLayer: aGraphicsContext
	
	| gc |
	gc := (self gcWrapper copy)
		context: aGraphicsContext;
		scale: self scale * self yAxisScale;
		translation:
				self diagramTranslation + (self contentTranslation x @ 0)
						+ self yAxisTranslation + self padding + self leftTopBorder;
		yourself.
	"gc font: self getDefaultFont."
	^gc! !

!ESAbstract2DDiagram methodsFor: 'evaluating' stamp: ' 11/3/11 16:41'!
yAxisLeft
	
	^self yAxisScale x = 1! !

!ESAbstract2DDiagram methodsFor: 'evaluating' stamp: ' 11/3/11 16:41'!
yAxisRight
	
	^self yAxisScale x = -1! !

!ESAbstract2DDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
yAxisScale
	
	^yAxisScale! !

!ESAbstract2DDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
yAxisScale: anObject
	
	yAxisScale := anObject! !

!ESAbstract2DDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
yAxisStrategy
	
	^yAxisStrategy! !

!ESAbstract2DDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
yAxisStrategy: anObject
	
	yAxisStrategy := anObject! !

!ESAbstract2DDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
yAxisTranslation
	
	^yAxisTranslation! !

!ESAbstract2DDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
yAxisTranslation: anObject
	
	yAxisTranslation := anObject! !

!ESAbstract2DDiagram methodsFor: 'accessing' stamp: 'AndreHora 4/11/2011 22:31'!
yDeviationDescription
	
	yDeviationDescription isNil
		ifTrue: [^yDeviationValue asString]
		ifFalse: [^yDeviationDescription]! !

!ESAbstract2DDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
yDeviationDescription: anObject
	
	yDeviationDescription := anObject! !

!ESAbstract2DDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
yDeviationValue
	
	^yDeviationValue! !

!ESAbstract2DDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
yDeviationValue: anObject
	
	yDeviationValue := anObject! !

ESAbstract2DDiagram subclass: #ESMatrixDiagram
	instanceVariableNames: 'matrix valueBlock lowColor highColor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EyeSee-Core'!

!ESMatrixDiagram methodsFor: 'displaying' stamp: 'AndreHora 9/23/2011 20:50'!
calculateWeight: pos max: max
	
	| weight |
	(weight := max - pos) < 1 ifTrue: [^weight].
	(pos rem: 1) = 0
		ifTrue: [weight := 1]
		ifFalse: [weight := 1 - (pos rem: 1)].
	^ weight! !

!ESMatrixDiagram methodsFor: 'initialize-release' stamp: 'AndreHora 9/23/2011 23:06'!
createColorDict
	"TODO"! !

!ESMatrixDiagram methodsFor: 'creating' stamp: 'TudorGirba 4/5/2011 22:35'!
createElements
	
	| availWidth availHeight groupColumnSize groupRowSize rectangle |
	availWidth := self contentWidth / self models columnSize asFloat.
	availHeight := self contentHeight / self models rowSize asFloat.
	groupColumnSize := groupRowSize := 1.
	availWidth < 1 ifTrue: [groupColumnSize := 1 / availWidth].
	availHeight < 1 ifTrue: [groupRowSize := 1 / availHeight].
	1
		to: self matrix rowSize asFloat
		by: groupRowSize
		do:
			[:i | 
			1
				to: self matrix columnSize asFloat
				by: groupColumnSize
				do:
					[:j | 
					| value |
					value := self
						getValue: i @ j
						offset: groupRowSize @ groupColumnSize.
					rectangle := Rectangle
						origin: ((j - 1) * availWidth) @ ((i - 1) * availHeight)
						extent: (availWidth * groupColumnSize) @ (availHeight * groupRowSize).
					self elements
						add: ((ESDataObject newWithShape: rectangle) model: value)]]! !

!ESMatrixDiagram methodsFor: 'displaying' stamp: ' 11/3/11 16:41'!
displayOn: aGraphicsContext
	
	super displayOn: aGraphicsContext.
	self layerHolder setActiveLayer: 'diagram'.
	self elements
		do:
			[:each | 
			self layerHolder activeLayer paint: each color.
			each shape displayFilledOn: self layerHolder activeLayer]! !

!ESMatrixDiagram methodsFor: 'displaying' stamp: 'AndreHora 9/23/2011 20:50'!
getNormalizer
		
	^ESColorLinearNormalizer
		inContext: self matrix asArray
		withCommand: self valueBlock
		lowColor: self lowColor
		highColor: self highColor! !

!ESMatrixDiagram methodsFor: 'displaying' stamp: 'AndreHora 9/23/2011 20:50'!
getValue: position offset: range
	
	| value colRange rowRange currColPos currRowPos colWeight rowWeight |
	value := 0.
	rowRange := range x.
	colRange := range y.
	currRowPos := 0.
	[currRowPos < rowRange]
		whileTrue:
			[currColPos := 0.
			rowWeight := self calculateWeight: currRowPos max: rowRange.
			[currColPos < colRange]
				whileTrue:
					[colWeight := self calculateWeight: currColPos max: colRange.
					value := value
						+
							((self matrix
								at: (position x + currRowPos) truncated
								and: (position y + currColPos) truncated) * colWeight * rowWeight).
					currColPos := currColPos + colWeight].
			currRowPos := currRowPos + rowWeight].
	^ value / (colRange * rowRange)! !

!ESMatrixDiagram methodsFor: 'private' stamp: 'AndreHora 9/23/2011 20:50'!
hasValues
	
	^ true! !

!ESMatrixDiagram methodsFor: 'accessing' stamp: 'AndreHora 9/23/2011 20:50'!
highColor
	
	^ highColor! !

!ESMatrixDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
highColor: anObject
	
	highColor := anObject! !

!ESMatrixDiagram methodsFor: 'initialize-release' stamp: 'AndreHora 9/23/2011 20:52'!
initialize
	
	super initialize.
	self hasOrientationLeftRight: true.
	self hasOrientationBottomTop: false.
	self lowColor: Color white.
	self highColor: Color black.
	self valueBlock: #yourself.
	self xPadding: 0.
	self yPadding: 0! !

!ESMatrixDiagram methodsFor: 'accessing' stamp: 'AndreHora 9/23/2011 20:50'!
lowColor
	
	^ lowColor! !

!ESMatrixDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
lowColor: anObject
	
	lowColor := anObject! !

!ESMatrixDiagram methodsFor: 'accessing' stamp: 'AndreHora 9/23/2011 20:50'!
matrix
	
	^ models! !

!ESMatrixDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
matrix: aMatrix
	
	models := aMatrix! !

!ESMatrixDiagram methodsFor: 'creating' stamp: 'AndreHora 12/9/2011 20:22'!
setColors
	
	| normalizer |
	self color
		ifNil:
			[normalizer := self getNormalizer.
			self color: [:each | normalizer eyeSeeValue: each model]].
	self elements do: [:each | each color: (self color value: each)]! !

!ESMatrixDiagram methodsFor: 'private' stamp: 'AndreHora 9/23/2011 20:51'!
setModels

	^ nil! !

!ESMatrixDiagram methodsFor: 'accessing' stamp: 'AndreHora 9/23/2011 20:50'!
valueBlock
	
	^ valueBlock! !

!ESMatrixDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
valueBlock: anObject
	
	valueBlock := anObject! !

ESAbstract2DDiagram subclass: #ESPieDiagram
	instanceVariableNames: 'radius segmentEachDegree pieValue sortBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EyeSee-Core'!

ESPieDiagram subclass: #ESKiviat
	instanceVariableNames: 'roundedBorder metrics kiviatModels backgroundColor kiviatBackground maxs mins axisLabels'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EyeSee-Core'!

!ESKiviat methodsFor: 'accessing' stamp: 'AndreHora 6/6/2012 17:17'!
axisLabels

	^ axisLabels! !

!ESKiviat methodsFor: 'accessing' stamp: 'AndreHora 6/6/2012 17:17'!
axisLabels: anObject

	axisLabels := anObject! !

!ESKiviat methodsFor: 'accessing' stamp: 'AndreHora 3/18/2012 17:51'!
backgroundColor

	^ backgroundColor! !

!ESKiviat methodsFor: 'accessing' stamp: 'AndreHora 3/18/2012 17:51'!
backgroundColor: anObject

	backgroundColor := anObject! !

!ESKiviat methodsFor: 'creating' stamp: 'AndreHora 6/6/2012 17:13'!
createElements
	
	super createElements.
	
	self models do: [ :each |
		self createKiviatModel: each ].
	
	self axisLabels notNil
		ifTrue: [ self createLabelsOnAxis ]! !

!ESKiviat methodsFor: 'creating' stamp: 'AndreHora 6/5/2012 11:38'!
createKiviatModel: model
	
	| element |
	
	element := (ESDataObject newWithShape: (self createKiviatPolygon: model))
		model: model;
		borderColor: self borderColor;
		borderWidth: self borderWidth.
	
	"self setPosition: element."
	self elements add: element! !

!ESKiviat methodsFor: 'creating' stamp: 'AndreHora 6/5/2012 17:58'!
createKiviatPolygon: model

	^ Polygon vertices: (self stubElements with: self metricMinsMaxs collect: [ :each :metricMinMax |
		
		| f l metricMinMaxValues |
		
		f := each shape vertices first.
		l := each shape vertices last.

		metricMinMaxValues := {
			metricMinMax first value: model.
			metricMinMax second value: self models.
			metricMinMax last value: self models }.

		self 
			mapMetric: metricMinMaxValues 
			toPointInIntervalFrom: l 
			to: f ]).! !

!ESKiviat methodsFor: 'creating' stamp: 'AndreHora 6/6/2012 18:15'!
createLabelsOnAxis
	
	| points |

	axisLabels := self stubElements with: self axisLabels collect: [ :each :label |
		
			ESTextLabel new 
				text: label asString;
				origin: each shape vertices first ]
	! !

!ESKiviat methodsFor: 'displaying' stamp: 'AndreHora 6/6/2012 18:09'!
displayOn: aGraphicsContext
	
	super displayOn: aGraphicsContext.
	
	self layerHolder setActiveLayer: 'diagram'.
	self axisLabels notNil
		ifTrue: [
			self axisLabels do: [ :each | each displayOn: self layerHolder activeLayer ]]
	! !

!ESKiviat methodsFor: 'initialization' stamp: 'AndreHora 6/6/2012 17:11'!
initialize

	super initialize.
	roundedBorder := false.
	kiviatBackground := true.
	color := #yourself.
	backgroundColor := Color transparent! !

!ESKiviat methodsFor: 'accessing' stamp: 'AndreHora 3/18/2012 19:49'!
kiviatBackground

	^ kiviatBackground! !

!ESKiviat methodsFor: 'accessing' stamp: 'AndreHora 3/18/2012 17:52'!
kiviatBackground: anObject

	kiviatBackground := anObject! !

!ESKiviat methodsFor: 'private' stamp: 'AndreHora 2/12/2012 22:30'!
kiviatBackgroundColor: aColor

	^ self kiviatBackground 
		ifTrue: [aColor]
		ifFalse: [Color transparent]! !

!ESKiviat methodsFor: 'private' stamp: 'AndreHora 2/12/2012 00:38'!
kiviatElements

	^ elements reject: [ :each | each model = 1 ]! !

!ESKiviat methodsFor: 'creating' stamp: 'AndreHora 3/18/2012 20:18'!
mapMetric: metricMinMax toPointInIntervalFrom: firstPoint to: lastPoint
	
	| v |
	
	v := self mapValue: 
		metricMinMax first 
		toIntervalFrom: metricMinMax second 
		to: metricMinMax last.
		
	^ self 
		mapValue: v 
		toPointInIntervalFrom: firstPoint 
		to: lastPoint
! !

!ESKiviat methodsFor: 'private' stamp: 'AndreHora 3/18/2012 20:15'!
mapValue: value toIntervalFrom: first to: last
	
	^ (value - first) / (last - first) asFloat! !

!ESKiviat methodsFor: 'private' stamp: 'AndreHora 3/18/2012 20:17'!
mapValue: value toPointInIntervalFrom: pointA to: pointB

	| incX incY nFraction pX pY |
	
	nFraction := 100.
	
	incX := ((pointA x - pointB x) / nFraction) negated.
	incY := ((pointA y - pointB y) / nFraction) negated.
	
	pX := pointA x + (incX * value * nFraction).
	pY := pointA y + (incY * value * nFraction).
	
	^ pX @ pY! !

!ESKiviat methodsFor: 'accessing' stamp: 'AndreHora 3/18/2012 20:21'!
maxs

	^ maxs! !

!ESKiviat methodsFor: 'accessing' stamp: 'AndreHora 3/18/2012 20:21'!
maxs: anObject

	maxs := anObject! !

!ESKiviat methodsFor: 'accessing' stamp: 'AndreHora 3/18/2012 20:22'!
metricMinsMaxs

	^ (1 to: self metrics size) collect: [ :index |
		{self metrics at: index. self mins at: index. self maxs at: index}]! !

!ESKiviat methodsFor: 'accessing' stamp: 'AndreHora 2/12/2012 10:47'!
metrics

	^ metrics! !

!ESKiviat methodsFor: 'accessing' stamp: 'AndreHora 2/12/2012 10:47'!
metrics: anObject

	metrics := anObject! !

!ESKiviat methodsFor: 'accessing' stamp: 'AndreHora 3/18/2012 17:59'!
mins
	^ mins! !

!ESKiviat methodsFor: 'accessing' stamp: 'AndreHora 3/18/2012 17:59'!
mins: anObject
	mins := anObject! !

!ESKiviat methodsFor: 'accessing' stamp: 'AndreHora 2/12/2012 00:05'!
models

	^ kiviatModels! !

!ESKiviat methodsFor: 'accessing' stamp: 'AndreHora 2/12/2012 00:02'!
models: aList

	kiviatModels := aList! !

!ESKiviat methodsFor: 'private' stamp: 'AndreHora 3/18/2012 18:28'!
pointsFrom: pointA to: pointB

	| incX incY nFraction pX pY |
	
	nFraction := 100.
	
	incX := ((pointA x - pointB x) / nFraction) negated.
	incY := ((pointA y - pointB y) / nFraction) negated.
	
	pX := pointA x.
	pY := pointA y.
	
	^ (1 to: nFraction) collect: [ :each |
		pX := pX + incX.
		pY := pY + incY.
		pX@pY ]! !

!ESKiviat methodsFor: 'accessing' stamp: 'AndreHora 2/12/2012 10:47'!
roundedBorder

	^ roundedBorder! !

!ESKiviat methodsFor: 'accessing' stamp: 'AndreHora 2/12/2012 10:47'!
roundedBorder: anObject

	roundedBorder := anObject! !

!ESKiviat methodsFor: 'private' stamp: 'AndreHora 2/12/2012 22:29'!
setColors

	[self models ~= nil] assert.
	self color notNil
		ifTrue: [ 
			| colors |
			colors := self colorValues
				copyFrom: 1
				to: self kiviatElements size.
			self kiviatElements with: colors do: [ :each :c | 
				each color: (self kiviatBackgroundColor: c).
				each borderColor: c strongerAlpha ]]
		ifFalse: [ 
			self kiviatElements do: [ :each | 
				each defaultColor: self defaultColor ]].

	self stubElements
		do: [:each | each color: self backgroundColor ]! !

!ESKiviat methodsFor: 'creating' stamp: 'AndreHora 3/18/2012 17:53'!
setKiviat

	"kiviat should have more than 2 metrics"
	(self metrics size <= 2)
		ifTrue: [^ self error].
		
	"storing a fake model"
	models := (Bag new add: 1 withOccurrences: self metrics size; yourself).
	self roundedBorder
		ifFalse: [self segmentEachDegree: 360 / self metrics size].! !

!ESKiviat methodsFor: 'private' stamp: 'AndreHora 2/11/2012 23:28'!
setModels! !

!ESKiviat methodsFor: 'initialization' stamp: 'AndreHora 2/11/2012 23:56'!
setup

	self setKiviat.
	super setup! !

!ESKiviat methodsFor: 'private' stamp: 'AndreHora 2/12/2012 00:32'!
stubElements

	^ elements select: [ :each | each model = 1 ]! !

!ESPieDiagram methodsFor: 'private' stamp: 'AndreHora 10/13/2011 11:33'!
calculateArcPointsFrom: fromDegree to: toDegree
	
	| beginEndPoints arcPoints |
	
	beginEndPoints := {self pointFromDegree: fromDegree. self pointFromDegree: toDegree}.
	
	((toDegree - fromDegree) < segmentEachDegree)
		ifTrue: [^ beginEndPoints].

	"we should keep the order, so no set"
	arcPoints := ((fromDegree to: toDegree by: segmentEachDegree) collect: [ :degree | 
			self pointFromDegree: degree ]) asOrderedCollection.
	
	arcPoints 
		detect: [ :each | (self pointFromDegree: toDegree) = each]
		ifNone: [ arcPoints add: (self pointFromDegree: toDegree)].
		
	^ arcPoints! !

!ESPieDiagram methodsFor: 'private' stamp: 'AndreHora 2/12/2012 00:10'!
calculateDegreeFor: element

	| total |
	
	total := (models collect: self pieValue) asArray sum.
	^ (element / total) * 360.0! !

!ESPieDiagram methodsFor: 'displaying' stamp: 'AndreHora 6/6/2012 16:06'!
contentLayer: aGraphicsContext
	
	^ self gcWrapper copy context: aGraphicsContext.! !

!ESPieDiagram methodsFor: 'private' stamp: 'AndreHora 10/12/2011 14:50'!
cosSinPoint: degree

	^ degree degreesToRadians cos @ degree degreesToRadians sin! !

!ESPieDiagram methodsFor: 'creating' stamp: 'AndreHora 6/5/2012 17:53'!
createElements
	
	| centerPoint currentDegree |
	
	centerPoint := (radius + self xPadding) @ (radius + self yPadding).
	currentDegree := 0.0.
	
	self sortedAs
		ifNotNil: [self models: (self models sorted: sortBlock) ].
	
	models do: [ :each | 
		| shape arcDegree arcPoints eachValue element |
		
		eachValue := self pieValue eyeSeeValue: each.
		
		arcDegree := self calculateDegreeFor: eachValue.
		arcPoints := self calculateArcPointsFrom: currentDegree to: currentDegree + arcDegree.
		arcPoints := arcPoints collect: [ :point | self transformPoint: point ].
		shape := Polygon vertices: arcPoints, {centerPoint}.
		currentDegree := currentDegree + arcDegree.
		
		element := (ESDataObject newWithShape: shape)
			model: each;
			borderColor: self borderColor;
			borderWidth: self borderWidth.

		self setPosition: element.
		self elements add: element]! !

!ESPieDiagram methodsFor: 'displaying' stamp: 'AndreHora 2/11/2012 19:04'!
displayOn: aGraphicsContext
	
	super displayOn: aGraphicsContext.
	self layerHolder setActiveLayer: 'diagram'.
	self elements
		do: [:each | 
			self layerHolder activeLayer paint: each color.
			each displayFilledOn: self layerHolder activeLayer ]! !

!ESPieDiagram methodsFor: 'testing' stamp: 'AndreHora 10/6/2011 17:31'!
hasValues
	
	^ true! !

!ESPieDiagram methodsFor: 'initialization' stamp: 'AndreHora 6/6/2012 15:25'!
initialize
	
	super initialize.
	self hasOrientationLeftRight: true.
	self hasOrientationBottomTop: false.
	self segmentEachDegree: 5.
	self pieValue: #yourself.
	self radius: 150.
	self borderColor: Color lightGray.
	self displayLegend: false! !

!ESPieDiagram methodsFor: 'accessing' stamp: 'AndreHora 10/12/2011 16:54'!
pieValue

	^ pieValue! !

!ESPieDiagram methodsFor: 'accessing' stamp: 'AndreHora 10/12/2011 16:54'!
pieValue: aBlock

	pieValue := aBlock! !

!ESPieDiagram methodsFor: 'private' stamp: 'AndreHora 10/13/2011 11:12'!
pointFromDegree: degree

	^ self cosSinPoint: degree! !

!ESPieDiagram methodsFor: 'accessing' stamp: 'AndreHora 10/12/2011 17:24'!
radius

	^ radius! !

!ESPieDiagram methodsFor: 'accessing' stamp: 'AndreHora 4/1/2012 20:47'!
radius: aNumber

	radius := aNumber.
	self width: radius * 2.
	self height: radius * 2.! !

!ESPieDiagram methodsFor: 'creating' stamp: 'AndreHora 6/5/2012 11:25'!
scaleFactor
	
	"TODO"
	^ 1 - ((self rightBorder * 1.5 max: self upperBorder) / self radius)! !

!ESPieDiagram methodsFor: 'accessing' stamp: 'AndreHora 10/12/2011 16:24'!
segmentEachDegree

	^ segmentEachDegree! !

!ESPieDiagram methodsFor: 'accessing' stamp: 'AndreHora 10/12/2011 16:24'!
segmentEachDegree: anObject

	segmentEachDegree := anObject! !

!ESPieDiagram methodsFor: 'creating' stamp: 'AndreHora 6/6/2012 15:18'!
setPosition: element
	
	element translatedBy: self rightBorder negated @ self upperBorder.
	element scaledBy: self scaleFactor.
	"self scale: (1@1negated)"! !

!ESPieDiagram methodsFor: 'accessing' stamp: 'AndreHora 10/12/2011 17:26'!
sortedAs

	^ sortBlock! !

!ESPieDiagram methodsFor: 'accessing' stamp: 'AndreHora 10/12/2011 17:26'!
sortedAs: aBlock

	sortBlock := aBlock! !

!ESPieDiagram methodsFor: 'private' stamp: 'AndreHora 6/6/2012 16:00'!
transformPoint: point
	
	"with radius = 1, the starting point is p(0,1)"
	super transformPoint: point.
	^ ((radius-(point x*radius)) + self xPadding) @((radius-(point y*radius)) + self yPadding)! !

ESAbstract2DDiagram subclass: #ESScatterPlot
	instanceVariableNames: 'radius x y shape shapeDict dataObjectFilled defaultShape'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EyeSee-Core'!

!ESScatterPlot methodsFor: 'scripting' stamp: 'AndreHora 4/6/2011 00:05'!
baseAxisLine
	
	self addXDecorator: ESBaseLineDecorator new.
	self addYDecorator: ESBaseLineDecorator new! !

!ESScatterPlot methodsFor: 'scripting' stamp: ' 11/3/11 16:41'!
bigObjects
	
	self radius: 10! !

!ESScatterPlot methodsFor: 'advanced scripting' stamp: ' 11/3/11 16:41'!
boxPlotAxis
	
	self
		xBoxPlot;
		yBoxPlot;
		xBoxPlotLabel;
		yBoxPlotLabel! !

!ESScatterPlot methodsFor: 'scripting' stamp: 'TudorGirba 4/5/2011 22:35'!
circles
	
	self defaultShape: ESShape circle! !

!ESScatterPlot methodsFor: 'creating' stamp: 'TudorGirba 4/5/2011 22:35'!
createElements
	
	self models
		do:
			[:each | 
			| currPoint dataObject currShape extent |
			currPoint := ((self x value: each) - self xAxis minValue)
				@ ((self y value: each) - self yAxis minValue).
			currPoint := currPoint
				scaledBy: self xAxis scaleFactor @ self yAxis scaleFactor.
			self shape isNil
				ifFalse: [currShape := self shapeDict at: (self shape value: each)]
				ifTrue: [currShape := self defaultShape].
			(self pointVisible: currPoint)
				ifTrue: [extent := self radius]
				ifFalse: [extent := 0].
			dataObject := ESDataObject
				newWithShape: (currShape value: currPoint value: extent).
			self elements add: dataObject]! !

!ESScatterPlot methodsFor: 'scripting' stamp: 'TudorGirba 4/5/2011 22:35'!
crosses
	
	self defaultShape: ESShape cross! !

!ESScatterPlot methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
dataObjectFilled
	
	^dataObjectFilled! !

!ESScatterPlot methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
dataObjectFilled: anObject
	
	dataObjectFilled := anObject! !

!ESScatterPlot methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
defaultShape
	
	^defaultShape! !

!ESScatterPlot methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
defaultShape: anObject
	
	defaultShape := anObject! !

!ESScatterPlot methodsFor: 'displaying' stamp: ' 11/3/11 16:41'!
displayOn: aGraphicsContext
	
	super displayOn: aGraphicsContext.
	self layerHolder setActiveLayer: 'content'.
	self dataObjectFilled
		ifTrue:
			[self elements
				do: [:each | each displayFilledOn: self layerHolder activeLayer]]
		ifFalse:
			[self elements
				do: [:each | each displayStrokedOn: self layerHolder activeLayer]].
	self layerHolder setActiveLayer: 'yAxis'.
	self yAxis displayOn: self layerHolder activeLayer.
	self layerHolder setActiveLayer: 'xAxis'.
	self xAxis displayOn: self layerHolder activeLayer! !

!ESScatterPlot methodsFor: 'private' stamp: ' 11/3/11 16:41'!
hasValues
	
	^(self models collect: x) isEmpty not
		and: [(self models collect: y) isEmpty not]! !

!ESScatterPlot methodsFor: 'initialize-release' stamp: 'AndreHora 4/1/2011 16:20'!
initialize
	"Initialize a newly created instance. This method must answer the receiver."
	
	super initialize.
	self width: 300.
	self height: 300.
	self mediumObjects.
	self strongColors.
	self dataObjectFilled: true.
	self circles.
	self hasOrientationLeftRight: true.
	self hasOrientationBottomTop: true.! !

!ESScatterPlot methodsFor: 'scripting' stamp: ' 11/3/11 16:41'!
mediumObjects
	
	self radius: 4! !

!ESScatterPlot methodsFor: 'advanced scripting' stamp: ' 11/3/11 16:41'!
minimalBoxPlotAxis
	
	self
		minimalXBoxPlot;
		minimalYBoxPlot;
		xBoxPlotLabel;
		yBoxPlotLabel! !

!ESScatterPlot methodsFor: 'scripting' stamp: 'TudorGirba 4/17/2011 21:10'!
minimalXBoxPlot
	
	self addXDecorator: ESFewBoxPlotBaseLineDecorator new! !

!ESScatterPlot methodsFor: 'scripting' stamp: 'AndreHora 4/6/2011 11:10'!
minimalYBoxPlot
	
	self addYDecorator: ESFewBoxPlotBaseLineDecorator new! !

!ESScatterPlot methodsFor: 'creating' stamp: ' 11/3/11 16:41'!
pointVisible: aPoint
	
	^aPoint x >= 0
		and:
			[aPoint y >= 0
				and:
					[aPoint x <= ((self getMaxX - self getMinX) * self xAxis scaleFactor)
						and:
							[aPoint y <= ((self getMaxY - self getMinY) * self yAxis scaleFactor)]]]! !

!ESScatterPlot methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
radius
	
	^radius! !

!ESScatterPlot methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
radius: anObject
	
	radius := anObject! !

!ESScatterPlot methodsFor: 'advanced scripting' stamp: ' 11/3/11 16:41'!
rangeAxis
	
	self
		xRangeBase;
		yRangeBase;
		xRangeLabels;
		yRangeLabels! !

!ESScatterPlot methodsFor: 'scripting' stamp: 'TudorGirba 4/5/2011 22:35'!
rectangles
	
	self defaultShape: ESShape rectangle! !

!ESScatterPlot methodsFor: 'advanced scripting' stamp: ' 11/3/11 16:41'!
regularAxis
	
	self
		regularTicks;
		regularLabels! !

!ESScatterPlot methodsFor: 'scripting' stamp: 'AndreHora 4/6/2011 11:10'!
regularLabels
	
	self addXDecorator: ESRegularLabelDecorator new.
	self addYDecorator: ESRegularLabelDecorator new! !

!ESScatterPlot methodsFor: 'scripting' stamp: 'AndreHora 4/6/2011 11:10'!
regularTicks
	
	self addXDecorator: ESRegularTickDecorator new.
	self addYDecorator: ESRegularTickDecorator new! !

!ESScatterPlot methodsFor: 'private' stamp: ' 11/3/11 16:41'!
setAxesStrategies
	
	super setAxesStrategies! !

!ESScatterPlot methodsFor: 'private' stamp: 'AndreHora 4/5/2011 11:37'!
setXAxisValues
	
	| xValues |
	self preferredAxisMaxX isNil
		ifTrue: [self xAxis maxValue: (self models collect: self x) maxValue]
		ifFalse: [self xAxis preferedMaxValue: self preferredAxisMaxX].
	self xAxis labelRepresentation: self labels.
	self xAxis rotatedLabels: self rotatedLabels.
	self preferredAxisMinX
		ifNotNil: [self xAxis minValue: self preferredAxisMinX].
	xValues := OrderedCollection new.
	(self models collect: self x)
		do:
			[:each | 
			(each - self getMinX >= 0 and: [each <= self getMaxX])
				ifTrue: [xValues add: each]].
	self xAxis values: xValues.
	super setXAxisValues! !

!ESScatterPlot methodsFor: 'private' stamp: 'AndreHora 4/5/2011 11:37'!
setYAxisValues
	
	| yValues |
	yValues := OrderedCollection new.
	self preferredAxisMaxY isNil
		ifTrue: [self yAxis maxValue: (self models collect: self y) maxValue]
		ifFalse: [self yAxis preferedMaxValue: self preferredAxisMaxY].
	self yAxis labelRepresentation: self labels.
	self preferredAxisMinY
		ifNotNil: [self yAxis minValue: self preferredAxisMinY].
	(self models collect: self y)
		do:
			[:each | 
			(each - self yAxis minValue >= 0 and: [each <= self yAxis maxValue])
				ifTrue: [yValues add: each]].
	self yAxis values: yValues.
	super setYAxisValues! !

!ESScatterPlot methodsFor: 'initialize-release' stamp: 'TudorGirba 4/5/2011 22:35'!
setup
	
	self shape
		ifNotNil:
			[| keys values |
			keys := (self models collect: self shape) asOrderedCollection
				removeDuplicates asSortedCollection.
			values := ESShape shapes.
			[keys size > values size] whileTrue: [values addAll: values].
			self shapeDict: (Dictionary keys: keys values: values)].
	super setup! !

!ESScatterPlot methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
shape
	
	^shape! !

!ESScatterPlot methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
shape: anObject
	
	shape := anObject! !

!ESScatterPlot methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
shapeDict
	
	^shapeDict! !

!ESScatterPlot methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
shapeDict: anObject
	
	shapeDict := anObject! !

!ESScatterPlot methodsFor: 'scripting' stamp: ' 11/3/11 16:41'!
smallObjects
	
	self radius: 1! !

!ESScatterPlot methodsFor: 'scripting' stamp: ' 11/3/11 16:41'!
strokedShapes
	
	self dataObjectFilled: false! !

!ESScatterPlot methodsFor: 'advanced scripting' stamp: ' 11/3/11 16:41'!
valueAxis
	
	self
		xValueTicks;
		xValueLabels;
		yValueTicks;
		yValueLabels! !

!ESScatterPlot methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
x
	
	^x! !

!ESScatterPlot methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
x: anObject
	
	x := anObject! !

!ESScatterPlot methodsFor: 'scripting' stamp: 'AndreHora 4/6/2011 00:05'!
xBoxPlot
	
	self addXDecorator: ESBoxPlotBaseLineDecorator new! !

!ESScatterPlot methodsFor: 'scripting' stamp: 'AndreHora 4/6/2011 00:06'!
xBoxPlotLabel
	
	self addXDecorator: ESBoxPlotLabelDecorator new! !

!ESScatterPlot methodsFor: 'scripting' stamp: 'AndreHora 4/6/2011 00:08'!
xRangeBase
	
	self addXDecorator: ESRangeBaseLineDecorator new! !

!ESScatterPlot methodsFor: 'scripting' stamp: 'AndreHora 4/6/2011 00:11'!
xRangeLabels
	
	self addXDecorator: ESRangeLabelDecorator new! !

!ESScatterPlot methodsFor: 'scripting' stamp: 'AndreHora 4/6/2011 00:05'!
xValueLabels
	
	self addXDecorator: ESValueLabelDecorator new! !

!ESScatterPlot methodsFor: 'scripting' stamp: 'AndreHora 4/6/2011 00:05'!
xValueTicks
	
	self addXDecorator: ESValueTickDecorator new! !

!ESScatterPlot methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
y
	
	^y! !

!ESScatterPlot methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
y: anObject
	
	y := anObject! !

!ESScatterPlot methodsFor: 'scripting' stamp: 'AndreHora 4/6/2011 00:06'!
yBoxPlot
	
	self addYDecorator: ESBoxPlotBaseLineDecorator new! !

!ESScatterPlot methodsFor: 'scripting' stamp: 'AndreHora 4/6/2011 00:07'!
yBoxPlotLabel
	
	self addYDecorator: ESBoxPlotLabelDecorator new! !

!ESScatterPlot methodsFor: 'scripting' stamp: 'AndreHora 4/6/2011 00:10'!
yRangeBase
	
	self addYDecorator: ESRangeBaseLineDecorator new! !

!ESScatterPlot methodsFor: 'scripting' stamp: 'AndreHora 4/6/2011 00:11'!
yRangeLabels
	
	self addYDecorator: ESRangeLabelDecorator new! !

!ESScatterPlot methodsFor: 'scripting' stamp: 'AndreHora 4/6/2011 00:05'!
yValueLabels
	
	self addYDecorator: ESValueLabelDecorator new! !

!ESScatterPlot methodsFor: 'scripting' stamp: 'AndreHora 4/6/2011 00:05'!
yValueTicks
	
	self addYDecorator: ESValueTickDecorator new! !

ESAbstract2DDiagram subclass: #ESSingleAxisDiagram
	instanceVariableNames: 'identifier valueBlock cachedValues'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EyeSee-Core'!

ESSingleAxisDiagram subclass: #ESAbstractBarDiagram
	instanceVariableNames: 'invertedLinearFill linearFill coloredFill leftGap rightGap centerBars barWidth'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EyeSee-Core'!

!ESAbstractBarDiagram commentStamp: '<historical>' prior: 0!
BarDiagram has not been commented.  The comment should state the purpose of the class and also explain any unobvious aspects of the implementation.

Instance Variables:
	axis	<Array>	 						contains the two axis
	bars	<(Collection of: Rectangle)>		collection of all bars
	barWidth	<Number>					in pixels
	diagramHeight	<ArithmeticValue>		in pixels
	maxYValue	<ArithmeticValue>			the highest actual value used in the diagram
	scaleFactor	<ArithmeticValue>			multiplied with the actual value, you get the pixel value
	tickWidth	<ArithmeticValue>			the width of a tick

!

!ESAbstractBarDiagram methodsFor: 'scripting' stamp: ' 11/3/11 16:41'!
addBaseDecorator: aDecorator
	
	self subclassResponsibility! !

!ESAbstractBarDiagram methodsFor: 'scripting' stamp: ' 11/3/11 16:41'!
addValueDecorator: aDecorator
	
	self subclassResponsibility! !

!ESAbstractBarDiagram methodsFor: 'evaluating' stamp: ' 11/3/11 16:41'!
barFraction
	
	^1 - self leftGap - self rightGap! !

!ESAbstractBarDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
barWidth
	
	^barWidth! !

!ESAbstractBarDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
barWidth: anObject
	
	barWidth := anObject! !

!ESAbstractBarDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
centerBars
	
	^centerBars! !

!ESAbstractBarDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
centerBars: anObject
	
	centerBars := anObject! !

!ESAbstractBarDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
coloredFill
	
	^coloredFill! !

!ESAbstractBarDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
coloredFill: anObject
	
	coloredFill := anObject! !

!ESAbstractBarDiagram methodsFor: 'scripting' stamp: ' 11/3/11 16:41'!
gapFraction: anInteger
	
	[(anInteger >= 0 & anInteger) < 1] assert.
	self leftGap: anInteger / 2.0.
	self rightGap: anInteger / 2.0! !

!ESAbstractBarDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
getBaseAxis
	
	self subclassResponsibility! !

!ESAbstractBarDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
getValueAxis
	
	self subclassResponsibility! !

!ESAbstractBarDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
hasMovedBaseAxis
	
	self subclassResponsibility! !

!ESAbstractBarDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
hasMovedValueAxis
	
	self subclassResponsibility! !

!ESAbstractBarDiagram methodsFor: 'initialize-release' stamp: 'AndreHora 4/1/2011 16:20'!
initialize
	
	super initialize.
	self gapFraction: 1 / 3 asFloat.
	self invertedLinearFill: false.
	self linearFill: false.
	self coloredFill: false.
	self centerBars: false.! !

!ESAbstractBarDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
invertedLinearFill
	
	^invertedLinearFill! !

!ESAbstractBarDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
invertedLinearFill: anObject
	
	invertedLinearFill := anObject! !

!ESAbstractBarDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
leftGap
	
	^leftGap! !

!ESAbstractBarDiagram methodsFor: 'scripting' stamp: ' 11/3/11 16:41'!
leftGap: anObject
	
	leftGap := anObject! !

!ESAbstractBarDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
linearFill
	
	^linearFill! !

!ESAbstractBarDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
linearFill: anObject
	
	linearFill := anObject! !

!ESAbstractBarDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
rightGap
	
	^rightGap! !

!ESAbstractBarDiagram methodsFor: 'scripting' stamp: ' 11/3/11 16:41'!
rightGap: anObject
	
	rightGap := anObject! !

!ESAbstractBarDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
setBaseAxis: anAxis
	
	self subclassResponsibility! !

!ESAbstractBarDiagram methodsFor: 'scripting' stamp: ' 11/3/11 16:41'!
setColoredFill
	
	self coloredFill: true! !

!ESAbstractBarDiagram methodsFor: 'scripting' stamp: ' 11/3/11 16:41'!
setInvertedLinearFill
	
	self linearFill: false.
	self invertedLinearFill: true! !

!ESAbstractBarDiagram methodsFor: 'scripting' stamp: ' 11/3/11 16:41'!
setLinearFill
	
	self linearFill: true.
	self invertedLinearFill: false! !

!ESAbstractBarDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
setValueAxis: anAxis
	
	self subclassResponsibility! !

!ESAbstractBarDiagram methodsFor: 'private' stamp: 'AndreHora 9/23/2011 21:32'!
setup

	(self linearFill or: [self invertedLinearFill])
		ifTrue:
			[| colors |
			self coloredFill
				ifTrue: [colors := ESAbstractDiagram getTemperatureColors: self models size]
				ifFalse: [colors := ESAbstractDiagram getGrayColors: self models size].
			self invertedLinearFill ifTrue: [colors := colors reverse].
			self availableColors: colors.
			self identifier notNil
				ifTrue: [self color: [:each | each identifier]]
				ifFalse:
					[self color: #yourself.
					self displayLegend: false]].
	super setup! !

ESAbstractBarDiagram subclass: #ESHistogram
	instanceVariableNames: 'numberOfIntervals property barDiagram'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EyeSee-Core'!

!ESHistogram methodsFor: 'scripting' stamp: ' 11/3/11 16:41'!
availableColors: aCollection
	
	self barDiagram availableColors: aCollection! !

!ESHistogram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
barDiagram
	
	^barDiagram! !

!ESHistogram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
barDiagram: anObject
	
	barDiagram := anObject! !

!ESHistogram methodsFor: 'scripting' stamp: ' 11/3/11 16:41'!
color: aBlock
	
	self barDiagram color: aBlock! !

!ESHistogram methodsFor: 'displaying' stamp: 'TudorGirba 9/28/2012 07:30'!
displayOn: aGraphicsContext
	self barDiagram gcWrapper: self gcWrapper copy.  
	self barDiagram displayOn: aGraphicsContext! !

!ESHistogram methodsFor: 'scripting' stamp: ' 11/3/11 16:41'!
gapFraction: aNumber
	
	self barDiagram gapFraction: aNumber! !

!ESHistogram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
getBaseAxis
	
	^self xAxis! !

!ESHistogram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
getValueAxis
	
	^self yAxis! !

!ESHistogram methodsFor: 'scripting' stamp: ' 11/3/11 16:41'!
gridLine
	
	self barDiagram gridLine! !

!ESHistogram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
hasMovedBaseAxis
	
	^self hasMovedXAxis! !

!ESHistogram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
hasMovedValueAxis
	
	^self hasMovedYAxis! !

!ESHistogram methodsFor: 'initialize-release' stamp: 'TudorGirba 4/5/2011 22:35'!
initialize
	
	self barDiagram: ESVerticalBarDiagram new.
	self numberOfIntervals: 1.
	self hasOrientationBottomTop: true.
	self hasOrientationLeftRight: true.
	super initialize! !

!ESHistogram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
numberOfIntervals
	
	^numberOfIntervals! !

!ESHistogram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
numberOfIntervals: anObject
	
	numberOfIntervals := anObject! !

!ESHistogram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
property
	
	^property! !

!ESHistogram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
property: anObject
	
	property := anObject! !

!ESHistogram methodsFor: 'scripting' stamp: ' 11/3/11 16:41'!
regularAxis
	
	self barDiagram regularAxis! !

!ESHistogram methodsFor: 'scripting' stamp: ' 11/3/11 16:41'!
regularLabels
	
	self barDiagram regularLabels! !

!ESHistogram methodsFor: 'scripting' stamp: ' 11/3/11 16:41'!
regularTicks
	
	self barDiagram regularTicks! !

!ESHistogram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
setBaseAxis: anAxis
	
	self xAxis: anAxis! !

!ESHistogram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
setValueAxis: anAxis
	
	self yAxis: anAxis! !

!ESHistogram methodsFor: 'private' stamp: 'TudorGirba 10/1/2012 07:49'!
setup
	
	| highestValue intervalSize barDiagramModel |
	highestValue := self models maximumValue: [:each | self property value: each ].
	"extracts highhest number for this property"
	intervalSize := highestValue / self numberOfIntervals.
	barDiagramModel := self models
		groupedBy: [:each | (self property value: each) // intervalSize].
	0
		to: numberOfIntervals - 1
		do:
			[:i | 
			barDiagramModel
				at: i
				ifAbsentPut: [OrderedCollection new]].
	self barDiagram
		y: [:each | each value size];
		identifier: [:each | 
			each value size >= 1
				ifTrue: [  
					each value size > 1 
						ifTrue: [each value first asString, ' - ', each value last asString ]
						ifFalse: [each value first asString]]
				ifFalse: ['']];
		models: (barDiagramModel associations sort: [:a :b | a key < b key]);
		rotatedLabels: self rotatedLabels;
		yAxisLabel: self yAxisLabel;
		xAxisLabel: self xAxisLabel.
	
	self barDiagram setup! !

ESAbstractBarDiagram subclass: #ESHorizontalBarDiagram
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EyeSee-Core'!

!ESHorizontalBarDiagram methodsFor: 'scripting' stamp: ' 11/3/11 16:41'!
addBaseDecorator: aDecorator
	
	self addYDecorator: aDecorator! !

!ESHorizontalBarDiagram methodsFor: 'scripting' stamp: ' 11/3/11 16:41'!
addValueDecorator: aDecorator
	
	self addXDecorator: aDecorator! !

!ESHorizontalBarDiagram methodsFor: 'creating' stamp: 'TudorGirba 10/1/2012 13:12'!
createElements
	
	| i bars availWidth axisScale |
	i := 1.
	availWidth := self contentHeight / self values size.
	bars := OrderedCollection new.
	self values
		do:
			[:each | 
			bars
				add:
					(ESDataObject
						newWithShape:
							(Rectangle
								origin: 0 @ 0
								corner: each @ 1))].
	i := 0.
	axisScale := self xAxis scaleFactor.
	bars
		do:
			[:each | 
			| scaledBar |
			scaledBar := each scaledBy: axisScale @ (availWidth * self barFraction).
			scaledBar moveBy: 0 @ (i * availWidth + (availWidth * self leftGap)).
			self elements add: scaledBar.
			i := i + 1]! !

!ESHorizontalBarDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
deviationDescription
	
	^self xDeviationDescription! !

!ESHorizontalBarDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
deviationDescription: aString
	
	^self xDeviationDescription: aString! !

!ESHorizontalBarDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
deviationValue
	
	^self xDeviationValue! !

!ESHorizontalBarDiagram methodsFor: 'accessing' stamp: 'AlexandreBergel 12/8/2011 13:00'!
deviationValue: aNumber
	"Check ESSingleAxisDiagram>> deviationValue: for a description"
	
	self xDeviationValue: aNumber! !

!ESHorizontalBarDiagram methodsFor: 'displaying' stamp: ' 11/3/11 16:41'!
displayOn: aGraphicsContext
	
	super displayOn: aGraphicsContext.
	self layerHolder setActiveLayer: 'content'.
	self elements
		do:
			[:each | each displayFilledOn: (self layerHolder activeLayer paint: each color)].
	self layerHolder setActiveLayer: 'yAxis'.
	self yAxis displayOn: self layerHolder activeLayer.
	self layerHolder setActiveLayer: 'xAxis'.
	self xAxis displayOn: self layerHolder activeLayer.
	self layerHolder setActiveLayer: 'content'.
	self deviationValue
		ifNotNil:
			[(self xAxisStrategy getDeviationLine: self)
				displayStrokedOn: (self layerHolder activeLayer paint: self axisColor).
			(self xAxisStrategy getDeviationDescriptionLabel: self)
				displayOn: (self layerHolder activeLayer paint: self axisColor)]! !

!ESHorizontalBarDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
getBaseAxis
	
	^self yAxis! !

!ESHorizontalBarDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
getValueAxis
	
	^self xAxis! !

!ESHorizontalBarDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
hasMovedBaseAxis
	
	^self hasMovedYAxis! !

!ESHorizontalBarDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
hasMovedValueAxis
	
	^self hasMovedXAxis! !

!ESHorizontalBarDiagram methodsFor: 'initialize-release' stamp: 'AndreHora 4/1/2011 16:21'!
initialize
	
	super initialize.
	self hasOrientationLeftRight: true.
	self hasOrientationBottomTop: true.! !

!ESHorizontalBarDiagram methodsFor: 'private' stamp: ' 11/3/11 16:41'!
setAxesStrategies
	
	super setAxesStrategies! !

!ESHorizontalBarDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
setBaseAxis: anAxis
	
	self yAxis: anAxis! !

!ESHorizontalBarDiagram methodsFor: 'creating' stamp: ' 11/3/11 16:41'!
setScaleAndTranslation
	
	super setScaleAndTranslation.
	self xAxis minValue < 0
		ifTrue:
			[self
				contentTranslation:
					(self values minValue * self xAxis scaleFactor negated) @ 0]! !

!ESHorizontalBarDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
setValueAxis: anAxis
	
	self xAxis: anAxis! !

!ESHorizontalBarDiagram methodsFor: 'private' stamp: 'AndreHora 4/5/2011 11:39'!
setXAxisValues
	
	self xAxis values: self values.
	self preferredAxisMaxX isNil
		ifTrue: [self xAxis maxValue: (self values maximumValue: [:each | each])]
		ifFalse: [self xAxis preferedMaxValue: self preferredAxisMaxX].
	self xAxis rotatedLabels: self rotatedLabels.
	self values minValue < 0
		ifTrue: [self xAxis minValue: self values minValue].
	self xAxis labelRepresentation: self labels.
	super setXAxisValues! !

!ESHorizontalBarDiagram methodsFor: 'private' stamp: 'AndreHora 4/5/2011 23:59'!
setYAxisValues
	
	self identifier
		ifNotNil:
			[self yAxis values: self identifiers.
			self yAxis: (ESIdentifierDecorator new anAxis: self yAxis)].
	super setYAxisValues! !

ESAbstractBarDiagram subclass: #ESRangeDiagram
	instanceVariableNames: 'minX maxX showGrid ticks valuesBlock tickColor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EyeSee-Core'!

!ESRangeDiagram methodsFor: 'scripting' stamp: ' 11/3/11 16:41'!
addBaseDecorator: aDecorator
	
	self addYDecorator: aDecorator! !

!ESRangeDiagram methodsFor: 'scripting' stamp: ' 11/3/11 16:41'!
addValueDecorator: aDecorator
	
	self addXDecorator: aDecorator! !

!ESRangeDiagram methodsFor: 'creating' stamp: ' 11/3/11 16:41'!
availHeight
	
	^self contentHeight / self models size asFloat! !

!ESRangeDiagram methodsFor: 'creating' stamp: 'TudorGirba 4/5/2011 22:35'!
createElements
	
	| currY |
	currY := 0.
	self models
		do:
			[:each | 
			| min max rect |
			min := self minX value: each.
			max := self maxX value: each.
			[min <= max] assert.	"Todo: handle case, when only min or max is given"
			(min notNil and: [max notNil])
				ifTrue:
					["check, wheter bar is in visible area"
					(max > self getMinX and: [min < self getMaxX])
						ifTrue:
							[max - min < self unit
								ifTrue:
									[rect := self
										createRectangleAt: currY
										min: min - (self unit / 2)
										max: max + (self unit / 2)]
								ifFalse: [rect := self createRectangleAt: currY min: min max: max].
							self elements add: (ESDataObject newWithShape: rect)]].
			currY := currY + 1].
	self valuesBlock ifNotNil: [self createTicks]! !

!ESRangeDiagram methodsFor: 'creating' stamp: ' 11/3/11 16:41'!
createRectangleAt: currY min: min max: max
	
	| rectMin rectMax |
	rectMin := min.
	rectMax := max.
	min < self getMinX ifTrue: [rectMin := self getMinX].
	max > self getMaxX ifTrue: [rectMax := self getMaxX].
	^Rectangle
		origin:
			((rectMin - self getMinX) * self xScale)
				@ (currY * self availHeight + (self availHeight * self leftGap))
		corner:
			((rectMax - self getMinX) * self xScale)
				@ ((currY + 1) * self availHeight - (self availHeight * self rightGap))! !

!ESRangeDiagram methodsFor: 'creating' stamp: 'TudorGirba 4/5/2011 22:35'!
createTicks
	
	| currY x |
	currY := 0.
	ticks := OrderedCollection new.
	self models
		do:
			[:each | 
			(self valuesBlock value: each)
				do:
					[:value | 
					x := (value - self getMinX) * self xScale.
					ticks
						add:
							((ESDataObject
								newWithShape:
									(LineSegment
										from: x @ ((currY + self leftGap) * self availHeight - 1)
										to: x @ ((currY + 1 - self rightGap) * self availHeight)))
								color: (self tickColor value: value))].
			currY := currY + 1]! !

!ESRangeDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
defaultControllerClass
	
	^VisualizationController! !

!ESRangeDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
deviationDescription
	
	^self xDeviationDescription! !

!ESRangeDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
deviationDescription: aString
	
	^self xDeviationDescription: aString! !

!ESRangeDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
deviationValue
	
	^self xDeviationValue! !

!ESRangeDiagram methodsFor: 'accessing' stamp: 'AlexandreBergel 12/8/2011 13:00'!
deviationValue: aNumber
	"Check ESSingleAxisDiagram>> deviationValue: for a description"
	
	self xDeviationValue: aNumber! !

!ESRangeDiagram methodsFor: 'displaying' stamp: ' 11/3/11 16:41'!
displayGrid
	
	| availHeight |
	availHeight := self contentHeight / self models size asFloat.
	self models
		doWithIndex:
			[:each :currY | 
			(LineSegment
				from: 0 @ ((currY - 1) * availHeight + (availHeight / 2))
				to: self xAxis end x @ (currY * availHeight - (availHeight / 2)))
				displayStrokedOn: (self layerHolder activeLayer paint: Color gray)]! !

!ESRangeDiagram methodsFor: 'displaying' stamp: 'AndreHora 3/29/2011 16:57'!
displayOn: aGraphicsContext
	
	super displayOn: aGraphicsContext.
	self layerHolder setActiveLayer: 'content'.
	self showGrid ifTrue: [self displayGrid].
	self elements
		do: [:each | each displayFilledOn: self layerHolder activeLayer].
	self layerHolder activeLayer paint: Color black.
	self ticks
		ifNotNil:
			[self ticks
				do: [:each | each displayStrokedOn: self layerHolder activeLayer]].
	self layerHolder setActiveLayer: 'yAxis'.
	self yAxis displayOn: self layerHolder activeLayer.
	self layerHolder setActiveLayer: 'xAxis'.
	self xAxis displayOn: self layerHolder activeLayer.
	self layerHolder setActiveLayer: 'content'.
	self deviationValue
		ifNotNil:
			[(self xAxisStrategy getDeviationLine: self)
				displayStrokedOn: (self layerHolder activeLayer paint: self axisColor)]! !

!ESRangeDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
getBaseAxis
	
	^self yAxis! !

!ESRangeDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
getValueAxis
	
	^self xAxis! !

!ESRangeDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
hasMovedBaseAxis
	
	^self hasMovedYAxis! !

!ESRangeDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
hasMovedValueAxis
	
	^self hasMovedXAxis! !

!ESRangeDiagram methodsFor: 'initialize-release' stamp: 'AndreHora 4/1/2011 16:21'!
initialize
	"Initialize a newly created instance. This method must answer the receiver."
	
	super initialize.	"self gapFraction: 1/5."
	self rotatedLabels: true.
	self hasOrientationLeftRight: true.
	self hasOrientationBottomTop: false.
	self showGrid: true.
	self tickColor: [:each | Color darkGray].! !

!ESRangeDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
maxX
	
	^maxX! !

!ESRangeDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
maxX: anObject
	
	maxX := anObject! !

!ESRangeDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
minX
	
	^minX! !

!ESRangeDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
minX: anObject
	
	minX := anObject! !

!ESRangeDiagram methodsFor: 'private' stamp: ' 11/3/11 16:41'!
setAxesStrategies
	
	super setAxesStrategies! !

!ESRangeDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
setBaseAxis: anAxis
	
	self yAxis: anAxis! !

!ESRangeDiagram methodsFor: 'creating' stamp: ' 11/3/11 16:41'!
setModels
	
	! !

!ESRangeDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
setValueAxis: anAxis
	
	self xAxis: anAxis! !

!ESRangeDiagram methodsFor: 'private' stamp: 'AndreHora 4/5/2011 11:39'!
setXAxisValues
	"only set minValue, when the user has not set one"
	
	| visibleValues |
	(self xAxis minValue == 0 and: [self values minValue ~= nil])
		ifTrue: [self xAxis minValue: self values minValue].
	self preferredAxisMaxX isNil
		ifTrue: [self xAxis maxValue: (self values maximumValue: [:each | each])]
		ifFalse: [self xAxis preferedMaxValue: self preferredAxisMaxX].	"only add values to axis, which are in the desired range"
	visibleValues := OrderedCollection new.
	self values
		do:
			[:each | 
			(each <= self getMaxX and: [each >= self getMinX])
				ifTrue: [visibleValues add: each]].
	self xAxis values: visibleValues.
	self xAxis maxValue: (visibleValues maximumValue: [:each | each]).
	self xAxis rotatedLabels: self rotatedLabels.
	self xAxis labelRepresentation: self labels.
	super setXAxisValues! !

!ESRangeDiagram methodsFor: 'private' stamp: 'AndreHora 4/6/2011 16:11'!
setYAxisValues
	
	self identifier
		ifNotNil:
			[self yAxis values: self identifiers.
			self yAxis: (ESIdentifierDecorator new anAxis: self yAxis)].
	super setYAxisValues! !

!ESRangeDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
showGrid
	
	^showGrid! !

!ESRangeDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
showGrid: anObject
	
	showGrid := anObject! !

!ESRangeDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
tickColor
	
	^tickColor! !

!ESRangeDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
tickColor: anObject
	
	tickColor := anObject! !

!ESRangeDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
ticks
	
	^ticks! !

!ESRangeDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
ticks: anObject
	
	ticks := anObject! !

!ESRangeDiagram methodsFor: 'creating' stamp: ' 11/3/11 16:41'!
unit
	
	^(self getMaxX - self getMinX) / self contentWidth asFloat! !

!ESRangeDiagram methodsFor: 'evaluating' stamp: ' 11/3/11 16:41'!
values
	
	| temp |
	temp := OrderedCollection new.
	self models
		do:
			[:each | 
			temp add: (self minX value: each).
			temp add: (self maxX value: each)].
	temp removeAllSuchThat: [:each2 | each2 == nil].
	^temp! !

!ESRangeDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
valuesBlock
	
	^valuesBlock! !

!ESRangeDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
valuesBlock: anObject
	
	valuesBlock := anObject! !

!ESRangeDiagram methodsFor: 'creating' stamp: ' 11/3/11 16:41'!
xScale
	
	^xAxis scaleFactor! !

ESAbstractBarDiagram subclass: #ESStackDiagram
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EyeSee-Core'!

!ESStackDiagram methodsFor: 'scripting' stamp: ' 11/3/11 16:41'!
addBaseDecorator: aDecorator
	
	self addXDecorator: aDecorator! !

!ESStackDiagram methodsFor: 'scripting' stamp: ' 11/3/11 16:41'!
addValueDecorator: aDecorator
	
	self addYDecorator: aDecorator! !

!ESStackDiagram methodsFor: 'creating' stamp: 'TudorGirba 4/5/2011 22:35'!
createElements
	
	| currY yScale |
	currY := 0.
	yScale := self yAxis scaleFactor.
	self values
		do:
			[:each | 
			| currRectangle |
			currRectangle := ESDataObject
				newWithShape:
					(Rectangle
						origin: 0 @ (currY * yScale)
						corner: self barWidth @ ((each + currY) * yScale)).
			self elements add: currRectangle.
			currY := currY + each]! !

!ESStackDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
deviationDescription
	
	^self yDeviationDescription! !

!ESStackDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
deviationDescription: aString
	
	^self yDeviationDescription: aString! !

!ESStackDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
deviationValue
	
	^self yDeviationValue! !

!ESStackDiagram methodsFor: 'accessing' stamp: 'AlexandreBergel 12/8/2011 13:00'!
deviationValue: aNumber
	"Check ESSingleAxisDiagram>> deviationValue: for a description"
	
	self yDeviationValue: aNumber! !

!ESStackDiagram methodsFor: 'displaying' stamp: 'AndreHora 3/29/2011 17:37'!
displayOn: aGraphicsContext

	"self halt."
	
	super displayOn: aGraphicsContext.
	self layerHolder setActiveLayer: 'content'.
	self elements
		do:
			[:each | each displayFilledOn: (self layerHolder activeLayer paint: each color)].
	self layerHolder setActiveLayer: 'xAxis'.
	self xAxis displayOn: self layerHolder activeLayer.
	self layerHolder setActiveLayer: 'yAxis'.
	self yAxis displayOn: self layerHolder activeLayer! !

!ESStackDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
getBaseAxis
	
	^self xAxis! !

!ESStackDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
getValueAxis
	
	^self yAxis! !

!ESStackDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
hasMovedBaseAxis
	
	^self hasMovedXAxis! !

!ESStackDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
hasMovedValueAxis
	
	^self hasMovedYAxis! !

!ESStackDiagram methodsFor: 'initialize-release' stamp: 'AndreHora 4/11/2011 22:32'!
initialize
	"Initialize a newly created instance. This method must answer the receiver."
	
	super initialize.
	self barWidth: 50.
	self labels: [:each | each asString , '%'].
	horizontalLegend := false.
	self hasOrientationLeftRight: true.
	self hasOrientationBottomTop: true.! !

!ESStackDiagram methodsFor: 'private' stamp: ' 11/3/11 16:41'!
setAxesStrategies
	
	super setAxesStrategies! !

!ESStackDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
setBaseAxis: anAxis
	
	self xAxis: anAxis! !

!ESStackDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
setValueAxis: anAxis
	
	self yAxis: anAxis! !

!ESStackDiagram methodsFor: 'private' stamp: 'AndreHora 4/5/2011 11:37'!
setYAxisValues
	
	| yValues |
	yValues := self models collect: self y.
	self yAxis values: yValues.
	self yAxis maxValue: yValues sum.
	self yAxis labelRepresentation: self labels.
	super setYAxisValues! !

!ESStackDiagram methodsFor: 'private' stamp: 'AndreHora 4/6/2011 00:08'!
setup
	
	self color ifNil: [self setLinearFill].
	self addYDecorator: ESStackedValueDecorator new.
	super setup! !

ESAbstractBarDiagram subclass: #ESVerticalBarDiagram
	instanceVariableNames: 'showLabelsOnBars barLabels'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EyeSee-Core'!

!ESVerticalBarDiagram commentStamp: '<historical>' prior: 0!
HorizontalBarDiagram has not been commented.  The comment should state the purpose of the class and also explain any unobvious aspects of the implementation.

Instance Variables:
	yScale	<ArithmeticValue>	the scale value 
	yStep	<SmallInteger>		in what steps the ticks on the y axis are displayed (usually 1/5/10)

!

ESVerticalBarDiagram subclass: #ESDeviationDiagram
	instanceVariableNames: 'colorAboveAverage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EyeSee-Core'!

!ESDeviationDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
colorAboveAverage
	
	^colorAboveAverage! !

!ESDeviationDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
colorAboveAverage: anObject
	
	colorAboveAverage := anObject! !

!ESDeviationDiagram methodsFor: 'creating' stamp: 'TudorGirba 4/5/2011 22:35'!
createElements
	
	| i offset availWidth axisScale |
	i := 0.
	axisScale := self yAxis scaleFactor.	"offset represents the actual pixel value of the deviation"
	self yAxis minValue < 0
		ifTrue: [offset := self deviationValue * axisScale]
		ifFalse:
			[offset := (self deviationValue - self yAxis minValue) * axisScale].
	availWidth := self contentWidth / self values size asFloat.
	self values
		do:
			[:each | 
			| currBar originY cornerY eachValue |
			self yAxis minValue < 0
				ifTrue: [eachValue := each * axisScale]
				ifFalse: [eachValue := (each - self yAxis minValue) * axisScale].
			each < self deviationValue
				ifTrue:
					[originY := eachValue.
					cornerY := offset]
				ifFalse:
					[originY := offset.
					cornerY := eachValue].
			currBar := ESDataObject
				newWithShape:
					(Rectangle
						origin: 0 @ originY
						corner: (availWidth * self barFraction) @ cornerY).
			currBar moveBy: (i * availWidth + (availWidth * self leftGap)) @ 0.	"TODO move to setColor"	"	self colorAboveAverage ifNotNil: 
					[(each > self deviationValue and: [self colorAboveAverage]) 
						ifTrue: [currBar color: ColorValue pink].
					(each < self deviationValue and: [self colorAboveAverage not]) 
						ifTrue: [currBar color: ColorValue pink]]."
			self elements add: currBar.
			i := i + 1]! !

!ESDeviationDiagram methodsFor: 'displaying' stamp: ' 11/3/11 16:41'!
displayOn: aGraphicsContext
	"Draws the bars and deviationLine on aDiagram"
	
	super displayOn: aGraphicsContext.
	self layerHolder setActiveLayer: 'content'.
	(self yAxisStrategy getDeviationLine: self)
		displayStrokedOn: (self layerHolder activeLayer paint: self axisColor).
	(self yAxisStrategy getDeviationDescriptionLabel: self)
		displayOn: (self layerHolder activeLayer paint: self axisColor)! !

!ESDeviationDiagram methodsFor: 'scripting' stamp: ' 11/3/11 16:41'!
highlightAboveDeviation
	
	self colorAboveAverage: true! !

!ESDeviationDiagram methodsFor: 'scripting' stamp: ' 11/3/11 16:41'!
highlightBelowDeviation
	
	self colorAboveAverage: false! !

!ESDeviationDiagram methodsFor: 'initialize-release' stamp: 'AndreHora 4/11/2011 22:31'!
initialize
	
	super initialize.
	self
		labels:
			[:each | 
			| label |
			label := ''.
			each value > self deviationValue ifTrue: [label := '+'].
			label := label , (each value - self deviationValue) asString].! !

!ESDeviationDiagram methodsFor: 'scripting' stamp: 'AndreHora 4/11/2011 22:29'!
labelsInPercent
	
	self
		labels:
			[:each | 
			| label |
			each value > self deviationValue
				ifTrue: [label := '+']
				ifFalse: [label := ''].
			label := label
				,
					(each value / self deviationValue * 100 - 100 asFloat roundTo: 0.01)
						asString , '%']! !

!ESDeviationDiagram methodsFor: 'private' stamp: ' 11/3/11 16:41'!
setYAxisValues
	
	super setYAxisValues.
	self preferredAxisMinY isNil
		ifTrue:
			[self values size > 0
				ifTrue: [self yAxis minValue: (self values minValue: [:each | each])]]
		ifFalse: [self yAxis minValue: self preferredAxisMinY]! !

!ESDeviationDiagram methodsFor: 'initialize-release' stamp: 'AndreHora 3/29/2011 16:32'!
setup
	"by default the average of the values is used to tell where the deviationLine is"
	
	self deviationValue
		ifNil: [self deviationValue: self values average asFloat].
	(self colorAboveAverage notNil and: [self color isNil])
		ifTrue:
			[self colorAboveAverage
				ifTrue:
					[self availableColors: {Color gray. Color red}.
					self color: [:each | (self y value: each) > self deviationValue]].
			self colorAboveAverage not
				ifTrue:
					[self availableColors: {Color red. Color gray}.
					self color: [:each | (self y value: each) < self deviationValue]].
			self displayLegend: false].
	super setup! !

ESVerticalBarDiagram subclass: #ESHisto
	instanceVariableNames: 'numberOfIntervals property'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EyeSee-Core'!

!ESHisto methodsFor: 'visualization protocol' stamp: ' 11/3/11 16:41'!
atPoint: aPoint
	
	! !

!ESHisto methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
identifiers
	
	^(self models keys collect: self identifier) asOrderedCollection! !

!ESHisto methodsFor: 'initialize-release' stamp: ' 11/3/11 16:41'!
initialize
	
	self numberOfIntervals: 10.
	super initialize! !

!ESHisto methodsFor: 'accessing' stamp: 'TudorGirba 4/7/2011 12:32'!
intervalSize
	
	| highestValue |
	highestValue := models
		maximumValue: [:each | self property value: each].	"extracts highhest number for this property"
	^highestValue / self numberOfIntervals! !

!ESHisto methodsFor: 'accessing' stamp: 'TudorGirba 4/7/2011 12:30'!
models
	
	| barDiagramModel |
	barDiagramModel := models groupedBy:
			[:each | (self property value: each) // self intervalSize].
	0
		to: self numberOfIntervals - 1
		do:
			[:i | 
			barDiagramModel
				at: i
				ifAbsentPut: [OrderedCollection new]].
	^barDiagramModel! !

!ESHisto methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
numberOfIntervals
	
	^numberOfIntervals! !

!ESHisto methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
numberOfIntervals: anObject
	
	numberOfIntervals := anObject! !

!ESHisto methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
property
	
	^property! !

!ESHisto methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
property: anObject
	
	property := anObject! !

!ESHisto methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
setModels
	
	! !

!ESHisto methodsFor: 'accessing' stamp: 'TudorGirba 4/7/2011 12:34'!
values
	
	self identifier: [:each |
		((each + 1) * self intervalSize) asFloat printString].
	^(self models associations sort:[:a :b | a key < b key ])
		collect: [:each | each value size]! !

!ESVerticalBarDiagram methodsFor: 'scripting' stamp: ' 11/3/11 16:41'!
addBaseDecorator: aDecorator
	
	self addXDecorator: aDecorator! !

!ESVerticalBarDiagram methodsFor: 'scripting' stamp: ' 11/3/11 16:41'!
addValueDecorator: aDecorator
	
	self addYDecorator: aDecorator! !

!ESVerticalBarDiagram methodsFor: 'creating' stamp: ' 11/3/11 16:41'!
availableWidth
	
	^self centerBars
		ifTrue: [self contentWidth / (self values size - 1)]
		ifFalse: [self contentWidth / self values size]! !

!ESVerticalBarDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
barLabels
	
	^barLabels! !

!ESVerticalBarDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
barLabels: anObject
	
	barLabels := anObject! !

!ESVerticalBarDiagram methodsFor: 'creating' stamp: 'TudorGirba 10/1/2012 09:05'!
createElements
	
	| bars |	

	bars := OrderedCollection new.
	self values
		do:
			[:each | 
			bars
				add:
					((ESDataObject new)
						shape:
								(Rectangle
										origin: 0 @ 0
										extent: 1 @ each);
						model: each;
						borderWidth: self borderWidth)].
	self setPositions: bars.
	self showLabelsOnBars
		ifTrue:
			[barLabels := bars
				collect:
					[:each | 
					(ESTextDataObject new)
						model: each model asString;
						compositionWidth: each width;
						color: Color lightGray;
						alignment: #center;
						textStyle: self getAxisTextStyle;
						position: each bounds left @ each bounds height]]! !

!ESVerticalBarDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
deviationDescription
	
	^self yDeviationDescription! !

!ESVerticalBarDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
deviationDescription: aString
	
	^self yDeviationDescription: aString! !

!ESVerticalBarDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
deviationValue
	
	^self yDeviationValue! !

!ESVerticalBarDiagram methodsFor: 'accessing' stamp: 'AlexandreBergel 12/8/2011 13:00'!
deviationValue: aNumber
	"Check ESSingleAxisDiagram>> deviationValue: for a description"
	
	self yDeviationValue: aNumber! !

!ESVerticalBarDiagram methodsFor: 'displaying' stamp: 'AndreHora 7/5/2011 17:01'!
displayOn: aGraphicsContext
	
	super displayOn: aGraphicsContext.
	self layerHolder setActiveLayer: 'content'.
	self elements
		do:
			[:each | each displayFilledOn: (self layerHolder activeLayer )].
	self layerHolder setActiveLayer: 'xAxis'.
	self xAxis displayOn: self layerHolder activeLayer.
	self layerHolder setActiveLayer: 'yAxis'.
	self yAxis displayOn: self layerHolder activeLayer.
	
	"TODO"
	self layerHolder setActiveLayer: 'content'.
	self barLabels
		ifNotNil:
			[self barLabels do: [:each | each displayOn: self layerHolder activeLayer]].
	self deviationValue
		ifNotNil:
			[(self yAxisStrategy getDeviationLine: self)
				displayStrokedOn: (self layerHolder activeLayer paint: self axisColor).
			(self yAxisStrategy getDeviationDescriptionLabel: self)
				displayOn: (self layerHolder activeLayer paint: self axisColor)]! !

!ESVerticalBarDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
getBaseAxis
	
	^self xAxis! !

!ESVerticalBarDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
getValueAxis
	
	^self yAxis! !

!ESVerticalBarDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
hasMovedBaseAxis
	
	^self hasMovedXAxis! !

!ESVerticalBarDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
hasMovedValueAxis
	
	^self hasMovedYAxis! !

!ESVerticalBarDiagram methodsFor: 'initialize-release' stamp: 'AndreHora 6/5/2012 13:29'!
initialize
	
	super initialize.
	self hasOrientationLeftRight: true.
	self hasOrientationBottomTop: true.
	self showLabelsOnBars: false! !

!ESVerticalBarDiagram methodsFor: 'private' stamp: ' 11/3/11 16:41'!
setAxesStrategies
	
	super setAxesStrategies! !

!ESVerticalBarDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
setBaseAxis: anAxis
	
	self xAxis: anAxis! !

!ESVerticalBarDiagram methodsFor: 'creating' stamp: 'AndreHora 6/5/2012 10:28'!
setPositions: aCollection
	
	| usedBarWidth availWidth |
	availWidth := self availableWidth.
	self barWidth = nil
		ifTrue: [usedBarWidth := availWidth * self barFraction]
		ifFalse: [usedBarWidth := barWidth].
	aCollection
		doWithIndex:
			[:each :i | 
			| scaledBar |

			scaledBar := each scaledBy: usedBarWidth @ self yAxis scaleFactor.
			self centerBars
				ifTrue:
					[scaledBar := scaledBar
						moveBy: ((i - 1) * availWidth - (usedBarWidth / 2)) @ 0]
				ifFalse:
					[scaledBar := scaledBar
						moveBy: ((i - 1) * availWidth + (availWidth * self leftGap)) @ 0].
			self elements add: scaledBar]! !

!ESVerticalBarDiagram methodsFor: 'private' stamp: ' 11/3/11 16:41'!
setScaleAndTranslation
	
	super setScaleAndTranslation.
	self yAxis minValue < 0
		ifTrue:
			[self contentTranslation: 0 @ self values minValue * self yAxis scaleFactor]! !

!ESVerticalBarDiagram methodsFor: 'private' stamp: ' 11/3/11 16:41'!
setUpperLowerBorder
	
	super setUpperLowerBorder.
	self showLabelsOnBars
		ifTrue: [self upperBorder: self upperBorder + self defaultFontSize]! !

!ESVerticalBarDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
setValueAxis: anAxis
	
	self yAxis: anAxis! !

!ESVerticalBarDiagram methodsFor: 'private' stamp: 'AndreHora 6/6/2011 15:23'!
setXAxisValues
	
	self xAxis rotatedLabels: self rotatedLabels.
	self identifier
		ifNotNil:
			[self xAxis values: self identifiers.
			self xAxis: (ESIdentifierDecorator new anAxis: self xAxis)].
	self yAxis gridLineLenght: self contentWidth.
	super setXAxisValues! !

!ESVerticalBarDiagram methodsFor: 'private' stamp: 'AndreHora 4/5/2011 11:37'!
setYAxisValues
	
	self yAxis values: self values.
	self preferredAxisMaxY isNil
		ifTrue:
			[self values size > 0
				ifTrue:
					[self yAxis values: self values.
					self yAxis maxValue: self values maxValue]]
		ifFalse: [self yAxis preferedMaxValue: self preferredAxisMaxY].
	(self values size > 0 and: [self values minValue < 0])
		ifTrue: [self yAxis minValue: self values minValue].
	self yAxis labelRepresentation: self labels.
	super setYAxisValues! !

!ESVerticalBarDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
showLabelsOnBars
	
	^showLabelsOnBars! !

!ESVerticalBarDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
showLabelsOnBars: anObject
	
	showLabelsOnBars := anObject! !

ESSingleAxisDiagram subclass: #ESHistoryDiagram
	instanceVariableNames: 'piledValues dataset attribute'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EyeSee-Core'!

!ESHistoryDiagram methodsFor: 'scripting' stamp: ' 11/3/11 16:41'!
addBaseDecorator: aDecorator
	
	self addXDecorator: aDecorator! !

!ESHistoryDiagram methodsFor: 'scripting' stamp: ' 11/3/11 16:41'!
addValueDecorator: aDecorator
	
	self addYDecorator: aDecorator! !

!ESHistoryDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
attribute
	
	^attribute! !

!ESHistoryDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
attribute: anObject
	
	attribute := anObject! !

!ESHistoryDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
availableLineWidth
	
	^self contentWidth
		/
			(((self models collect: self dataset) collect: #size) maxValue - 1) asFloat	"the size of the first collection ist the size of all collections"! !

!ESHistoryDiagram methodsFor: 'creating' stamp: 'TudorGirba 4/12/2011 15:17'!
createElements
	
	| x availLineWidth line datalines baseline |
	line := OrderedCollection new.
	datalines := OrderedCollection new.
	x := 0.
	availLineWidth := self availableLineWidth.
	self piledValues
		do:
			[:aCollection | 
			x := 0.
			line := OrderedCollection new.
			aCollection
				do:
					[:each | 
					line add: (x * availLineWidth) @ (each * self yAxis scaleFactor).
					x := x + 1].
			datalines add: line].
	baseline := OrderedCollection new.
	baseline add: "Point zero" 0 @ 0.
	baseline add: self xAxis end.
	datalines addFirst: baseline.
	datalines
		overlappingPairsDo:
			[:aCollection :anotherCollection | 
			self elements
				add:
					(ESDataObject
						newWithShape:
							(self createPolyline: aCollection with: anotherCollection))]! !

!ESHistoryDiagram methodsFor: 'creating' stamp: ' 11/3/11 16:41'!
createPiledValues
	
	| combination |
	combination := OrderedCollection new.
	piledValues := OrderedCollection new.
	(self models collect: self dataset)
		do:
			[:aCollection | combination add: (aCollection collect: self attribute)].	"combination holds now the collections of y values (not sumed up yet)"	"we have to calculate all values that we will get from piling the lines on another"	"keep the first collection"
	self piledValues add: combination first.	"add the second collection to the first and store these values"
	2
		to: combination size
		do:
			[:i | self piledValues add: (self piledValues last sumUp: (combination at: i))]! !

!ESHistoryDiagram methodsFor: 'creating' stamp: 'AndreHora 3/25/2011 12:36'!
createPolyline: aCollection with: aCollection2
	
	| temp |
	temp := OrderedCollection new.
	temp addAll: aCollection.
	aCollection2 reverseDo: [:each | temp add: each].
	^PathShape vertices: temp! !

!ESHistoryDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
dataset
	
	^dataset! !

!ESHistoryDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
dataset: anObject
	
	dataset := anObject! !

!ESHistoryDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
deviationDescription
	
	^self yDeviationDescription! !

!ESHistoryDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
deviationDescription: aString
	
	^self yDeviationDescription: aString! !

!ESHistoryDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
deviationValue
	
	^self yDeviationValue! !

!ESHistoryDiagram methodsFor: 'accessing' stamp: 'AlexandreBergel 12/8/2011 13:00'!
deviationValue: aNumber
	"Check ESSingleAxisDiagram>> deviationValue: for a description"	

	self yDeviationValue: aNumber! !

!ESHistoryDiagram methodsFor: 'displaying' stamp: ' 11/3/11 16:41'!
displayOn: aGraphicsContext
	
	super displayOn: aGraphicsContext.
	self layerHolder setActiveLayer: 'content'.
	self displayPolygons.
	self layerHolder setActiveLayer: 'yAxis'.
	self yAxis displayOn: self layerHolder activeLayer.
	self layerHolder setActiveLayer: 'xAxis'.
	self xAxis displayOn: self layerHolder activeLayer! !

!ESHistoryDiagram methodsFor: 'displaying' stamp: ' 11/3/11 16:41'!
displayPolygons
	
	| currLayer |
	currLayer := self layerHolder activeLayer.
	self elements do: [:each | each displayFilledOn: currLayer]! !

!ESHistoryDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
getBaseAxis
	
	^self xAxis! !

!ESHistoryDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
getValueAxis
	
	^self yAxis! !

!ESHistoryDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
hasMovedBaseAxis
	
	^self hasMovedXAxis! !

!ESHistoryDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
hasMovedValueAxis
	
	^self hasMovedYAxis! !

!ESHistoryDiagram methodsFor: 'private' stamp: ' 11/3/11 16:41'!
hasValues
	
	^true! !

!ESHistoryDiagram methodsFor: 'initialize-release' stamp: 'AndreHora 4/1/2011 16:21'!
initialize
	"Initialize a newly created instance. This method must answer the receiver."
	
	super initialize.
	self hasOrientationLeftRight: true.
	self hasOrientationBottomTop: true.! !

!ESHistoryDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
piledValues
	
	piledValues ifNil: [self createPiledValues].
	^piledValues! !

!ESHistoryDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
piledValues: anObject
	
	piledValues := anObject! !

!ESHistoryDiagram methodsFor: 'private' stamp: ' 11/3/11 16:41'!
setAxesStrategies
	
	super setAxesStrategies! !

!ESHistoryDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
setBaseAxis: anAxis
	
	self xAxis: anAxis! !

!ESHistoryDiagram methodsFor: 'private' stamp: 'AndreHora 4/12/2011 12:02'!
setColors
	"by default, every polygon line should be colored differently, so we use
	a little trick here, if no color block is set"
	
	self color isNil ifTrue: [self color: [:each | each hash]].
	self availableColors size < self elements size
		ifTrue: [self availableColors: (ESAbstractDiagram getGrayColors: self elements size)].
	super setColors! !

!ESHistoryDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
setValueAxis: anAxis
	
	self yAxis: anAxis! !

!ESHistoryDiagram methodsFor: 'private' stamp: ' 11/3/11 16:41'!
setXAxisValues
	
	self yAxis gridLineLenght: self contentWidth.
	super setXAxisValues! !

!ESHistoryDiagram methodsFor: 'private' stamp: 'AndreHora 4/5/2011 11:39'!
setYAxisValues
	
	| possibleValues |
	possibleValues := OrderedCollection new.	"wecan get collections of piled values  stored in  piledValues. But for the axis we want them as one big collection"
	self piledValues do: [:each | possibleValues addAll: each].
	self yAxis values: possibleValues.
	self preferredAxisMaxY isNil
		ifTrue: [self yAxis maxValue: (possibleValues maximumValue: [:each | each])]
		ifFalse: [self yAxis preferedMaxValue: self preferredAxisMaxY].
	self yAxis rotatedLabels: self rotatedLabels.
	self yAxis labelRepresentation: self labels.
	super setYAxisValues! !

!ESHistoryDiagram methodsFor: 'private' stamp: ' 11/3/11 16:41'!
setup
	
	self createPiledValues.
	self color isNil
		ifTrue:
			[self color: [:each | each hash].
			self displayLegend: false].
	super setup! !

ESHistoryDiagram subclass: #ESVerticalHistoryDiagram
	instanceVariableNames: 'lines'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EyeSee-Core'!

!ESVerticalHistoryDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
availableLineWidth
	
	^self contentWidth / (self models size - 1) asFloat	"the size of the first collection ist the size of all collections"! !

!ESVerticalHistoryDiagram methodsFor: 'creating' stamp: ' 11/3/11 16:41'!
createPiledValues
	
	| verticalValues keys |
	piledValues := OrderedCollection new.
	verticalValues := self models collect: [:each | self dataset value: each].
	keys := (verticalValues flatCollect: #keys) asSet.
	lines := Dictionary new.
	verticalValues
		do:
			[:each | 
			keys
				do:
					[:key | 
					(lines
						at: key
						ifAbsent:
							[lines
								at: key
								put: OrderedCollection new])
						add: (self attribute value: key value: each)]].
	lines := lines associations.
	self piledValues add: lines first value.
	2
		to: lines size
		do:
			[:i | 
			self piledValues
				add: (self piledValues last value sumUp: (lines at: i) value)]! !

!ESVerticalHistoryDiagram methodsFor: 'creating' stamp: 'AndreHora 4/12/2011 11:59'!
setColors
	
	self color
		ifNotNil:
			[self elements
				do:
					[:each | 
					each
						color:
							(self colorDict
								at: (self color value: each model)
								ifAbsent:
									[self colorDict
										at: (self color value: each model)
										put: ESAbstractDiagram lightColors last])]]! !

!ESVerticalHistoryDiagram methodsFor: 'creating' stamp: ' 11/3/11 16:41'!
setModels
	
	lines
		with: self elements
		do: [:value :model | model model: value key]! !

ESSingleAxisDiagram subclass: #ESLineDiagram
	instanceVariableNames: 'dotSize mathematical lineWidth'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EyeSee-Core'!

!ESLineDiagram methodsFor: 'scripting' stamp: ' 11/3/11 16:41'!
addBaseDecorator: aDecorator
	
	self addXDecorator: aDecorator! !

!ESLineDiagram methodsFor: 'scripting' stamp: ' 11/3/11 16:41'!
addValueDecorator: aDecorator
	
	self addYDecorator: aDecorator! !

!ESLineDiagram methodsFor: 'visualization protocol' stamp: ' 11/3/11 16:41'!
atPoint: aPoint
	
	| found point |
	point := self transformPoint: aPoint.
	self elements
		do:
			[:each | 
			found := each
				atXValue: point x
				tolerance: self toleranceValue.
			found ifNotNil: [^found]].
	^nil! !

!ESLineDiagram methodsFor: 'creating' stamp: ' 11/3/11 16:41'!
createElements
	
	self mathematical
		ifTrue: [self createMathematicalElements]
		ifFalse: [self createOrdinaryElements]! !

!ESLineDiagram methodsFor: 'creating' stamp: 'TudorGirba 4/5/2011 22:35'!
createMathematicalElements
	
	| availLineWidth |
	availLineWidth := self contentWidth / (self values size - 1).
	self values
		doWithIndex:
			[:each :i | 
			self elements
				add:
					(ESDataObject
						newWithShape:
							(Circle new
								center: ((i - 1) * availLineWidth) @ (each * self yAxis scaleFactor)
								radius: self dotSize))]! !

!ESLineDiagram methodsFor: 'creating' stamp: 'TudorGirba 4/5/2011 22:35'!
createOrdinaryElements
	
	| x availLineWidth |
	x := 0.
	availLineWidth := self contentWidth / self values size.
	self values
		do:
			[:each | 
			self elements
				add:
					(ESDataObject
						newWithShape:
							(Circle new
								center: (x * availLineWidth + (availLineWidth / 2.0) @ ((each - self yAxis minValue) * self yAxis scaleFactor))
								radius: self dotSize)).
			x := x + 1]! !

!ESLineDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
deviationDescription
	
	^self yDeviationDescription! !

!ESLineDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
deviationDescription: aString
	
	^self yDeviationDescription: aString! !

!ESLineDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
deviationValue
	
	^self yDeviationValue! !

!ESLineDiagram methodsFor: 'accessing' stamp: 'AlexandreBergel 12/8/2011 13:00'!
deviationValue: aNumber
	"Check ESSingleAxisDiagram>> deviationValue: for a description"
	
	self yDeviationValue: aNumber! !

!ESLineDiagram methodsFor: 'displaying' stamp: 'AndreHora 3/24/2011 17:09'!
displayOn: aGraphicsContext
	
	super displayOn: aGraphicsContext.
	self layerHolder setActiveLayer: 'content'.
	self elements size > 0
		ifTrue:
			[self elements first displayFilledOn: self layerHolder activeLayer].
	self elements size > 1
		ifTrue:
			[| oldLineWidth |
			oldLineWidth := self layerHolder activeLayer lineWidth.
			self layerHolder activeLayer lineWidth: lineWidth.
			(PathShape vertices: (self elements collect: [:each | each shape center]))
				displayStrokedOn:
					(self layerHolder activeLayer paint: self defaultColor).
			self layerHolder activeLayer lineWidth: oldLineWidth].
	self layerHolder setActiveLayer: 'yAxis'.
	self yAxis displayOn: self layerHolder activeLayer.
	self layerHolder setActiveLayer: 'xAxis'.
	self xAxis displayOn: self layerHolder activeLayer.
	self layerHolder setActiveLayer: 'content'.
	self deviationValue
		ifNotNil:
			[(self yAxisStrategy getDeviationLine: self)
				displayStrokedOn: (self layerHolder activeLayer paint: self axisColor).
			(self yAxisStrategy getDeviationDescriptionLabel: self)
				displayOn: (self layerHolder activeLayer paint: self axisColor)]	"self deviationValue ifNotNil: [self displayDeviationLine]."! !

!ESLineDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
dotSize
	
	^dotSize! !

!ESLineDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
dotSize: anObject
	
	dotSize := anObject! !

!ESLineDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
getBaseAxis
	
	^self xAxis! !

!ESLineDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
getValueAxis
	
	^self yAxis! !

!ESLineDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
hasMovedBaseAxis
	
	^self hasMovedXAxis! !

!ESLineDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
hasMovedValueAxis
	
	^self hasMovedYAxis! !

!ESLineDiagram methodsFor: 'scripting' stamp: ' 11/3/11 16:41'!
hideDots
	
	self dotSize: 0! !

!ESLineDiagram methodsFor: 'initialize-release' stamp: 'AndreHora 4/1/2011 16:21'!
initialize
	"Initialize a newly created instance. This method must answer the receiver."
	
	super initialize.
	self defaultColor: Color black.
	self dotSize: 0.
	self lineWidth: 1.
	self mathematical: false.
	self hasOrientationLeftRight: true.
	self hasOrientationBottomTop: true.! !

!ESLineDiagram methodsFor: 'scripting' stamp: ' 11/3/11 16:41'!
lineColor: aColor
	
	self defaultColor: aColor asColor! !

!ESLineDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
lineWidth
	
	^lineWidth! !

!ESLineDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
lineWidth: anObject
	
	lineWidth := anObject! !

!ESLineDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
mathematical
	
	^mathematical! !

!ESLineDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
mathematical: anObject
	
	mathematical := anObject! !

!ESLineDiagram methodsFor: 'private' stamp: ' 11/3/11 16:41'!
setAxesStrategies
	
	super setAxesStrategies! !

!ESLineDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
setBaseAxis: anAxis
	
	self xAxis: anAxis! !

!ESLineDiagram methodsFor: 'private' stamp: ' 11/3/11 16:41'!
setScaleAndTranslation
	
	super setScaleAndTranslation.
	self yAxis minValue < 0
		ifTrue:
			[self xAxisTranslation: 0 @ self yAxis minValue * self yAxis scaleFactor]! !

!ESLineDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
setValueAxis: anAxis
	
	self yAxis: anAxis! !

!ESLineDiagram methodsFor: 'private' stamp: 'AndreHora 6/6/2011 15:28'!
setXAxisValues

	self xAxis rotatedLabels: self rotatedLabels.
	self identifier
		ifNotNil:
			[self xAxis values: self identifiers.
			self xAxis: (ESIdentifierDecorator new anAxis: self xAxis)].
	self yAxis gridLineLenght: self contentWidth.
	super setXAxisValues! !

!ESLineDiagram methodsFor: 'private' stamp: 'AndreHora 6/6/2011 15:14'!
setYAxisValues
	
	self yAxis values: self values.
	self preferredAxisMaxY isNil
		ifTrue: [self yAxis maxValue: (self values maximumValue: [:each | each])]
		ifFalse: [self yAxis preferedMaxValue: self preferredAxisMaxY].
	self values size > 0
		ifTrue:
			[self values minValue < 0
				ifTrue: [self yAxis minValue: self values minValue]].
	self preferredAxisMinY
		ifNotNil: [self yAxis preferedMinValue: self preferredAxisMinY].
	self yAxis labelRepresentation: self labels.
	super setYAxisValues! !

!ESLineDiagram methodsFor: 'scripting' stamp: ' 11/3/11 16:41'!
startLineAtZero
	
	self mathematical: true! !

!ESLineDiagram methodsFor: 'visualization protocol' stamp: ' 11/3/11 16:41'!
toleranceValue
	
	self values size = 1 ifTrue: [^self contentWidth].
	^self contentWidth / (self values size - 1) / 2.0! !

!ESSingleAxisDiagram methodsFor: 'scripting' stamp: ' 11/3/11 16:41'!
addBaseDecorator: aDecorator
	
	self subclassResponsibility! !

!ESSingleAxisDiagram methodsFor: 'scripting' stamp: ' 11/3/11 16:41'!
addValueDecorator: aDecorator
	
	self subclassResponsibility! !

!ESSingleAxisDiagram methodsFor: 'scripting' stamp: 'AndreHora 4/5/2011 23:56'!
baseAxisLine
	
	self addBaseDecorator: ESBaseLineDecorator new! !

!ESSingleAxisDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
deviationDescription
	
	self subclassResponsibility	"
	deviationDescription isNil 
		ifTrue: [^deviationValue displayString]
		ifFalse: [^deviationDescription]"! !

!ESSingleAxisDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
deviationDescription: anObject
	
	self subclassResponsibility! !

!ESSingleAxisDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
deviationValue
	
	self subclassResponsibility! !

!ESSingleAxisDiagram methodsFor: 'accessing' stamp: 'AlexandreBergel 12/8/2011 12:57'!
deviationValue: anObject
	"It draws a line at the level aNumber with the label #deviationDescription: in the chart. This is used when you want to set a reference for example"
	
	self subclassResponsibility! !

!ESSingleAxisDiagram methodsFor: 'displaying' stamp: ' 11/3/11 16:41'!
displayOn: aGraphicsContext
	
	super displayOn: aGraphicsContext! !

!ESSingleAxisDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
getBaseAxis
	
	self subclassResponsibility! !

!ESSingleAxisDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
getValueAxis
	
	self subclassResponsibility! !

!ESSingleAxisDiagram methodsFor: 'scripting' stamp: 'TudorGirba 4/5/2011 22:59'!
gridLine
	
	self addValueDecorator: ESRegularGridLineDecorator new! !

!ESSingleAxisDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
hasMovedBaseAxis
	
	self subclassResponsibility! !

!ESSingleAxisDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
hasMovedValueAxis
	
	self subclassResponsibility! !

!ESSingleAxisDiagram methodsFor: 'private' stamp: ' 11/3/11 16:41'!
hasValues
	
	^self values isEmpty not! !

!ESSingleAxisDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
identifier
	
	^identifier! !

!ESSingleAxisDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
identifier: anObject
	
	identifier := anObject! !

!ESSingleAxisDiagram methodsFor: 'evaluating' stamp: ' 11/3/11 16:41'!
identifiers
	
	^self models collect: self identifier! !

!ESSingleAxisDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
label: anObject
	
	label := anObject! !

!ESSingleAxisDiagram methodsFor: 'advanced scripting' stamp: ' 11/3/11 16:41'!
regularAxis
	
	self regularTicks.
	self regularLabels.
	self baseAxisLine.
	self valueAxisLine! !

!ESSingleAxisDiagram methodsFor: 'scripting' stamp: 'AndreHora 4/5/2011 23:56'!
regularLabels
	
	self addValueDecorator: ESRegularLabelDecorator new! !

!ESSingleAxisDiagram methodsFor: 'scripting' stamp: 'AndreHora 4/5/2011 23:56'!
regularTicks
	
	self addValueDecorator: ESRegularTickDecorator new! !

!ESSingleAxisDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
setBaseAxis: anAxis
	
	self subclassResponsibility! !

!ESSingleAxisDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
setValueAxis: anAxis
	
	self subclassResponsibility! !

!ESSingleAxisDiagram methodsFor: 'advanced scripting' stamp: ' 11/3/11 16:41'!
valueAxis
	
	self valueTicks.
	self valueLabels.
	self baseAxisLine.
	self valueAxisLine! !

!ESSingleAxisDiagram methodsFor: 'scripting' stamp: 'AndreHora 4/5/2011 23:56'!
valueAxisLine
	
	self addValueDecorator: ESBaseLineDecorator new! !

!ESSingleAxisDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
valueBlock
	
	^valueBlock! !

!ESSingleAxisDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
valueBlock: anObject
	
	valueBlock := anObject! !

!ESSingleAxisDiagram methodsFor: 'scripting' stamp: 'AndreHora 4/5/2011 23:55'!
valueLabels
	
	self addValueDecorator: ESValueLabelDecorator new! !

!ESSingleAxisDiagram methodsFor: 'scripting' stamp: 'AndreHora 4/5/2011 23:55'!
valueTicks
	
	self addValueDecorator: ESValueTickDecorator new! !

!ESSingleAxisDiagram methodsFor: 'evaluating' stamp: ' 11/3/11 16:41'!
values
	
	^cachedValues
		ifNil: [cachedValues := self models collect: self valueBlock]! !

!ESSingleAxisDiagram methodsFor: 'scripting' stamp: ' 11/3/11 16:41'!
x
	
	^self valueBlock! !

!ESSingleAxisDiagram methodsFor: 'scripting' stamp: ' 11/3/11 16:41'!
x: aBlock
	
	self valueBlock: aBlock! !

!ESSingleAxisDiagram methodsFor: 'scripting' stamp: ' 11/3/11 16:41'!
y
	
	^self valueBlock! !

!ESSingleAxisDiagram methodsFor: 'scripting' stamp: ' 11/3/11 16:41'!
y: aBlock
	
	self valueBlock: aBlock! !

ESAbstract2DDiagram subclass: #ESTable
	instanceVariableNames: 'rowLabels columnLabels verticalCellPadding horizontalCellPadding rowBlock columnBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EyeSee-Core'!

!ESTable methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
availableHeight
	
	^self contentHeight / self models size asFloat! !

!ESTable methodsFor: 'private' stamp: ' 11/3/11 16:41'!
basicHeightOfRow: aNumber
	
	^((self elements select: [:each | each model i = aNumber])
		collect: [:each | each shape height]) maxValue! !

!ESTable methodsFor: 'private' stamp: ' 11/3/11 16:41'!
basicWidthOfColumn: aNumber
	
	^((self elements select: [:each | each model j = aNumber])
		collect: [:each | each shape width]) maxValue! !

!ESTable methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
columnBlock
	
	^columnBlock! !

!ESTable methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
columnBlock: anObject
	
	columnBlock := anObject! !

!ESTable methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
columnLabels
	
	^columnLabels! !

!ESTable methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
columnLabels: anObject
	
	columnLabels := anObject! !

!ESTable methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
columns
	
	^self columnBlock value: self models! !

!ESTable methodsFor: 'creating' stamp: 'TudorGirba 4/5/2011 22:35'!
createElements
	
	| dataObject string alignment |
	self rows
		doWithIndex:
			[:row :i | 
			row
				doWithIndex:
					[:each :j | 
					each isString
						ifTrue:
							[string := each.
							alignment := #left]
						ifFalse:
							[string := each printString.
							alignment := #right].
					dataObject := (ESTableCell new)
						model: (i matrixPointWith: j);
						alignment: alignment;
						text: string;
						textStyle: self getDefaultTextStyle.
					self elements add: dataObject]].
	self setPositions! !

!ESTable methodsFor: 'displaying' stamp: ' 11/3/11 16:41'!
displayOn: aGraphicsContext
	
	super displayOn: aGraphicsContext.
	self layerHolder setActiveLayer: 'content'.
	self elements do: [:each | each displayOn: self layerHolder activeLayer]! !

!ESTable methodsFor: 'private' stamp: ' 11/3/11 16:41'!
hasValues
	
	self rows do: [:row | row do: [:element | element notNil ifTrue: [^true]]].
	^false! !

!ESTable methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
height
	
	(height isNil or: [self elements isEmpty or: [self elements isNil]])
		ifTrue:
			[self createElements.
			self height: self totalHeight].
	^height! !

!ESTable methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
horizontalCellPadding
	
	^horizontalCellPadding	"| numberOfColumns |
	numberOfColumns := self models first size.
	^(self contentWidth
		-
			((1 to: numberOfColumns)
				collect: [:columnIndex | self basicWidthOfColumn: columnIndex]) sum)
		/ (numberOfColumns - 1)"! !

!ESTable methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
horizontalCellPadding: anObject
	
	horizontalCellPadding := anObject! !

!ESTable methodsFor: 'initialize-release' stamp: 'AndreHora 4/1/2011 16:22'!
initialize
	"Initialize a newly created instance. This method must answer the receiver."
	
	super initialize.
	self hasOrientationBottomTop: false.
	self hasOrientationLeftRight: true.
	self horizontalCellPadding: 5.
	self verticalCellPadding: 2.
	self height: nil.
	self width: nil.! !

!ESTable methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
matrix
	
	^self models! !

!ESTable methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
matrix: aMatrix
	
	self models: aMatrix! !

!ESTable methodsFor: 'private' stamp: ' 11/3/11 16:41'!
positionOfColumn: aNumber
	
	^(1 to: aNumber - 1)
		inject: 0
		into: [:sum :each | sum + (self widthOfColumn: each)]! !

!ESTable methodsFor: 'private' stamp: ' 11/3/11 16:41'!
positionOfRow: aNumber
	
	^(1 to: aNumber - 1)
		inject: 0
		into: [:sum :each | sum + (self basicHeightOfRow: each)]! !

!ESTable methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
rowBlock
	
	^rowBlock! !

!ESTable methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
rowBlock: anObject
	
	rowBlock := anObject! !

!ESTable methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
rowLabels
	
	^rowLabels! !

!ESTable methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
rowLabels: anObject
	
	rowLabels := anObject! !

!ESTable methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
rows
	
	^self rowBlock value: self models! !

!ESTable methodsFor: 'private' stamp: ' 11/3/11 16:41'!
setModels
	
	! !

!ESTable methodsFor: 'creating' stamp: ' 11/3/11 16:41'!
setPositions
	
	| currXPosition currYPosition |
	self elements
		do:
			[:each | 
			currXPosition := self positionOfColumn: each model j.
			currYPosition := self positionOfRow: each model i.
			each
				setBoundsTo:
					(Rectangle
						origin: (currXPosition + horizontalCellPadding) @ currYPosition
						extent:
							((self widthOfColumn: each model j) - horizontalCellPadding)
								@ each shape height)]! !

!ESTable methodsFor: 'private' stamp: ' 11/3/11 16:41'!
totalHeight
	
	| totalHeight |
	totalHeight := 0.
	1
		to: self rows size
		do: [:i | totalHeight := totalHeight + (self basicHeightOfRow: i)].
	^totalHeight + (2 * self yPadding)! !

!ESTable methodsFor: 'private' stamp: ' 11/3/11 16:41'!
totalWidth
	
	^(self rows first
		collectWithIndex:
			[:each :i | (self basicWidthOfColumn: i) + self horizontalCellPadding])
		sum + (2 * xPadding)! !

!ESTable methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
verticalCellPadding
	
	^verticalCellPadding! !

!ESTable methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
verticalCellPadding: anObject
	
	verticalCellPadding := anObject! !

!ESTable methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
width
	
	(width isNil or: [self elements isEmpty or: [self elements isNil]])
		ifTrue:
			[self createElements.
			self width: self totalWidth].
	^width! !

!ESTable methodsFor: 'private' stamp: ' 11/3/11 16:41'!
widthOfColumn: aNumber
	
	^(self basicWidthOfColumn: aNumber) + self horizontalCellPadding! !

!ESAbstractDiagram class methodsFor: 'constants' stamp: ' 11/3/11 16:41'!
alignCentered
	
	^'center'! !

!ESAbstractDiagram class methodsFor: 'constants' stamp: ' 11/3/11 16:41'!
alignLeft
	
	^'left'! !

!ESAbstractDiagram class methodsFor: 'constants' stamp: ' 11/3/11 16:41'!
alignRight
	
	^'right'! !

!ESAbstractDiagram class methodsFor: 'colors' stamp: 'AndreHora 10/13/2011 16:24'!
distinctGrayColors

	^ (OrderedCollection new)
		add: (Color 
					h: 0
					s: 0
					v: 0.3);
		add: (Color 
					h: 0
					s: 0
					v: 0.5);
		add: (Color 
					h: 0
					s: 0
					v: 0.75);
		add: (Color 
					h: 0
					s: 0
					v: 0.95);
		yourself! !

!ESAbstractDiagram class methodsFor: 'colors' stamp: 'AndreHora 9/23/2011 21:32'!
getColors: aNumber
	
	| step i colors |
	
	[aNumber ~= 0] assert.
	step := 360 / aNumber.
	colors := OrderedCollection new.
	i := 0.
	[i < 360]
		whileTrue:
			[colors
				add:
					(Color
						h: i
						s: 0.5
						v: 1).
			i := i + step].
	^colors! !

!ESAbstractDiagram class methodsFor: 'colors' stamp: 'AndreHora 9/23/2011 21:32'!
getGrayColors: aNumber
	
	| step i colors |
	
	[aNumber ~= 0] assert.
	step := 0.75 / aNumber.
	colors := OrderedCollection new.
	i := 0.25.
	[i < 1]
		whileTrue:
			[colors add: (Color h: 0 s: 0 v: i).
			i := i + step].
	^colors! !

!ESAbstractDiagram class methodsFor: 'colors' stamp: 'AndreHora 9/23/2011 21:30'!
getTemperatureColors: aNumber
	
	| step i colors |

	[aNumber ~= 0] assert.
	step := 180 / aNumber.
	colors := OrderedCollection new.
	i := 0.
	[i < 360]
		whileTrue:
			[colors
				add:
					(Color
						h: i
						s: 1
						v: 1).
			i := i + step].
	^colors! !

!ESAbstractDiagram class methodsFor: 'colors' stamp: 'AndreHora 10/13/2011 16:24'!
lightColors

	^ OrderedCollection new
		"red"
		add: (Color 
					h: Color red hue
					s: 0.3
					v: Color red brightness);
		"blue"
		add: (Color 
					h: Color blue hue
					s: 0.3
					v: Color blue brightness);
		"orange"
		add: (Color 
					h: Color orange hue
					s: 0.3
					v: Color orange brightness);
		"cyan"
		add: (Color 
					h: Color cyan hue
					s: 0.3 
					v: Color cyan brightness );
		"green"
		add: (Color 
					h: Color lightGreen hue
					s: 0.1
					v: 0.7);
		"pink"
		add: (Color 
					h: ESAbstractDiagram pink hue
					s: 0.1
					v: ESAbstractDiagram pink brightness);
		"brown"
		add: (Color 
					h: Color brown hue
					s: 0.2
					v: 1 );
		"purple"
		add: (Color 
					h: ESAbstractDiagram purple hue
					s: 0.2
					v: ESAbstractDiagram purple brightness );
		"yellow"
		add: (Color 
					h: Color yellow hue
					s: 0.3
					v: Color yellow brightness);
		"gray"
		add: (Color veryLightGray);
		yourself;


		yourself! !

!ESAbstractDiagram class methodsFor: 'colors' stamp: 'AndreHora 2/12/2012 00:51'!
lightColorsTransparent

	^ self lightColorsTransparent: 0.3! !

!ESAbstractDiagram class methodsFor: 'colors' stamp: 'AndreHora 2/12/2012 00:51'!
lightColorsTransparent: alpha

	^ self lightColors collect: [ :each | each alpha: alpha]! !

!ESAbstractDiagram class methodsFor: 'colors' stamp: 'AndreHora 10/13/2011 16:24'!
pink

 	^ Color r: 1.0 g: 0.752899 b: 0.796118.! !

!ESAbstractDiagram class methodsFor: 'colors' stamp: 'AndreHora 10/13/2011 16:24'!
purple

 	^ Color r: 0.4 g: 0.0 b: 0.6.! !

!ESAbstractDiagram class methodsFor: 'colors' stamp: 'AndreHora 10/13/2011 16:24'!
strongColors

	^ (OrderedCollection new)
			add: Color red;
			add: Color blue;
			add: Color orange;
			add: Color cyan;
			add: Color green;
			add: ESAbstractDiagram pink;
			add: Color brown;
			add: ESAbstractDiagram purple;
			add: Color yellow;
			add: Color gray;
			yourself! !

!ESAbstractDiagram class methodsFor: 'colors' stamp: 'AndreHora 2/12/2012 00:51'!
strongColorsTransparent

	^ self strongColorsTransparent: 0.3! !

!ESAbstractDiagram class methodsFor: 'colors' stamp: 'AndreHora 2/12/2012 00:51'!
strongColorsTransparent: alpha

	^ self strongColors collect: [ :each | each alpha: alpha]! !

!ESAbstractDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
addDecorator: aVisualPart at: aSymbol
	
	decorators at: aSymbol put: aVisualPart! !

!ESAbstractDiagram methodsFor: 'scripting' stamp: ' 11/3/11 16:41'!
alignTitleLeft
	
	titleAlignment := self class alignLeft! !

!ESAbstractDiagram methodsFor: 'announce' stamp: 'AndreHora 4/15/2011 16:53'!
announcer

	^ announcer! !

!ESAbstractDiagram methodsFor: 'announce' stamp: 'AndreHora 4/13/2011 13:05'!
announcer: anAnnouncer

	announcer := anAnnouncer! !

!ESAbstractDiagram methodsFor: 'visualization protocol' stamp: 'AndreHora 6/19/2011 17:19'!
atPoint: aPoint
	
	| found |
	(found := self
		findObjectIn: self elements
		forPoint: aPoint
		inLayer: 'content') ifNotNil: [^ found].
	^ nil! !

!ESAbstractDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
availableColors
	
	^availableColors! !

!ESAbstractDiagram methodsFor: 'accessing' stamp: 'AndreHora 3/21/2011 12:19'!
availableColors: anObject
	
	availableColors := anObject collect: [:each | each asColor]! !

!ESAbstractDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
axisColor
	
	^axisColor! !

!ESAbstractDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
axisColor: aColor
	
	axisColor := aColor asColor! !

!ESAbstractDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
axisFontSize
	
	^axisFontSize! !

!ESAbstractDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
axisFontSize: anObject
	
	axisFontSize := anObject! !

!ESAbstractDiagram methodsFor: 'accessing' stamp: 'AndreHora 7/23/2011 22:27'!
borderWidth

	^ borderWidth! !

!ESAbstractDiagram methodsFor: 'accessing' stamp: 'AndreHora 7/23/2011 22:27'!
borderWidth: aNumber

	borderWidth := aNumber! !

!ESAbstractDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
bottomDecoration
	
	^decorators
		at: #bottom
		ifAbsent: [nil]! !

!ESAbstractDiagram methodsFor: 'displaying' stamp: ' 11/3/11 16:41'!
bottomDecorationLayer: aGraphicsContext
	
	self subclassResponsibility! !

!ESAbstractDiagram methodsFor: 'visualization protocol' stamp: ' 11/3/11 16:41'!
bounds
	
	^Rectangle
		origin: 0 @ 0
		extent: self width @ self height! !

!ESAbstractDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
bounds: aRectangle
	
	! !

!ESAbstractDiagram methodsFor: 'scripting' stamp: ' 11/3/11 16:41'!
centerTitle
	
	titleAlignment := self class alignCentered! !

!ESAbstractDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
color
	
	^color! !

!ESAbstractDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
color: anObject
	
	color := anObject! !

!ESAbstractDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
colorDict
	
	^colorDict! !

!ESAbstractDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
colorDict: anObject
	
	colorDict := anObject! !

!ESAbstractDiagram methodsFor: 'evaluating' stamp: ' 11/3/11 16:41'!
colorValues
	" returns a collection of colors corresponding to values "
	
	| colValues |
	colValues := self models collect: self color.
	^colValues
		collect:
			[:each | 
			each isColor
				ifTrue: [each]
				ifFalse:
					[self colorDict
						at: each
						ifAbsent:
							[self colorDict
								at: each
								put: Color gray]]]! !

!ESAbstractDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
container: anObject
	
	! !

!ESAbstractDiagram methodsFor: 'evaluating' stamp: ' 11/3/11 16:41'!
contentHeight
	"gets the height available for the actual diagram elements"
	
	^self height - (2 * self yPadding) - self upperBorder - self lowerBorder! !

!ESAbstractDiagram methodsFor: 'displaying' stamp: 'AndreHora 6/6/2012 14:43'!
contentLayer: aGraphicsContext
	
	| gc |

	gc := (self gcWrapper copy)
		context: aGraphicsContext;
		scale: self scale * self contentScale;
		translation: self diagramTranslation + self padding + self leftTopBorder;
		yourself.
	"gc font: self getDefaultFont."
	self translateToContent: gc.
	^gc! !

!ESAbstractDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
contentScale
	
	^contentScale! !

!ESAbstractDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
contentScale: anObject
	
	contentScale := anObject! !

!ESAbstractDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
contentTranslation
	
	^contentTranslation! !

!ESAbstractDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
contentTranslation: anObject
	
	contentTranslation := anObject! !

!ESAbstractDiagram methodsFor: 'evaluating' stamp: 'AndreHora 4/1/2012 21:11'!
contentWidth
	"gets the width available for the actual diagram elements"
	
	^ self width - self xPadding - self leftBorder - self rightBorder! !

!ESAbstractDiagram methodsFor: 'private' stamp: ' 11/3/11 16:41'!
createAxis
	
	self subclassResponsibility! !

!ESAbstractDiagram methodsFor: 'initialize-release' stamp: 'AndreHora 9/23/2011 23:00'!
createColorDict
	
	(self color notNil and: [self colorDict isEmpty])
		ifTrue:
			[| keys values |

			keys := (self models collect: self color) asOrderedCollection removeDuplicates.
			values := fillColor isNil
				ifTrue: [self availableColors]
				ifFalse: [self models collect: self fillColor].
			keys size > values size
				ifTrue: [self availableColors: (ESAbstractDiagram getColors: keys size).
						values := self availableColors].
			self
				colorDict:
					(Dictionary
						keys: keys
						values: values)]! !

!ESAbstractDiagram methodsFor: 'creating' stamp: ' 11/3/11 16:41'!
createElements
	
	self subclassResponsibility! !

!ESAbstractDiagram methodsFor: 'creating' stamp: 'usmanbhatti 6/5/2012 17:19'!
createLegend
	self legend isNil
		ifTrue:
			[horizontalLegend
				ifTrue: [legend := ESHorizontalLegend new]
				ifFalse: [legend := ESVerticalLegend new]].
	(self colorDict notNil and: [self colorDict notEmpty])
		ifTrue:
			[(self legend)
				legendTextBlock: self legendTextBlock;
				container: self;
				origin: self legendOrigin;
				width: self legendWidth;
				height: self legendHeight;
				models: self colorDict associations asOrderedCollection;
				yourself]! !

!ESAbstractDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
defaultColor
	
	^defaultColor! !

!ESAbstractDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
defaultColor: anObject
	
	defaultColor := anObject asColor! !

!ESAbstractDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
defaultFontSize
	
	^defaultFontSize! !

!ESAbstractDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
defaultFontSize: anObject
	
	defaultFontSize := anObject! !

!ESAbstractDiagram methodsFor: 'selection' stamp: 'AndreHora 4/27/2011 13:51'!
deselectAll

	self elements do: [ :each | each deselect ].! !

!ESAbstractDiagram methodsFor: 'displaying' stamp: 'AndreHora 3/15/2011 16:51'!
diagramLayer: aGraphicsContext
	
	| gc |
	gc := self gcWrapper copy context: aGraphicsContext.
	"gc font: self getDefaultFont." "andre"
	^gc! !

!ESAbstractDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
diagramTitle
	
	^diagramTitle! !

!ESAbstractDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
diagramTitle: anObject
	
	diagramTitle := anObject! !

!ESAbstractDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
diagramTranslation
	
	^diagramTranslation! !

!ESAbstractDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
diagramTranslation: anObject
	
	diagramTranslation := anObject! !

!ESAbstractDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
displayLegend
	
	^displayLegend! !

!ESAbstractDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
displayLegend: anObject
	
	displayLegend := anObject! !

!ESAbstractDiagram methodsFor: 'displaying' stamp: ' 11/3/11 16:41'!
displayOn: aGraphicsContext
	
	self setupLayers: aGraphicsContext.
	self layerHolder setActiveLayer: 'topDecoration'.
	self topDecoration
		ifNotNil: [self topDecoration displayOn: self layerHolder activeLayer].
	self layerHolder setActiveLayer: 'bottomDecoration'.
	self bottomDecoration
		ifNotNil: [self bottomDecoration displayOn: self layerHolder activeLayer]! !

!ESAbstractDiagram methodsFor: 'displaying' stamp: 'AndreHora 3/21/2011 16:50'!
displayTitle: aGraphicsContext
	
	"aGraphicsContext font: self getTitleFont."
	self diagramTitle
		ifNotNil:
			[self diagramTitle
				displayStringOn: aGraphicsContext
				at: self getTitlePosition].
	"aGraphicsContext font: self getDefaultFont"! !

!ESAbstractDiagram methodsFor: 'displaying' stamp: ' 11/3/11 16:41'!
drawLegend: aGraphicsContext
	
	(self displayLegend and: [legend ~= nil])
		ifTrue: [legend displayOn: aGraphicsContext]! !

!ESAbstractDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
elements
	
	^elements! !

!ESAbstractDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
elements: anObject
	
	elements := anObject! !

!ESAbstractDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
extent
	
	^self width @ self height! !

!ESAbstractDiagram methodsFor: 'accessing' stamp: 'AndreHora 9/23/2011 23:03'!
fillColor

	^ fillColor! !

!ESAbstractDiagram methodsFor: 'accessing' stamp: 'AndreHora 9/23/2011 23:03'!
fillColor: aBlock
	
	self color: #yourself.
	fillColor := aBlock! !

!ESAbstractDiagram methodsFor: 'visualization protocol' stamp: 'AndreHora 6/5/2012 13:25'!
findObjectIn: aCollection forPoint: aPoint inLayer: aString
	
	| found point |
	point := self transformPoint: aPoint ofLayer: aString.
	point = nil ifTrue: [^ nil].
	aCollection
		ifNotNil:
			[aCollection
				do:
					[:each | 
					found := each atPoint: point.
					found ifNotNil: [^ found]]].
	^nil! !

!ESAbstractDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
gcWrapper
	
	^gcWrapper! !

!ESAbstractDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
gcWrapper: anObject
	
	gcWrapper := anObject! !

!ESAbstractDiagram methodsFor: 'private' stamp: ' 11/3/11 16:41'!
getAxisTextStyle
	
	^self getDefaultTextStyleWithSize: self axisFontSize! !

!ESAbstractDiagram methodsFor: 'private' stamp: 'AndreHora 3/21/2011 16:34'!
getDefaultFont
	
	^self getDefaultTextStyle defaultFont! !

!ESAbstractDiagram methodsFor: 'private' stamp: ' 11/3/11 16:41'!
getDefaultTextStyle
	
	^self getDefaultTextStyleWithSize: self defaultFontSize! !

!ESAbstractDiagram methodsFor: 'private' stamp: 'AndreHora 3/16/2011 16:13'!
getDefaultTextStyleWithSize: aNumber
	
"	| fd ca ta fontSize |
	(OSSystemSupport concreteClass includesBehavior: WinNTSystemSupport)
		ifTrue: [fontSize := (aNumber * (96 / 72.0) asFloat) rounded]
		ifFalse: [fontSize := aNumber].
	fd := (FontDescription new)
		family: #('verdana' 'helvetica' 'arial' 'times*' 'bookman' '*');
		pixelSize: fontSize.
	ca := CharacterAttributes newWithDefaultAttributes.
	ca setDefaultQuery: fd.
	ta := TextAttributes characterAttributes: ca.
	^t"
	"^ StrikeFont default pointSize: aNumber"
	"^ TextStyle default defaultFont pointSize: aNumber"
	"TODO: the size (aNumber"
	^ TextStyle default copy! !

!ESAbstractDiagram methodsFor: 'evaluating' stamp: 'AndreHora 4/12/2011 14:17'!
getTitlePosition
	"TODO"
	"ESHistoryDiagramtitleAlignment = self class alignCentered
		ifTrue:
			[^(self width / 2
				-
					((TextMeasurer
						defaultWidthOfString: self diagramTitle
						font: self getTitleFont) / 2)) @ (5 + self titleFontSize)]."
	^self xPadding @ (self yPadding + self titleFontSize)! !

!ESAbstractDiagram methodsFor: 'scripting' stamp: 'AndreHora 4/12/2011 12:00'!
grayShades
	
	self availableColors: ESAbstractDiagram distinctGrayColors! !

!ESAbstractDiagram methodsFor: 'private' stamp: ' 11/3/11 16:41'!
hasValues
	
	self subclassResponsibility! !

!ESAbstractDiagram methodsFor: 'accessing' stamp: 'AndreHora 4/1/2012 20:40'!
height
	
	^ height! !

!ESAbstractDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
height: anObject
	
	height := anObject! !

!ESAbstractDiagram methodsFor: 'scripting' stamp: ' 11/3/11 16:41'!
horizontalLegend
	
	horizontalLegend := true! !

!ESAbstractDiagram methodsFor: 'initialize-release' stamp: 'AndreHora 6/5/2012 13:08'!
initialize
	"Initialize a newly created instance. This method must answer the receiver."
	
	self width: 400.
	self height: 300.
	self models: OrderedCollection new.
	self xPadding: 20.
	self yPadding: 20.
	self leftBorder: 0.
	self upperBorder: 0.
	self rightBorder: 0.
	self lowerBorder: 0.
	self defaultFontSize: 12.
	self axisFontSize: 8.
	self labels: [:each | each].
	self titleFontSize: 18.	"self labels: 
			[:aNumber | 
			aNumber > 1000000 
				| (aNumber < 0.000001 & (aNumber > 0) | (aNumber < -1000000)) 
					ifTrue: [aNumber asFloat].
			aNumber isInteger ifFalse: [aNumber asFloat]. aNumber]."
	self scale: 1 asPoint.
	self contentScale: 1 asPoint.
	self diagramTranslation: 0 asPoint.
	self contentTranslation: 0 asPoint.
	self elements: OrderedCollection new.
	self layerHolder: ESLayerHolder new.
	self rotatedLabels: false.
	self axisColor: Color black.
	self defaultColor: Color gray.
	self legendOrigin: 0 @ 0.
	self borderWidth: 0.
	self gcWrapper: ESDiagramGraphicsContextWrapper new.
	horizontalLegend := true.
	decorators := Dictionary new.
	decorationPadding := 0.! !

!ESAbstractDiagram methodsFor: 'announce' stamp: 'AndreHora 4/13/2011 13:06'!
interaction

	^ self announcer! !

!ESAbstractDiagram methodsFor: 'accessing' stamp: 'AndreHora 4/1/2012 20:40'!
labelDistance
	
	^ labelDistance! !

!ESAbstractDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
labelDistance: anObject
	
	labelDistance := anObject! !

!ESAbstractDiagram methodsFor: 'accessing' stamp: 'AndreHora 4/1/2012 20:40'!
labels
	
	^ labels! !

!ESAbstractDiagram methodsFor: 'accessing' stamp: 'AlexandreBergel 12/9/2011 11:12'!
labels: aBlockOrASymbol
	"I set the label string in y axis. By default the labels is #yourself.
	Note that the labels appear only if you have set valueAxis.
	
	For example, if you want to have truncated float as labels, just do
	| diagram |
diagram := ESDiagramRenderer new.
(diagram lineDiagram)
	y: #yourself;
	labels: [ :each | each value asTruncatedFloat ];
	valueAxis;
	models: (1 to: 13) / 16.
diagram open
"

	labels := aBlockOrASymbol! !

!ESAbstractDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
layerHolder
	
	^layerHolder! !

!ESAbstractDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
layerHolder: anObject
	
	layerHolder := anObject! !

!ESAbstractDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
leftBorder
	
	^leftBorder! !

!ESAbstractDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
leftBorder: anObject
	
	leftBorder := anObject! !

!ESAbstractDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
leftDecoration
	
	^decorators
		at: #left
		ifAbsent: [nil]! !

!ESAbstractDiagram methodsFor: 'displaying' stamp: ' 11/3/11 16:41'!
leftDecorationLayer: aGraphicsContext
	
	self subclassResponsibility! !

!ESAbstractDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
leftTopBorder
	
	^self leftBorder @ self upperBorder! !

!ESAbstractDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
legend
	
	^legend! !

!ESAbstractDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
legend: anObject
	
	legend := anObject! !

!ESAbstractDiagram methodsFor: 'scripting' stamp: 'AndreHora 4/1/2012 19:56'!
legendAtTop
	
	legendOrigin := 
		(self width - self legendWidth - self xPadding) @ 
		self yPadding! !

!ESAbstractDiagram methodsFor: 'scripting' stamp: 'AndreHora 4/1/2012 19:56'!
legendBelow
	
	self displayLegend: true.
	legendOrigin := 
		self xPadding @ 
		(self height - (self legendHeight / 2) - self yPadding)! !

!ESAbstractDiagram methodsFor: 'accessing' stamp: 'AndreHora 4/1/2012 20:01'!
legendHeight

	horizontalLegend
		ifTrue: [^ legendHeight]
		ifFalse: [^ legendHeight * self colorDict size]! !

!ESAbstractDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
legendHeight: anObject
	
	legendHeight := anObject! !

!ESAbstractDiagram methodsFor: 'accessing' stamp: 'AndreHora 6/1/2012 14:46'!
legendOrigin
	
	horizontalLegend
		ifTrue: [^ self padding ]
		ifFalse: [^ (self width - self legendWidth - self xPadding) @ self yPadding]! !

!ESAbstractDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
legendOrigin: anObject
	
	legendOrigin := anObject! !

!ESAbstractDiagram methodsFor: 'announce' stamp: 'usmanbhatti 6/5/2012 17:17'!
legendTextBlock

	^ legendTextBlock! !

!ESAbstractDiagram methodsFor: 'accessing' stamp: 'usmanbhatti 6/5/2012 17:17'!
legendTextBlock: aBlock

	legendTextBlock := aBlock.! !

!ESAbstractDiagram methodsFor: 'accessing' stamp: 'AndreHora 4/1/2012 19:25'!
legendWidth
	
	legendWidth ifNotNil: [^ legendWidth].
	horizontalLegend
		ifTrue:  [ ^ self contentWidth]
		ifFalse: [ ^ self colorDict keys getMaxStringLengthForFont: self getDefaultFont]! !

!ESAbstractDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
legendWidth: anObject
	
	legendWidth := anObject! !

!ESAbstractDiagram methodsFor: 'scripting' stamp: 'AndreHora 4/12/2011 11:59'!
lightColors
	
	self availableColors: ESAbstractDiagram lightColors! !

!ESAbstractDiagram methodsFor: 'accessing' stamp: 'AndreHora 4/1/2012 19:31'!
lowerBorder
	
	^ lowerBorder! !

!ESAbstractDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
lowerBorder: anObject
	
	lowerBorder := anObject! !

!ESAbstractDiagram methodsFor: 'accessing' stamp: 'AndreHora 4/1/2012 19:31'!
models
	
	^ models! !

!ESAbstractDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
models: anObject
	
	models := anObject! !

!ESAbstractDiagram methodsFor: 'scripting' stamp: ' 11/3/11 16:41'!
noBorders
	
	self
		leftBorder: 0;
		rightBorder: 0;
		upperBorder: 0;
		lowerBorder: 0! !

!ESAbstractDiagram methodsFor: 'scripting' stamp: ' 11/3/11 16:41'!
noPadding
	
	self
		xPadding: 0;
		yPadding: 0! !

!ESAbstractDiagram methodsFor: 'accessing' stamp: 'AndreHora 4/1/2012 19:31'!
padding
	
	^ self xPadding @ self yPadding! !

!ESAbstractDiagram methodsFor: 'visualization protocol' stamp: ' 11/3/11 16:41'!
preferredBounds
	
	^0 asPoint extent: self width @ self height! !

!ESAbstractDiagram methodsFor: 'accessing' stamp: 'AndreHora 4/1/2012 19:38'!
rightBorder
	
	^ rightBorder! !

!ESAbstractDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
rightBorder: anObject
	
	rightBorder := anObject! !

!ESAbstractDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
rightDecoration
	
	^decorators
		at: #right
		ifAbsent: [nil]! !

!ESAbstractDiagram methodsFor: 'displaying' stamp: ' 11/3/11 16:41'!
rightDecorationLayer: aGraphicsContext
	
	self subclassResponsibility! !

!ESAbstractDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
rotatedLabels
	
	^rotatedLabels! !

!ESAbstractDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
rotatedLabels: anObject
	
	rotatedLabels := anObject! !

!ESAbstractDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
scale
	
	^scale! !

!ESAbstractDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
scale: anObject
	
	scale := anObject! !

!ESAbstractDiagram methodsFor: 'private' stamp: ' 11/3/11 16:41'!
setAxesColor
	
	self subclassResponsibility! !

!ESAbstractDiagram methodsFor: 'private' stamp: ' 11/3/11 16:41'!
setAxesStrategies
	
	self subclassResponsibility! !

!ESAbstractDiagram methodsFor: 'private' stamp: 'AndreHora 9/23/2011 20:48'!
setColors
	
	| colors |
	[self models ~= nil] assert.
	self color notNil
		ifTrue:
			[ colors := self colorValues
				copyFrom: 1
				to: self elements size.
			self elements
				with: colors
				do: [:each :color0 | each color: color0]]
		ifFalse:
			[self elements do: [:each | each defaultColor: self defaultColor]]! !

!ESAbstractDiagram methodsFor: 'private' stamp: ' 11/3/11 16:41'!
setLeftRightBorder
	
	self leftDecoration
		ifNotNil:
			[self
				leftBorder:
					self leftBorder + self leftDecoration bounds width
						+ (2 * decorationPadding)].
	self rightDecoration
		ifNotNil:
			[self
				rightBorder:
					self rightBorder + self rightDecoration bounds width
						+ (2 * decorationPadding)]! !

!ESAbstractDiagram methodsFor: 'private' stamp: 'TudorGirba 10/1/2012 13:12'!
setModels

	[self models ~= nil] assert.
	self elements doWithIndex: [:each :i | 
		each model: (self models at: i)]! !

!ESAbstractDiagram methodsFor: 'private' stamp: ' 11/3/11 16:41'!
setScaleAndTranslation
	"overwrite this method in subclasses to change the orientation of the coord system"
	
	! !

!ESAbstractDiagram methodsFor: 'private' stamp: 'AndreHora 6/1/2012 14:56'!
setUpperLowerBorder

	"Legend"

	(self color notNil and: [self displayLegend])
		ifTrue:
			[horizontalLegend
				ifTrue: [self upperBorder: self upperBorder + self legendHeight ]].
	self diagramTitle
		ifNotNil:
			[self upperBorder: (self upperBorder max: 2 * self titleFontSize)].
	self topDecoration
		ifNotNil:
			[self
				upperBorder:
					self upperBorder + self topDecoration height + (2 * decorationPadding)].
	self bottomDecoration
		ifNotNil:
			[self
				lowerBorder:
					self lowerBorder + self bottomDecoration height + (2 * decorationPadding)]! !

!ESAbstractDiagram methodsFor: 'initialize-release' stamp: 'AndreHora 10/6/2011 15:53'!
setup
	
	self elements: OrderedCollection new.
	self layerHolder: ESLayerHolder new.
	self availableColors
		ifNil: [self availableColors: ESAbstractDiagram distinctGrayColors].
	self createColorDict.
	self createAxis.
	self setScaleAndTranslation.
	self hasValues ifTrue: [self createElements].
	self setModels.
	self setColors.
	self displayLegend ifTrue: [self createLegend].
	decorators values do: [:each | each gcWrapper: self gcWrapper].
	self bottomDecoration
		ifNotNil: [self bottomDecoration width: self contentWidth].
	decorators values do: [:each | each setup]! !

!ESAbstractDiagram methodsFor: 'displaying' stamp: 'AndreHora 6/6/2012 16:10'!
setupLayers: aGraphicsContext
	
	self layerHolder
		addLayer: (self diagramLayer: aGraphicsContext)
		name: 'diagram'.
	self layerHolder
		addLayer: (self contentLayer: aGraphicsContext)
		name: 'content'.
	self topDecoration
		ifNotNil:
			[self layerHolder
				addLayer: (self topDecorationLayer: aGraphicsContext)
				name: 'topDecoration'].
	self bottomDecoration
		ifNotNil:
			[self layerHolder
				addLayer: (self bottomDecorationLayer: aGraphicsContext)
				name: 'bottomDecoration']! !

!ESAbstractDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
size: aPoint
	
	self width: aPoint x.
	self height: aPoint y! !

!ESAbstractDiagram methodsFor: 'scripting' stamp: 'AndreHora 4/12/2011 11:58'!
strongColors
	
	self availableColors: ESAbstractDiagram strongColors! !

!ESAbstractDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
titleAlignment
	
	^titleAlignment! !

!ESAbstractDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
titleAlignment: anObject
	
	titleAlignment := anObject! !

!ESAbstractDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
titleFontSize
	
	^titleFontHeight! !

!ESAbstractDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
titleFontSize: anObject
	
	titleFontHeight := anObject! !

!ESAbstractDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
topDecoration
	
	^decorators
		at: #top
		ifAbsent: [nil]! !

!ESAbstractDiagram methodsFor: 'displaying' stamp: ' 11/3/11 16:41'!
topDecorationLayer: aGraphicsContext
	
	self subclassResponsibility! !

!ESAbstractDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
totalLeftBorder
	
	^self xPadding + self leftBorder! !

!ESAbstractDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
totalUpperBorder
	
	^self yPadding + self upperBorder! !

!ESAbstractDiagram methodsFor: 'visualization protocol' stamp: ' 11/3/11 16:41'!
transformPoint: aPoint
	
	self layerHolder setActiveLayer: 'content'.
	^self layerHolder activeLayer isNil
		ifTrue: [^aPoint]
		ifFalse: [self layerHolder activeLayer inverseTransform: aPoint]! !

!ESAbstractDiagram methodsFor: 'visualization protocol' stamp: ' 11/3/11 16:41'!
transformPoint: aPoint ofLayer: aString
	
	self layerHolder setActiveLayer: aString.
	^self layerHolder activeLayer isNil
		ifTrue: [^nil]
		ifFalse: [self layerHolder activeLayer inverseTransform: aPoint]! !

!ESAbstractDiagram methodsFor: 'visualization protocol' stamp: ' 11/3/11 16:41'!
transformXAxisPoint: aPoint
	
	self layerHolder setActiveLayer: 'xAxis'.
	^self layerHolder activeLayer isNil
		ifTrue: [^nil]
		ifFalse: [self layerHolder activeLayer inverseTransform: aPoint]! !

!ESAbstractDiagram methodsFor: 'private' stamp: 'AndreHora 3/16/2011 14:14'!
translateToContent: aGraphicsContext
	
	aGraphicsContext translateBy: self contentTranslation! !

!ESAbstractDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
upperBorder
	
	^upperBorder! !

!ESAbstractDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
upperBorder: anObject
	
	upperBorder := anObject! !

!ESAbstractDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
use: aCollection
	"Deprecated, use models: aCollection instead"
	
	self models: aCollection! !

!ESAbstractDiagram methodsFor: 'scripting' stamp: ' 11/3/11 16:41'!
useColorDict: aDictionary
	
	colorDict := aDictionary! !

!ESAbstractDiagram methodsFor: 'scripting' stamp: ' 11/3/11 16:41'!
useColors: aCollection
	
	self availableColors: aCollection! !

!ESAbstractDiagram methodsFor: 'scripting' stamp: ' 11/3/11 16:41'!
verticalLegend
	
	horizontalLegend := false! !

!ESAbstractDiagram methodsFor: 'accessing' stamp: 'AndreHora 4/1/2012 20:57'!
width
	
	^ width! !

!ESAbstractDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
width: anObject
	
	width := anObject! !

!ESAbstractDiagram methodsFor: 'accessing' stamp: 'AndreHora 4/1/2012 20:57'!
xPadding
	
	^ xPadding! !

!ESAbstractDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
xPadding: anObject
	
	xPadding := anObject! !

!ESAbstractDiagram methodsFor: 'accessing' stamp: 'AndreHora 4/1/2012 20:57'!
yPadding
	
	^ yPadding! !

!ESAbstractDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
yPadding: anObject
	
	yPadding := anObject! !

ESAbstractDiagram subclass: #ESCompositeDiagram
	instanceVariableNames: 'diagrams'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EyeSee-Core'!

!ESCompositeDiagram methodsFor: 'changing' stamp: ' 11/3/11 16:41'!
add: aDiagram
	
	self diagrams add: aDiagram! !

!ESCompositeDiagram methodsFor: 'visualization protocol' stamp: 'AndreHora 6/19/2011 17:19'!
atPoint: aPoint
	
	| object |
	self diagrams do: [:each | 
		(object := each atPoint: aPoint) 
			ifNotNil: [^ object ] ].
	^ nil! !

!ESCompositeDiagram methodsFor: 'creating' stamp: 'AndreHora 6/19/2011 16:39'!
createElements! !

!ESCompositeDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
diagrams
	
	^diagrams! !

!ESCompositeDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
diagrams: anObject
	
	diagrams := anObject! !

!ESCompositeDiagram methodsFor: 'displaying' stamp: ' 11/3/11 16:41'!
displayOn: aGraphicsContext
	
	self diagrams do: [:each | each displayOn: aGraphicsContext]! !

!ESCompositeDiagram methodsFor: 'accessing' stamp: 'AndreHora 6/19/2011 16:41'!
elements

	^ diagrams flatCollect: #elements! !

!ESCompositeDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
gcWrapper: aGCWrapper
	
	super gcWrapper: aGCWrapper.
	self diagrams do: [:each | each gcWrapper: aGCWrapper]! !

!ESCompositeDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
height: aNumber
	
	self diagrams ifNotNil: [self diagrams do: [:each | each height: aNumber]].
	height := aNumber! !

!ESCompositeDiagram methodsFor: 'initialize-release' stamp: 'AndreHora 4/1/2011 16:22'!
initialize
	"Initialize a newly created instance. This method must answer the receiver."
	
	self diagrams: OrderedCollection new.
	super initialize.! !

!ESCompositeDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
preferredAxisMaxX: aNumber
	
	self diagrams do: [:each | each preferredAxisMaxX: aNumber]! !

!ESCompositeDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
preferredAxisMaxY: aNumber
	
	self diagrams do: [:each | each preferredAxisMaxY: aNumber]! !

!ESCompositeDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
preferredAxisMinX: aNumber
	
	self diagrams do: [:each | each preferredAxisMinX: aNumber]! !

!ESCompositeDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
preferredAxisMinY: aNumber
	
	self diagrams do: [:each | each preferredAxisMinY: aNumber]! !

!ESCompositeDiagram methodsFor: 'initialize-release' stamp: ' 11/3/11 16:41'!
setup
	
	self syncBorder.
	self diagrams do: [:each | each setup]! !

!ESCompositeDiagram methodsFor: 'initialize-release' stamp: ' 11/3/11 16:41'!
syncBorder
	
	| left right upper lower |
	left := right := upper := lower := 0.
	self diagrams do: [:each | each createAxis].
	self diagrams
		do:
			[:each | 
			each leftBorder > left ifTrue: [left := each leftBorder].
			each rightBorder > right ifTrue: [right := each rightBorder].
			each upperBorder > upper ifTrue: [upper := each upperBorder].
			each lowerBorder > lower ifTrue: [lower := each lowerBorder]].
	self diagrams
		do:
			[:each | 
			each
				leftBorder: left;
				rightBorder: right;
				upperBorder: upper;
				lowerBorder: lower]! !

!ESCompositeDiagram methodsFor: 'displaying' stamp: ' 11/3/11 16:41'!
topDecorationLayer: aGraphicsContext
	
	| gc |
	gc := (self gcWrapper copy)
		context: aGraphicsContext;
		scale: self scale;
		translation:
				self diagramTranslation
						+
							(self totalLeftBorder
								@
									(self totalUpperBorder - self xAxis height - self topDecoration height -
											decorationPadding));
		yourself.
	gc font: self getDefaultFont.
	^gc! !

!ESCompositeDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
width: aNumber
	
	self diagrams ifNotNil: [self diagrams do: [:each | each width: aNumber]].
	width := aNumber! !

!ESCompositeDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
xPadding: aNumber
	
	self diagrams
		ifNotNil: [self diagrams do: [:each | each xPadding: aNumber]].
	xPadding := aNumber! !

!ESCompositeDiagram methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
yPadding: aNumber
	
	self diagrams
		ifNotNil: [self diagrams do: [:each | each yPadding: aNumber]].
	yPadding := aNumber! !

Object subclass: #ESBrowser
	instanceVariableNames: 'canvas userCommands diagram'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EyeSee-Core'!

!ESBrowser class methodsFor: 'instance creation' stamp: 'AndreHora 3/19/2011 19:17'!
openOn: aDiagram
	^ (self new diagram: aDiagram) open  ! !

!ESBrowser methodsFor: 'morphic' stamp: 'HernanMoralesDurand 10/1/2012 16:03'!
addSubMenusTo: dock in: aWin

	dock 
		add: 'Export' translated
		font: aWin theme menuBarFont
		icon: nil
		help: 'Export' translated
		subMenu: self exportMenu.
	dock
		add: 'X Axis Decorator' translated
		font: aWin theme menuBarFont
		icon: nil
		help: 'X Axis Decorator' translated
		subMenu: self decoratorXMenu.
	dock
		add: 'Y Axis Decorator' translated
		font: aWin theme menuBarFont
		icon: nil
		help: 'Y Axis Decorator' translated
		subMenu: self decoratorYMenu.! !

!ESBrowser methodsFor: 'commands' stamp: 'AndreHora 3/15/2011 15:45'!
addUserCommand: aCommand
	self userCommands add: aCommand! !

!ESBrowser methodsFor: 'accessing' stamp: 'AndreHora 3/15/2011 15:45'!
canvas
	^ canvas! !

!ESBrowser methodsFor: 'morphic' stamp: 'HernanMoralesDurand 10/1/2012 16:20'!
decoratorXMenu

	| menuMorph |
	
	menuMorph := MenuMorph new.
	ESAbstractAxis allSubclassesDo: [: decoratorClass | 
		menuMorph 
				add: decoratorClass name
				target: self diagram
				selector: #addXDecorator:
				argument: decoratorClass new ].
	^ menuMorph! !

!ESBrowser methodsFor: 'morphic' stamp: 'HernanMoralesDurand 10/1/2012 16:22'!
decoratorYMenu

	| menuMorph |
	
	menuMorph := MenuMorph new.
	ESAbstractAxis allSubclassesDo: [: decoratorClass | 
		menuMorph 
				add: decoratorClass name
				target: self diagram
				selector: #addYDecorator:
				argument: decoratorClass new ].				
	^ menuMorph! !

!ESBrowser methodsFor: 'accessing' stamp: 'AndreHora 3/19/2011 19:14'!
diagram
	^ diagram! !

!ESBrowser methodsFor: 'accessing' stamp: 'AndreHora 3/19/2011 19:14'!
diagram: aDiagram
	diagram := aDiagram! !

!ESBrowser methodsFor: 'morphic' stamp: 'AndreHora 12/9/2011 20:34'!
exportAsGIF

	self canvas exportAsGIF! !

!ESBrowser methodsFor: 'morphic' stamp: 'AndreHora 12/9/2011 20:34'!
exportAsPNG

	self canvas exportAsPNG! !

!ESBrowser methodsFor: 'morphic' stamp: 'AndreHora 12/9/2011 20:57'!
exportMenu

	| menuMorph |
	
	menuMorph := MenuMorph new.
	menuMorph 
				add: 'Export as PNG'
				target: self
				selector: #exportAsPNG.
				
	menuMorph 
				add: 'Export as GIF'
				target: self
				selector: #exportAsGIF.
	^ menuMorph! !

!ESBrowser methodsFor: 'morphic' stamp: 'HernanMoralesDurand 10/1/2012 16:03'!
initializeButtonsIn: aWin

	| dock buttons offset |
	
	dock := aWin newToolDockingBar.

	self addSubMenusTo: dock in: aWin.
	offset := dock minExtent y.
	aWin 
		addMorph: dock
		fullFrame: (LayoutFrame 
					fractions: (0 @ 0 corner: 1 @ 0)
					offsets: (0 @ 0 corner: 0 @ offset))! !

!ESBrowser methodsFor: 'morphic' stamp: 'TudorGirba 4/12/2011 10:21'!
open
	^ self open: 'EyeSee Canvas'! !

!ESBrowser methodsFor: 'morphic' stamp: 'AndreHora 12/9/2011 20:36'!
open: windowLabel
	"The canvas needs to be accessed from outside, especially by the ViewRenderer. This is necessary for sharing the announcer between the canvas and the view"
	| window pane |
	window := StandardWindow labelled: windowLabel.
	window model: self.
	window extent: 640 @ 480.
		
	pane := ScrollPane new.
	
	canvas := ESCanvas onDiagram: diagram.
	self initializeButtonsIn: window.

	pane scroller addMorph: canvas.
	window 
		addMorph: pane
		fullFrame: (LayoutFrame fractions: (0 @ 0 corner: 1 @ 1) offsets: (0 @ 26 corner: 0 @ 0)).
	
	canvas updateBounds.
	window openInWorld.
	
	^ window! !

!ESBrowser methodsFor: 'morphic' stamp: 'AndreHora 3/15/2011 15:45'!
userCommands
	userCommands ifNil: [ userCommands := OrderedCollection new ].
	^ userCommands! !

!ESBrowser methodsFor: 'morphic' stamp: 'AndreHora 3/15/2011 16:12'!
windowIsClosing
	"canvas root allNodesDo: [ :n | n interaction stopProcesses ]"! !

Object subclass: #ESCross
	instanceVariableNames: 'origin barLength'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EyeSee-Core'!

!ESCross class methodsFor: 'instance creation' stamp: 'AndreHora 3/15/2011 14:59'!
center: aPoint radius: amount
	
	^self origin: aPoint barLength: amount! !

!ESCross class methodsFor: 'instance creation' stamp: 'AndreHora 3/15/2011 14:59'!
origin: aPoint barLength: amount
	
	^(self new)
		origin: aPoint;
		barLength: amount;
		yourself! !

!ESCross class methodsFor: 'instance creation' stamp: 'AndreHora 3/15/2011 14:59'!
origin: aPoint extent: aPoint2
	
	^(self new)
		origin: aPoint + (aPoint2 / 2);
		barLength: aPoint2 x / 2;
		yourself! !

!ESCross methodsFor: 'accessing' stamp: 'AndreHora 3/15/2011 14:59'!
barLength
	
	^barLength! !

!ESCross methodsFor: 'accessing' stamp: 'AndreHora 3/15/2011 14:59'!
barLength: anObject
	
	barLength := anObject! !

!ESCross methodsFor: 'private' stamp: 'AndreHora 3/15/2011 14:59'!
computeBounds
	
	^(Rectangle
		origin: self origin - self barLength asPoint
		corner: self origin + self barLength asPoint) bounds! !

!ESCross methodsFor: 'displaying' stamp: 'AndreHora 3/15/2011 14:59'!
displayFilledOn: aGraphicsContext
	
	self displayStrokedOn: aGraphicsContext! !

!ESCross methodsFor: 'displaying' stamp: 'AndreHora 3/15/2011 14:59'!
displayStrokedOn: aGraphicsContext
	
	(LineSegment
		from: self origin - (0 @ self barLength)
		to: self origin + (0 @ self barLength)) displayStrokedOn:
			aGraphicsContext.
	(LineSegment
		from: self origin - (self barLength @ 0)
		to: self origin + (self barLength @ 0)) displayStrokedOn:
			aGraphicsContext! !

!ESCross methodsFor: 'initialize-release' stamp: 'AndreHora 4/1/2011 16:22'!
initialize
	
	self barLength: 2.! !

!ESCross methodsFor: 'accessing' stamp: 'AndreHora 3/15/2011 14:59'!
origin
	
	^origin! !

!ESCross methodsFor: 'accessing' stamp: 'AndreHora 3/15/2011 14:59'!
origin: anObject
	
	origin := anObject! !

!ESCross methodsFor: 'transforming' stamp: 'AndreHora 3/15/2011 14:59'!
scaledBy: amount
	
	^self copy barLength: (self barLength scaledBy: amount)! !

!ESCross methodsFor: 'transforming' stamp: 'AndreHora 6/5/2012 10:15'!
translatedBy: amount
	
	^self copy origin: (self origin translatedBy: amount)! !

!ESCross methodsFor: 'transforming' stamp: 'AndreHora 4/11/2011 22:50'!
translatedby: amount
	
	^self copy origin: (self origin translatedby: amount)! !

Object subclass: #ESDataObject
	instanceVariableNames: 'color selectionColor defaultColor menu model shape attributes announcer isSelected borderColor borderWidth'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EyeSee-Core'!

!ESDataObject class methodsFor: 'instance creation' stamp: 'AndreHora 4/1/2011 16:18'!
newWithShape: aGeometric
	"Answer a newly created and initialized instance."
	
	^self new 
		shape: aGeometric! !

!ESDataObject methodsFor: 'announce' stamp: 'AndreHora 4/13/2011 11:52'!
announcer
	"Answer the announcer of the receiver."
	
	^ announcer ifNil: [ announcer := ESAnnouncer new ]! !

!ESDataObject methodsFor: 'visualization protocol' stamp: 'TudorGirba 4/12/2011 15:23'!
atPoint: aPoint
	
	^ (self shape containsPoint: aPoint) 
		ifTrue: [self]
		ifFalse: [nil]! !

!ESDataObject methodsFor: 'visualization protocol' stamp: 'AndreHora 10/13/2011 16:17'!
atXValue: amount
	
	(self shape bounds origin x < amount
		and: [self shape bounds corner x > amount]) ifTrue: [^self].
	^ nil! !

!ESDataObject methodsFor: 'visualization protocol' stamp: 'AndreHora 10/13/2011 16:17'!
atXValue: amount tolerance: amount2
	
	(self shape bounds origin x - amount2 < amount
		and: [amount < (self shape bounds corner x + amount2)]) ifTrue: [^self].
	^ nil! !

!ESDataObject methodsFor: 'visualization protocol' stamp: 'AndreHora 10/13/2011 16:17'!
atYValue: amount
	
	(self shape bounds origin y < amount
		and: [self shape bounds corner y > amount]) ifTrue: [^self].
	^ nil! !

!ESDataObject methodsFor: 'attributes' stamp: 'AndreHora 4/13/2011 11:31'!
attributeAt: aSymbol

	^ self attributes at: aSymbol! !

!ESDataObject methodsFor: 'attributes' stamp: 'AndreHora 4/13/2011 11:31'!
attributeAt: aSymbol ifAbsent: aBlock

	^ self attributes at: aSymbol ifAbsent: aBlock! !

!ESDataObject methodsFor: 'attributes' stamp: 'AndreHora 4/13/2011 11:31'!
attributeAt: aSymbol ifAbsentPut: aBlock

	^ self attributes at: aSymbol ifAbsentPut: aBlock! !

!ESDataObject methodsFor: 'attributes' stamp: 'AndreHora 10/13/2011 16:17'!
attributeAt: aSymbol put: aValue

	^ self attributes at: aSymbol put: aValue! !

!ESDataObject methodsFor: 'attributes' stamp: 'AndreHora 10/13/2011 16:18'!
attributes

	^ attributes ifNil: [ attributes := IdentityDictionary new ]! !

!ESDataObject methodsFor: 'accessing' stamp: 'AndreHora 10/13/2011 16:18'!
attributes: anObject

	^ attributes := anObject! !

!ESDataObject methodsFor: 'accessing' stamp: 'AndreHora 4/27/2011 14:18'!
borderColor

	self isSelected
		ifTrue: [^ selectionColor ]
		ifFalse: [^ borderColor ]! !

!ESDataObject methodsFor: 'accessing' stamp: 'AndreHora 4/18/2011 20:53'!
borderColor: aColor

	borderColor := aColor! !

!ESDataObject methodsFor: 'accessing' stamp: 'AndreHora 7/23/2011 22:54'!
borderWidth
	
	"The border also indicates the selection. If my borderWidth is 0, when I am selected I must the 1."
	(isSelected and: [borderWidth = 0])
		ifTrue: [^ 1].
	^ borderWidth! !

!ESDataObject methodsFor: 'accessing' stamp: 'AndreHora 7/23/2011 22:34'!
borderWidth: aNumber

	borderWidth := aNumber! !

!ESDataObject methodsFor: 'accessing' stamp: 'AndreHora 10/13/2011 16:17'!
color
	
	^ defaultColor! !

!ESDataObject methodsFor: 'accessing' stamp: 'AndreHora 4/19/2011 11:04'!
color: aColor
	
	defaultColor := aColor! !

!ESDataObject methodsFor: 'bounds accessing' stamp: 'AndreHora 10/13/2011 16:17'!
computePreferredBounds
	
	^ self shape bounds! !

!ESDataObject methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
corner
	
	^self shape corner! !

!ESDataObject methodsFor: 'accessing' stamp: 'AndreHora 10/13/2011 16:17'!
defaultColor
	
	^ defaultColor! !

!ESDataObject methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
defaultColor: anObject
	
	defaultColor := anObject! !

!ESDataObject methodsFor: 'selecting' stamp: 'AndreHora 7/23/2011 22:39'!
deselect

	isSelected := false.! !

!ESDataObject methodsFor: 'displaying' stamp: 'AndreHora 2/11/2012 19:18'!
displayFilledOn: aGraphicsContext
	

	self shape displayFilledOn: (
		aGraphicsContext 
			paint: self color; 
			borderColor: self borderColor; 
			borderWidth: self borderWidth)! !

!ESDataObject methodsFor: 'displaying' stamp: 'AndreHora 4/18/2011 21:18'!
displayOn: aGraphicsContext
	
	self shape displayOn: (aGraphicsContext paint: self color)! !

!ESDataObject methodsFor: 'displaying' stamp: ' 11/3/11 16:41'!
displayStrokedOn: aGraphicsContext
	
	self shape displayStrokedOn: (aGraphicsContext paint: self color)! !

!ESDataObject methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
height
	
	^self shape height! !

!ESDataObject methodsFor: 'initialize-release' stamp: 'AndreHora 10/6/2011 17:32'!
initialize

	isSelected := false.
	
	self color: Color black.
	self borderColor: self color.
	self selectionColor: Color red.
	self borderWidth: 0! !

!ESDataObject methodsFor: 'testing' stamp: 'AndreHora 4/18/2011 17:21'!
isNotSelected

	^ self isSelected not! !

!ESDataObject methodsFor: 'selecting' stamp: 'AndreHora 4/18/2011 17:21'!
isSelected

	^ isSelected! !

!ESDataObject methodsFor: 'selecting' stamp: 'AndreHora 4/27/2011 14:13'!
isSelected: anObject

	isSelected := anObject! !

!ESDataObject methodsFor: 'metamodeling' stamp: ' 11/3/11 16:41'!
menu
	
	^menu! !

!ESDataObject methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
menu: anObject
	
	menu := anObject! !

!ESDataObject methodsFor: 'accessing' stamp: 'AndreHora 12/9/2011 20:20'!
model
	
	^ model! !

!ESDataObject methodsFor: 'accessing' stamp: 'AndreHora 12/9/2011 20:20'!
model: anObject
	
	model := anObject! !

!ESDataObject methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
moveBy: aPoint
	
	self shape: (self shape moveBy: aPoint)! !

!ESDataObject methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
origin
	
	^self shape origin! !

!ESDataObject methodsFor: 'printing' stamp: ' 11/3/11 16:41'!
printOn: aStream
	
	self model printOn: aStream! !

!ESDataObject methodsFor: 'event driven' stamp: ' 11/3/11 16:41'!
redButtonPressedEvent
	
	super redButtonPressedEvent! !

!ESDataObject methodsFor: 'accessing' stamp: 'AndreHora 3/13/2011 15:36'!
scaledBy: aPoint
	
	self shape: (self shape scaleBy: aPoint)! !

!ESDataObject methodsFor: 'selecting' stamp: 'AndreHora 7/23/2011 22:39'!
select

	isSelected := true.! !

!ESDataObject methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
selectionColor
	
	^selectionColor! !

!ESDataObject methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
selectionColor: anObject
	
	selectionColor := anObject! !

!ESDataObject methodsFor: 'accessing' stamp: 'AndreHora 3/13/2011 15:28'!
shape

	^ shape! !

!ESDataObject methodsFor: 'accessing' stamp: 'AndreHora 4/5/2011 14:03'!
shape: aShape

	shape := aShape value.
	"shape decorates: self"! !

!ESDataObject methodsFor: 'accessing' stamp: 'AndreHora 6/5/2012 10:15'!
translatedBy: aPoint
	
	self shape: (self shape translateBy: aPoint)! !

!ESDataObject methodsFor: 'accessing' stamp: 'TudorGirba 5/20/2011 13:53'!
width
	
	^self shape extent x! !

ESDataObject subclass: #ESTextDataObject
	instanceVariableNames: 'text position bold rotated textStyle alignment compositionWidth backgroundColor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EyeSee-Core'!

ESTextDataObject subclass: #ESTableCell
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EyeSee-Core'!

!ESTableCell methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
alignment
	
	^alignment! !

!ESTableCell methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
alignment: anObject
	
	alignment := anObject! !

!ESTableCell methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
handles
	" *** This method was defined by Mondrian.AbstractFigure as a subclass responsibility.
	Replace its body with a proper implementation. *** "
	
	self error: 'Subclass responsibility stub not reimplemented'! !

!ESTableCell methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
position
	
	alignment = #right
		ifTrue:
			[^self bounds origin + (self bounds width @ 0) - (self shape width @ 0)].
	alignment = #center
		ifTrue:
			[^self bounds origin + ((self bounds width / 2) @ 0)
				- ((self shape width / 2) @ 0)].
	^self bounds origin! !

!ESTableCell methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
zOrder
	" *** This method was defined by Mondrian.AbstractFigure as a subclass responsibility.
	Replace its body with a proper implementation. *** "
	
	self error: 'Subclass responsibility stub not reimplemented'! !

!ESTextDataObject methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
alignment
	
	^alignment! !

!ESTextDataObject methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
alignment: anObject
	
	alignment := anObject! !

!ESTextDataObject methodsFor: 'accessing' stamp: 'AndreHora 4/18/2011 15:37'!
atPoint: aPoint
	
	"TODO"
"	self position ifNotNil: [
		((self shape clippingRectangle translateBy: self position) containsPoint: aPoint)
				ifTrue: [^self]]."
	^nil! !

!ESTextDataObject methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
bold
	
	^bold! !

!ESTextDataObject methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
bold: anObject
	
	bold := anObject! !

!ESTextDataObject methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
compositionWidth
	
	^compositionWidth! !

!ESTextDataObject methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
compositionWidth: anObject
	
	compositionWidth := anObject! !

!ESTextDataObject methodsFor: 'displaying' stamp: 'AndreHora 6/6/2011 14:59'!
displayOn: aGraphicsContext
	
	(self rotated) 
		ifTrue: [
			aGraphicsContext 
				displayRotatedString: self shape text string
				at: self position 
				angle: 90. "todo"]
		ifFalse: [
			aGraphicsContext
				displayString: self shape text string
				at: self position]
		! !

!ESTextDataObject methodsFor: 'initialize-release' stamp: 'TudorGirba 5/20/2011 13:51'!
initialize
	"Initialize a newly created instance. This method must answer the receiver."
	
	super initialize.
	rotated := false.
	bold := false.
	textStyle := TextStyle default! !

!ESTextDataObject methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
position
	
	^position! !

!ESTextDataObject methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
position: anObject
	
	position := anObject! !

!ESTextDataObject methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
rotated
	
	^rotated! !

!ESTextDataObject methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
rotated: anObject
	
	rotated := anObject! !

!ESTextDataObject methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
setBold
	
	bold := true! !

!ESTextDataObject methodsFor: 'accessing' stamp: 'AndreHora 6/6/2011 14:58'!
shape																																													
																																																						 	| tempShape |																																																		
																																																						
	shape isNil
		ifTrue:
			[ tempShape := self text asString asTextMorph.
			"self compositionWidth
				ifNotNil: [tempShape compositionWidth: self compositionWidth]."
			alignment = #right ifTrue: [tempShape rightFlush].
			alignment = #center ifTrue: [tempShape centered].
"			self bold ifTrue: [tempShape text emphasizeAllWith: #bold].
"			"self rotated
				ifTrue:
					[tempShape := TextRotator rotateString: tempShape byQuadrants: -1]."
			^tempShape]
		ifFalse: [^shape]! !

!ESTextDataObject methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
text
	
	^text ifNil: [self model]! !

!ESTextDataObject methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
text: anObject
	
	text := anObject! !

!ESTextDataObject methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
textStyle
	
	^textStyle! !

!ESTextDataObject methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
textStyle: anObject
	
	textStyle := anObject! !

!ESTextDataObject methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
value
	
	^self model! !

Object subclass: #ESDiagramGraphicsContextWrapper
	instanceVariableNames: 'context translation scale transformFirst color borderColor borderWidth'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EyeSee-Core'!

!ESDiagramGraphicsContextWrapper class methodsFor: 'instance creation' stamp: 'AndreHora 4/1/2011 15:58'!
newWith: aGraphicsContext
	"Answer a newly created and initialized instance."
	
	^(self new)
		context: aGraphicsContext;
		scale: 1 @ 1;
		translation: 0 @ 0;
		yourself! !

!ESDiagramGraphicsContextWrapper class methodsFor: 'instance creation' stamp: 'AndreHora 4/1/2011 15:58'!
newWith: aGraphicsContext scale: aScalePoint translation: aPoint
	"Answer a newly created and initialized instance."
	
	^(self new)
		context: aGraphicsContext;
		scale: aScalePoint;
		translation: aPoint;
		yourself! !

!ESDiagramGraphicsContextWrapper methodsFor: 'accessing' stamp: 'AndreHora 4/18/2011 20:52'!
borderColor

	^ borderColor! !

!ESDiagramGraphicsContextWrapper methodsFor: 'accessing' stamp: 'AndreHora 4/18/2011 20:53'!
borderColor: aColor

	borderColor := aColor! !

!ESDiagramGraphicsContextWrapper methodsFor: 'accessing' stamp: 'AndreHora 7/23/2011 22:27'!
borderWidth

	^ borderWidth! !

!ESDiagramGraphicsContextWrapper methodsFor: 'accessing' stamp: 'AndreHora 7/23/2011 22:17'!
borderWidth: aNumber

	borderWidth := aNumber! !

!ESDiagramGraphicsContextWrapper methodsFor: 'accessing' stamp: 'AndreHora 3/16/2011 18:20'!
boundingBox
	
	"^self context clippingBounds translatedBy: self translation negated"
	^self context clipRect translateBy: self translation negated! !

!ESDiagramGraphicsContextWrapper methodsFor: 'accessing' stamp: 'AndreHora 4/11/2011 22:50'!
clippingBounds
	
	^self context clippingBounds translatedby: self translation negated! !

!ESDiagramGraphicsContextWrapper methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
clippingBounds: aRectangle
	
	self context clippingBounds: aRectangle! !

!ESDiagramGraphicsContextWrapper methodsFor: 'accessing' stamp: 'AndreHora 3/21/2011 14:37'!
color
	
	^ color! !

!ESDiagramGraphicsContextWrapper methodsFor: 'accessing' stamp: 'AndreHora 3/21/2011 14:37'!
color: aColor

	color := aColor! !

!ESDiagramGraphicsContextWrapper methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
context
	
	^context! !

!ESDiagramGraphicsContextWrapper methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
context: anObject
	
	context := anObject! !

!ESDiagramGraphicsContextWrapper methodsFor: 'copying' stamp: ' 11/3/11 16:41'!
copy
	
	| aCopy |
	aCopy := super copy.
	^aCopy context: self context copy! !

!ESDiagramGraphicsContextWrapper methodsFor: 'displaying' stamp: 'AndreHora 12/4/2011 18:58'!
displayArcBBoxOrigin: aPoint extent: aPoint2 startAngle: amount sweepAngle: amount2

	| newRect |
	newRect := Rectangle origin: aPoint extent: aPoint2.
	self displayOval: newRect  ! !

!ESDiagramGraphicsContextWrapper methodsFor: 'displaying' stamp: 'AndreHora 4/13/2011 01:11'!
displayLineFrom: aPoint1 to: aPoint2
						
	self context 
		line: (self transform: aPoint1) 
		to: (self transform: aPoint2) 
		width: 1 
		color: self color.! !

!ESDiagramGraphicsContextWrapper methodsFor: 'displaying' stamp: ' 11/3/11 16:41'!
displayMappedString: concreteString from: startIndex to: endIndex at: aPoint withMap: aMap
	
	self context
		displayMappedString: concreteString
		from: startIndex
		to: endIndex
		at: (self transform: aPoint)
		withMap: aMap! !

!ESDiagramGraphicsContextWrapper methodsFor: 'displaying' stamp: 'AndreHora 7/23/2011 23:02'!
displayOval: aRectangle
	
	| transformedRectangleMod transformedRectangle |
	
	transformedRectangle := (self transform: aRectangle).
	transformedRectangle := self transformRectangleOriginCorner: transformedRectangle. 
	
	self context 
		fillOval: transformedRectangle
		color: self color
		borderWidth: self borderWidth
		borderColor: Color transparent! !

!ESDiagramGraphicsContextWrapper methodsFor: 'displaying' stamp: ' 11/3/11 16:41'!
displayPixelArray: aPixelArray at: aPoint
	
	self context
		displayPixelArray: aPixelArray
		at: (self transform: aPoint)! !

!ESDiagramGraphicsContextWrapper methodsFor: 'displaying' stamp: 'AndreHora 10/6/2011 23:41'!
displayPolygon: aVerticesCollection
	
	self context	
		drawPolygon: (aVerticesCollection collect: [:each | self transform: each]) 
		color: self color 
		borderWidth: self borderWidth
		borderColor: self borderColor! !

!ESDiagramGraphicsContextWrapper methodsFor: 'displaying' stamp: 'AndreHora 12/4/2011 18:57'!
displayPolyline: vertices at: aPoint
		
	| initialVertex |
	
	initialVertex := vertices first.
	
	vertices do: [ :each |
		((each = vertices first) not)
			ifTrue: [self displayLineFrom: initialVertex to: each].
		initialVertex := each ]! !

!ESDiagramGraphicsContextWrapper methodsFor: 'displaying' stamp: 'AndreHora 9/23/2011 20:34'!
displayRectangle: aRectangle
	
	| transformedRectangle |
	
	transformedRectangle := self transform: aRectangle.
	transformedRectangle := self transformRectangleOriginCorner: transformedRectangle.

	self context 
		frameAndFillRectangle: transformedRectangle
		fillColor: self color
		borderWidth: self borderWidth
		borderColor: self borderColor.
	
	self context changed.! !

!ESDiagramGraphicsContextWrapper methodsFor: 'displaying' stamp: 'AndreHora 7/23/2011 23:03'!
displayRectangularBorder: aRectangle

	| transformedRectangleMod transformedRectangle |
	
	transformedRectangle := self transform: aRectangle.
	transformedRectangle := self transformRectangleOriginCorner: transformedRectangle.
	
	self context 
		frameAndFillRectangle: transformedRectangle
		fillColor: Color transparent 
		borderWidth: self borderWidth
		borderColor: self color! !

!ESDiagramGraphicsContextWrapper methodsFor: 'displaying' stamp: 'AndreHora 10/6/2011 11:32'!
displayRotatedString: aString at: aPoint angle: aDegree
	
	| stringMorph transformationMorph |
	
	stringMorph := aString asStringMorph.
	transformationMorph := TransformationMorph new asFlexOf: stringMorph.
	transformationMorph angle: aDegree degreesToRadians.
	transformationMorph position: (self transform: aPoint).

	self context
		fullDraw: transformationMorph.! !

!ESDiagramGraphicsContextWrapper methodsFor: 'displaying' stamp: 'AndreHora 6/19/2011 17:54'!
displayString: aString at: aPoint

	self context
		drawString: aString
		at: (self transform: aPoint).
	
	self context changed.! !

!ESDiagramGraphicsContextWrapper methodsFor: 'displaying' stamp: 'AndreHora 12/4/2011 18:57'!
displayWedgeBBoxOrigin: aPoint extent: aPoint2 startAngle: amount sweepAngle: amount2
	
	| newRect |
	newRect := Rectangle origin: aPoint extent: aPoint2.
	self displayRectangle: newRect  ! !

!ESDiagramGraphicsContextWrapper methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
findFont: aFontDescription
	
	^self context findFont: aFontDescription! !

!ESDiagramGraphicsContextWrapper methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
font
	
	^self context font! !

!ESDiagramGraphicsContextWrapper methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
font: aFont
	
	^self context font: aFont! !

!ESDiagramGraphicsContextWrapper methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
fontPolicy
	
	^self context fontPolicy! !

!ESDiagramGraphicsContextWrapper methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
fontPolicy: aFontPolicy
	
	^self context fontPolicy: aFontPolicy! !

!ESDiagramGraphicsContextWrapper methodsFor: 'initialize-release' stamp: 'AndreHora 7/23/2011 22:16'!
initialize
	"Initialize a newly created instance. This method must answer the receiver."
	
	self scale: 1 @ 1.
	self translation: 0 @ 0.
	self color: Color black.
	self borderColor: self color.
	self borderWidth: 0.! !

!ESDiagramGraphicsContextWrapper methodsFor: 'private' stamp: 'AndreHora 6/6/2012 16:07'!
inverseTransform: aPoint
	
	^ (aPoint translatedby: self translation negated) scaledBy: 1 / self scale! !

!ESDiagramGraphicsContextWrapper methodsFor: 'accessing' stamp: 'AndreHora 3/24/2011 17:04'!
lineWidth
	
	^"self context lineWidth" "andre" 1! !

!ESDiagramGraphicsContextWrapper methodsFor: 'accessing' stamp: 'AndreHora 3/24/2011 17:04'!
lineWidth: width
	
	"self context lineWidth: width" "andre"! !

!ESDiagramGraphicsContextWrapper methodsFor: 'accessing' stamp: 'AndreHora 3/21/2011 14:38'!
paint: aColorValue
	
	"self context fillColor: aColorValue"
	self color: aColorValue! !

!ESDiagramGraphicsContextWrapper methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
paint: aColorValue alpha: anAlpha
	
	self context paint: aColorValue! !

!ESDiagramGraphicsContextWrapper methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
scale
	
	^scale! !

!ESDiagramGraphicsContextWrapper methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
scale: anObject
	
	scale := anObject! !

!ESDiagramGraphicsContextWrapper methodsFor: 'private' stamp: 'AndreHora 3/16/2011 14:11'!
transform: aPoint
	
	^((aPoint scaleBy: self scale) translateBy: self translation) rounded! !

!ESDiagramGraphicsContextWrapper methodsFor: 'private' stamp: 'AndreHora 4/6/2011 16:53'!
transformRectangleOriginCorner: aRectangle
	"To create a Rectangle in Pharo with the method Rectangle>>origin:corner:, you must provide the top left and the bottom right points."
	
	(aRectangle area = 0) 
		ifTrue: [ ^ Rectangle 
				origin: (aRectangle origin x @ aRectangle corner y) 
				corner: (aRectangle corner x @ aRectangle origin y)].
	^ aRectangle! !

!ESDiagramGraphicsContextWrapper methodsFor: 'accessing' stamp: 'AndreHora 4/11/2011 22:24'!
translateBy: aPoint
	
	self translation: (self translation translatedby: aPoint)! !

!ESDiagramGraphicsContextWrapper methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
translation
	
	^translation! !

!ESDiagramGraphicsContextWrapper methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
translation: anObject
	
	translation := anObject! !

!ESDiagramGraphicsContextWrapper methodsFor: 'evaluating' stamp: ' 11/3/11 16:41'!
widthOfString: aString
	
	^self context widthOfString: aString! !

Object subclass: #ESDiagramRenderer
	instanceVariableNames: 'diagram backgroundColor announcer canvas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EyeSee-Core'!

!ESDiagramRenderer methodsFor: 'announce' stamp: 'AndreHora 4/13/2011 12:02'!
announce: ann

	ann element announcer announce: ann! !

!ESDiagramRenderer methodsFor: 'announce' stamp: 'AndreHora 4/13/2011 15:10'!
announcer

	^ announcer ifNil: [ announcer := self defaultAnnouncer ]! !

!ESDiagramRenderer methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
atPoint: aPoint
	
	^diagram atPoint: aPoint! !

!ESDiagramRenderer methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
backgroundColor
	
	^backgroundColor! !

!ESDiagramRenderer methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
backgroundColor: anObject
	
	backgroundColor := anObject! !

!ESDiagramRenderer methodsFor: 'ui' stamp: 'AndreHora 1/11/2012 11:47'!
canvas

	^ canvas ifNil: [
	
		diagram setup.
		canvas := ESCanvas onDiagram: diagram.
		canvas updateBounds.
		self setElementSelectionHandler.
		canvas ]! !

!ESDiagramRenderer methodsFor: 'diagrams' stamp: 'TudorGirba 4/5/2011 22:35'!
compositeDiagram
	
	^diagram := ESCompositeDiagram new! !

!ESDiagramRenderer methodsFor: 'announce' stamp: 'AndreHora 4/18/2011 16:38'!
defaultAnnouncer

	^ ESAnnouncer new diagramRenderer: self! !

!ESDiagramRenderer methodsFor: 'diagrams' stamp: ' 11/3/11 16:41'!
defaultDisplayOn: gc
	
	| tempGC |
	tempGC := diagram gcWrapper copy context: gc.
	tempGC paint: self backgroundColor.
	diagram bounds displayFilledOn: tempGC.
	diagram displayOn: gc! !

!ESDiagramRenderer methodsFor: 'diagrams' stamp: 'TudorGirba 4/5/2011 22:35'!
deviationDiagram
	
	^diagram := ESDeviationDiagram new! !

!ESDiagramRenderer methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
diagram
	
	^diagram! !

!ESDiagramRenderer methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
diagram: anObject
	
	^diagram := anObject! !

!ESDiagramRenderer methodsFor: 'displaying' stamp: 'AndreHora 1/11/2012 11:46'!
displayOn: gc
	
	self defaultDisplayOn: gc! !

!ESDiagramRenderer methodsFor: 'diagrams' stamp: 'TudorGirba 4/5/2011 22:35'!
histo
	
	^diagram := ESHisto new! !

!ESDiagramRenderer methodsFor: 'diagrams' stamp: 'TudorGirba 4/5/2011 22:35'!
histogram
	
	^diagram := ESHistogram new! !

!ESDiagramRenderer methodsFor: 'diagrams' stamp: 'TudorGirba 4/5/2011 22:35'!
historyDiagram
	
	^diagram := ESHistoryDiagram new! !

!ESDiagramRenderer methodsFor: 'diagrams' stamp: 'TudorGirba 4/5/2011 22:35'!
horizontalBarDiagram
	
	^diagram := ESHorizontalBarDiagram new! !

!ESDiagramRenderer methodsFor: 'initialize-release' stamp: 'AndreHora 4/18/2011 22:05'!
initialize
	"Initialize a newly created instance. This method must answer the receiver."
	
	self backgroundColor: Color white.! !

!ESDiagramRenderer methodsFor: 'accessing' stamp: 'AndreHora 4/18/2011 22:07'!
interaction
	
	diagram announcer: self announcer.
	^ self announcer! !

!ESDiagramRenderer methodsFor: 'diagrams' stamp: 'AndreHora 2/9/2012 22:46'!
kiviat
	
	^ diagram := ESKiviat new! !

!ESDiagramRenderer methodsFor: 'diagrams' stamp: 'TudorGirba 4/5/2011 22:35'!
lineDiagram
	
	^diagram := ESLineDiagram new! !

!ESDiagramRenderer methodsFor: 'diagrams' stamp: 'TudorGirba 4/5/2011 22:35'!
matrix
	
	^diagram := ESMatrixDiagram new! !

!ESDiagramRenderer methodsFor: 'ui' stamp: 'AndreHora 1/11/2012 11:47'!
open
	
	| browser |
	
	diagram setup.
	browser := ESBrowser openOn: diagram.
	canvas := browser model canvas.
	self setElementSelectionHandler.
	
	^ browser! !

!ESDiagramRenderer methodsFor: 'diagrams' stamp: 'AndreHora 10/6/2011 17:30'!
pieDiagram
	
	^ diagram := ESPieDiagram new! !

!ESDiagramRenderer methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
preferedBounds
	
	^diagram preferedBounds! !

!ESDiagramRenderer methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
preferredBounds
	
	^diagram preferredBounds! !

!ESDiagramRenderer methodsFor: 'diagrams' stamp: 'TudorGirba 4/5/2011 22:35'!
rangeDiagram
	
	^diagram := ESRangeDiagram new! !

!ESDiagramRenderer methodsFor: 'diagrams' stamp: 'TudorGirba 4/5/2011 22:35'!
scatterplot
	
	^diagram := ESScatterPlot new! !

!ESDiagramRenderer methodsFor: 'events' stamp: 'AndreHora 6/19/2011 16:43'!
setElementSelectionHandler
	
	| updateBlock |

	updateBlock := [ :element :diag | 
		diag deselectAll.
		element select ].

	self announcer
		on: ESElementSelection do: [ :ann | 
			
			updateBlock value: ann element value: self diagram.
			ann diagramRenderer updateWindow ]! !

!ESDiagramRenderer methodsFor: 'diagrams' stamp: 'TudorGirba 4/5/2011 22:35'!
stackDiagram
	
	^diagram := ESStackDiagram new! !

!ESDiagramRenderer methodsFor: 'diagrams' stamp: 'TudorGirba 4/5/2011 22:35'!
table
	
	^diagram := ESTable new! !

!ESDiagramRenderer methodsFor: 'events' stamp: 'AndreHora 4/13/2011 15:32'!
updateWindow
	"Refresh the content of the window"
	
	^ canvas owner changed! !

!ESDiagramRenderer methodsFor: 'diagrams' stamp: 'AndreHora 6/5/2012 10:33'!
verticalBarDiagram
	
	^ diagram := ESVerticalBarDiagram new! !

Object subclass: #ESLayerHolder
	instanceVariableNames: 'layers activeLayer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EyeSee-Core'!

!ESLayerHolder methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
activeLayer
	
	^activeLayer! !

!ESLayerHolder methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
addLayer: aLayer name: aString
	
	self layers add: (Association key: aString value: aLayer)! !

!ESLayerHolder methodsFor: 'initialize-release' stamp: 'AndreHora 4/1/2011 16:23'!
initialize
	"Initialize a newly created instance. This method must answer the receiver."
	
	self layers: Dictionary new.! !

!ESLayerHolder methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
layers
	
	^layers! !

!ESLayerHolder methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
layers: anObject
	
	layers := anObject! !

!ESLayerHolder methodsFor: 'changing' stamp: ' 11/3/11 16:41'!
scaleAllLayers: aPoint
	
	self
		layers: (self layers collect: [:each | each scale: each scale * aPoint])! !

!ESLayerHolder methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
setActiveLayer: aString
	
	^activeLayer := self layers
		at: aString
		ifAbsent: [nil]! !

Object subclass: #ESLegend
	instanceVariableNames: 'origin width height font colorBlock textBlock textColor sortBlock maxNumberOfEntries models elements container legendTextBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EyeSee-Core'!

ESLegend subclass: #ESHorizontalLegend
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EyeSee-Core'!

!ESHorizontalLegend methodsFor: 'creating' stamp: 'AndreHora 4/1/2012 20:14'!
legendElementOffset: legendElement

	^ legendElement width @ 0! !

!ESHorizontalLegend methodsFor: 'creating' stamp: 'AndreHora 4/1/2012 21:11'!
setPositions
	
	| startPoint offsetPoint gap |
	
	startPoint := self origin.
	gap := ((self width - (self elements sum: #width)) / 
		(self elements size)) rounded.
	offsetPoint := gap @ 0.
	self setPositions: startPoint offset: offsetPoint! !

!ESLegend methodsFor: 'bounds accessing' stamp: 'AndreHora 3/18/2011 16:16'!
bounds
	
	^Rectangle
		origin: origin
		extent: width @ height! !

!ESLegend methodsFor: 'accessing' stamp: 'AndreHora 3/18/2011 16:16'!
colorBlock
	
	^colorBlock! !

!ESLegend methodsFor: 'accessing' stamp: 'AndreHora 3/18/2011 16:16'!
colorBlock: anObject
	
	colorBlock := anObject! !

!ESLegend methodsFor: 'accessing' stamp: 'AndreHora 3/18/2011 16:24'!
container
	^ container! !

!ESLegend methodsFor: 'accessing' stamp: 'AndreHora 3/18/2011 16:23'!
container: aContainer
	container := aContainer! !

!ESLegend methodsFor: 'creating' stamp: 'usmanbhatti 6/5/2012 17:26'!
createElements
	
	| dataObject sortedModels |
	
	sortedModels := self models.
	elements := (sortedModels
		copyFrom: 1
		to: self numberOfEntries)
		collect:
			[:each | 
			|element|
			element := self textBlock value: each.
			dataObject := (ESDataObject new)
				model: each key;
				color: Color darkGray;
				shape:
						((ESLegendElement new)
								color: each value;
								container: self;
								text:  (self legendTextBlock value: element ) asString asTextMorph).
			dataObject].
	self models size > self numberOfEntries
		ifTrue:
			[elements
				add:
					(self
						getOthersLegendElement:
							(sortedModels
								sliceFrom: self numberOfEntries + 1
								to: sortedModels size))].
	self setPositions! !

!ESLegend methodsFor: 'displaying' stamp: 'AndreHora 6/6/2012 17:57'!
displayOn: gc
	
	self elements
		do: [ :each | each displayOn: gc]! !

!ESLegend methodsFor: 'accessing' stamp: 'AndreHora 3/18/2011 16:16'!
elements
	
	^elements! !

!ESLegend methodsFor: 'accessing' stamp: 'AndreHora 3/18/2011 16:16'!
elements: anObject
	
	elements := anObject! !

!ESLegend methodsFor: 'accessing' stamp: 'AndreHora 3/18/2011 16:16'!
font
	
	^font! !

!ESLegend methodsFor: 'accessing' stamp: 'AndreHora 3/18/2011 16:16'!
font: anObject
	
	font := anObject! !

!ESLegend methodsFor: 'creating' stamp: 'TudorGirba 4/5/2011 22:35'!
getOthersLegendElement: aCollection
	
	| dataObject |
	dataObject := (ESDataObject new)
		color: Color darkGray;
		shape:
				((ESLegendElement new)
						color: Color lightGray;
						container: self;
						text:
								((ComposedText withText: 'others')
										textStyle: self container getDefaultTextStyle)).
	dataObject eventHandler
		onMouseEnter:
			[:object | 
			Popup
				showString:
					(aCollection
						inject: ''
						into:
							[:string :each | string , (self textBlock value: each) , Character cr asSymbol])].
	^dataObject! !

!ESLegend methodsFor: 'accessing' stamp: 'AndreHora 3/18/2011 16:16'!
height
	
	^height! !

!ESLegend methodsFor: 'accessing' stamp: 'AndreHora 3/18/2011 16:16'!
height: anObject
	
	^height := anObject! !

!ESLegend methodsFor: 'initialize-release' stamp: 'usmanbhatti 6/5/2012 17:26'!
initialize
	
	self width: 150.
	self height: 30.
	textBlock := #key.
	legendTextBlock := #yourself.
	colorBlock := #value.
	textColor := Color black.
	sortBlock := [ :each1 :each2 | each1 < each2]! !

!ESLegend methodsFor: 'creating' stamp: 'AndreHora 4/1/2012 18:13'!
legendElementOffset: legendElement

	self subclassResponsibility! !

!ESLegend methodsFor: 'accessing' stamp: 'usmanbhatti 6/5/2012 17:23'!
legendTextBlock
	^ legendTextBlock! !

!ESLegend methodsFor: 'accessing' stamp: 'usmanbhatti 6/5/2012 17:22'!
legendTextBlock: aBlock
	legendTextBlock := aBlock.! !

!ESLegend methodsFor: 'accessing' stamp: 'AndreHora 3/18/2011 16:16'!
maxNumberOfEntries
	
	^maxNumberOfEntries! !

!ESLegend methodsFor: 'accessing' stamp: 'AndreHora 3/18/2011 16:16'!
maxNumberOfEntries: anObject
	
	maxNumberOfEntries := anObject! !

!ESLegend methodsFor: 'accessing' stamp: 'AndreHora 4/1/2012 19:21'!
miniRectSize
	
	^ 10 @ 10! !

!ESLegend methodsFor: 'accessing' stamp: 'AndreHora 3/18/2011 16:16'!
models
	
	^models! !

!ESLegend methodsFor: 'accessing' stamp: 'AndreHora 3/18/2011 16:16'!
models: anObject
	
	models := anObject.
	self createElements! !

!ESLegend methodsFor: 'accessing' stamp: 'AndreHora 3/18/2011 16:16'!
numberOfEntries
	
	maxNumberOfEntries isNil
		ifTrue: [^self models size]
		ifFalse: [^maxNumberOfEntries min: self models size]! !

!ESLegend methodsFor: 'accessing' stamp: 'AndreHora 3/18/2011 16:16'!
origin
	
	^origin! !

!ESLegend methodsFor: 'accessing' stamp: 'AndreHora 3/18/2011 16:16'!
origin: anObject
	
	origin := anObject! !

!ESLegend methodsFor: 'creating' stamp: 'AndreHora 3/18/2011 16:16'!
setPositions
	
	self subclassResponsibility! !

!ESLegend methodsFor: 'creating' stamp: 'AndreHora 4/1/2012 20:05'!
setPositions: startPoint offset: offsetPoint
	
	| currPos |
	currPos := startPoint.
	elements do: [ :each | 
		each shape position: currPos.
		currPos := currPos translatedby: offsetPoint + (self legendElementOffset: each)]! !

!ESLegend methodsFor: 'accessing' stamp: 'AndreHora 3/18/2011 16:16'!
sortBlock
	
	^sortBlock! !

!ESLegend methodsFor: 'accessing' stamp: 'AndreHora 3/18/2011 16:16'!
sortBlock: anObject
	
	sortBlock := anObject! !

!ESLegend methodsFor: 'accessing' stamp: 'AndreHora 3/18/2011 16:16'!
textBlock
	
	^textBlock! !

!ESLegend methodsFor: 'accessing' stamp: 'AndreHora 3/18/2011 16:16'!
textBlock: anObject
	
	textBlock := anObject! !

!ESLegend methodsFor: 'accessing' stamp: 'AndreHora 3/18/2011 16:16'!
textColor
	
	^textColor! !

!ESLegend methodsFor: 'accessing' stamp: 'AndreHora 3/18/2011 16:16'!
textColor: anObject
	
	textColor := anObject! !

!ESLegend methodsFor: 'accessing' stamp: 'AndreHora 4/1/2012 21:10'!
width
	
	^ width! !

!ESLegend methodsFor: 'accessing' stamp: 'AndreHora 3/18/2011 16:16'!
width: anObject
	
	width := anObject! !

ESLegend subclass: #ESVerticalLegend
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EyeSee-Core'!

!ESVerticalLegend methodsFor: 'creating' stamp: 'AndreHora 4/1/2012 18:13'!
legendElementOffset: legendElement

	^ 0 @ 0! !

!ESVerticalLegend methodsFor: 'creating' stamp: 'AndreHora 4/1/2012 21:06'!
setPositions
	
	| startPoint offsetPoint |

	startPoint := self origin.
	offsetPoint := 0 @ (self height / self elements size).
	self setPositions: startPoint offset: offsetPoint! !

Object subclass: #ESLegendElement
	instanceVariableNames: 'color text position gap container'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EyeSee-Core'!

!ESLegendElement methodsFor: 'private' stamp: 'AndreHora 4/1/2012 20:26'!
boundingRectangle
	
	^ self text compositionRectangle
		expandRectangle:
			(Rectangle
				origin: 0 asPoint
				extent: self container miniRectSize + (gap @ 0))! !

!ESLegendElement methodsFor: 'accessing' stamp: 'AndreHora 4/1/2012 20:26'!
bounds
	
	^ self boundingRectangle translatedby: self position! !

!ESLegendElement methodsFor: 'accessing' stamp: 'AndreHora 4/1/2012 20:26'!
color
	
	^ color! !

!ESLegendElement methodsFor: 'accessing' stamp: 'AndreHora 3/18/2011 16:41'!
color: anObject
	
	color := anObject! !

!ESLegendElement methodsFor: 'accessing' stamp: 'AndreHora 4/1/2012 20:26'!
container

	^ container! !

!ESLegendElement methodsFor: 'accessing' stamp: 'AndreHora 4/1/2012 20:26'!
container: aContainer

	container := aContainer! !

!ESLegendElement methodsFor: 'displaying' stamp: 'AndreHora 6/6/2011 13:25'!
displayOn: aGraphicsContext
	
	| miniRect |
							
	aGraphicsContext
		displayString: self text asText asString
		at: self textPosition.

	miniRect := Rectangle
		origin:
			(self position
				translatedby: 0 @ (self container miniRectSize x / 2 negated))
		extent: self container miniRectSize.
	miniRect displayFilledOn: (aGraphicsContext paint: self color )! !

!ESLegendElement methodsFor: 'accessing' stamp: 'AndreHora 4/1/2012 20:26'!
extent
	
	^ self boundingRectangle extent! !

!ESLegendElement methodsFor: 'initialize-release' stamp: 'AndreHora 4/1/2012 20:27'!
initialize

	"size between square and label"
	gap := 5! !

!ESLegendElement methodsFor: 'accessing' stamp: 'AndreHora 4/1/2012 20:26'!
position
	
	^ position! !

!ESLegendElement methodsFor: 'accessing' stamp: 'AndreHora 3/18/2011 16:41'!
position: anObject
	
	position := anObject! !

!ESLegendElement methodsFor: 'accessing' stamp: 'AndreHora 4/1/2012 20:26'!
text
	
	^ text! !

!ESLegendElement methodsFor: 'accessing' stamp: 'AndreHora 3/18/2011 16:41'!
text: anObject
	
	text := anObject! !

!ESLegendElement methodsFor: 'accessing' stamp: 'AndreHora 4/1/2012 20:26'!
textPosition

	^ self position
		translatedby:
			(self container miniRectSize x + gap) @ (self text height / 2) negated! !

!ESLegendElement methodsFor: 'accessing' stamp: 'AndreHora 4/1/2012 20:26'!
width
	
	^ self boundingRectangle width! !

Object subclass: #ESPopup
	instanceVariableNames: ''
	classVariableNames: 'TooltipBalloon'
	poolDictionaries: ''
	category: 'EyeSee-Core'!

!ESPopup class methodsFor: 'actions' stamp: 'AndreHora 4/18/2011 11:32'!
remove
	TooltipBalloon ifNotNil: [ TooltipBalloon delete ].
	ESPopupViewCanvas allInstances do: [:canv| canv delete].! !

!ESPopup class methodsFor: 'accessing' stamp: 'AndreHora 4/18/2011 11:32'!
show: msgString

	self remove.
	TooltipBalloon := (UITheme builder newBalloonHelp: msgString for: World activeHand)
		popUpFor: (Morph new) hand:  World activeHand.

	^ TooltipBalloon! !

Object variableSubclass: #ESShape
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EyeSee-Core'!

!ESShape class methodsFor: 'shapes' stamp: 'AndreHora 3/21/2011 15:36'!
circle
	
	^[:center :rad | Circle new center: center radius: rad]! !

!ESShape class methodsFor: 'shapes' stamp: 'TudorGirba 4/5/2011 22:35'!
cross
	
	^[:origin :length | ESCross origin: origin barLength: length]! !

!ESShape class methodsFor: 'shapes' stamp: 'AndreHora 3/25/2011 15:23'!
rectangle
	
	^[:origin :corner | 
	| rect |
	rect := Rectangle
		origin: origin
		extent: corner asPoint * 2.	"move center of square to the right point"
	rect translateBy: rect width asPoint negated / 2.0]! !

!ESShape class methodsFor: 'shapes' stamp: ' 11/3/11 16:41'!
shapes
	
	^(OrderedCollection new)
		add: self circle;
		add: self cross;
		add: self rectangle;
		yourself! !

Object subclass: #ESTextLabel
	instanceVariableNames: 'origin textColor text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EyeSee-Core'!

!ESTextLabel methodsFor: 'displaying' stamp: 'AndreHora 6/3/2011 12:46'!
displayOn: aGraphicsContext

	(aGraphicsContext paint: self textColor)
		displayString: self text
		at: self origin! !

!ESTextLabel methodsFor: 'initialize-release' stamp: ' 11/3/11 16:41'!
initialize
	
	self textColor: Color black! !

!ESTextLabel methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
origin
	
	^origin! !

!ESTextLabel methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
origin: anObject
	
	origin := anObject! !

!ESTextLabel methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
text
	
	^text! !

!ESTextLabel methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
text: anObject
	
	text := anObject! !

!ESTextLabel methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
textColor
	
	^textColor! !

!ESTextLabel methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
textColor: anObject
	
	textColor := anObject! !
